--- Remove and reclaim previous version?
IFDEF *BREAKOUT*
bk org
FORGET *BREAKOUT*
}
TAQOZ
pub *BREAKOUT*		PRINT" BREAKOUT FOR THE P2 - 190606" ;

0 bytes bk	--- dummy variable to mark start of data

ALIAS +-! NEGATE!	--- rename for readability

--- save and restore VGA parameters - mainly for debugging via the console
pub <VGA		EMIT@ >L row @ >L col @ >L PEN@ >L PAPER@ >L VGA ;
pub VGA>		L> PAPER L> PEN L> col ! L> row ! L> EMIT! ;

--- Read the color of the pixel at XY
pub XY@ ( x y -- color )		cols * + SCR + C@ ;



	*** SOUNDS ***

2 longs duration		--- duration timer
--- hitting a wall sound
pri BONK	300 50
pri SOUND	ROUT PIN duration TIMEOUT HZ ;
pub BANG	700 80 SOUND ;

	*** BORDER ***

pub BORDER
	<VGA
---	outside frame
	white PEN 0 x 0 y cols w rows h RECT
---	top score line
	0 x 11 y cols 1- w HLINE
---	bottom line (for optional terminal window )
	rows 64 - y  HLINE
---	fill in score are
	0 x 0 y cols w 12 h white PEN PANEL
---	TITLE
	cols 2/ 70 - 2 VXY white PAPER blue PEN PRINT"  TAQOZ P2 BREAKOUT "
	VGA>
	;



	*** WALL ***


( CONSTANTS )

pri backwall 60 ;	--- gap behind walls
pri mortar	2 ;
pri #bricks 20 ;	--- number of brick columns
pri brickh	14 ;	--- height of brick
pri #walls 	4 ;
pri #total	#bricks #walls * ;

--- width of brick
pub brickw ( -- width )
    cols #bricks / mortar -
    ;

--- add in mortar to width or height
pri +mortar ( w/h -- w/h+ )	mortar + ;

pub BRICKxy ( n -- x y )
	brickw +mortar * 0 cols UM// DROP SWAP
	1+ SWAP brickh +mortar * backwall +
	;

--- Bake a brick of a random color at position index n
pub BAKE ( n -- )
	RND >B 254 MIN 1 MAX SWAP
pub DRAWBRICK ( color n -- )
	BRICKxy y x brickw w brickh h
	<VGA PEN PANEL VGA>
	;

--- smash the brick (erase it)
pub SMASH ( n -- )
	0 SWAP DRAWBRICK
	;

--- indentify the index of the brick at xy
pub BRICK# ( x y -- index )
	SWAP brickw +mortar U/ ( x xindex )
	SWAP backwall - brickh +mortar U/ ( xindex yindex )
	#bricks * +
	;

--- is there at brick at this index?
pub BRICK? ( index -- color/flg )
	BRICKxy XY@
	;

--- Build the walls by baking and laying the brick
pub WALLS
	#total FOR I BAKE NEXT
	;


pri BRICKS? ( -- rem total )
	#total 0 OVER FOR I BRICK? IF 1+ THEN NEXT SWAP
	;


	*** PADDLE ***

20	:= pw	--- paddle width
3	:= ph	--- paddle height

word px		--- paddle position
word py

--- draw the paddle
pub PADDLE ( color -- )		px W@ x py W@ y pw w ph h <VGA PEN PANEL VGA> ;

--- is there a paddle in this position?
pub PADDLE? ( x y -- flg )	SWAP px W@ DUP pw + WITHIN SWAP py W@ = AND ;

--- PADDLE MOVEMENTS
pub <PADDLE
	px W@ IF 0 PADDLE -8 px W+! white PADDLE THEN
	;
pub PADDLE>
	px W@ cols 2 - < IF 0 PADDLE 8 px W+! white PADDLE THEN
	;


pri NEWPADDLE		rows 80 - py W! cols 2/ px W! white PADDLE ;






	*** BALL ***

4 := ballw


byte score
byte balls
word energy
word rem
word speed

2 longs speedtmr

--- velocity
long velx
long vely

--- ball position variables
long ballx
long bally

pri ballx@		        ballx @ ;
pri bally@		        bally @ ;

pri ballwh		        ' ballw 2+ C! ;

pri DRAWBALL            ballx@ x  bally@ y  ballw w ballw h PANEL ;
pub HIDEBALL		    black PEN DRAWBALL ;
pub SHOWBALL
    energy W@ 50 > IF red ELSE green THEN
    PEN energy W@ IF energy W-- THEN
    DRAWBALL
    ;
---	 and update new position (but still hidden)
pri MOVEBALL	        velx @ ballx +!	vely @ bally +! ;

pri NEWBALL
	HIDEBALL
---	reset ball position in center
	cols 2/  ballx ! rows 2/  bally !
---	reset ball speed and direction
	5 speed W!  1 vely ! 1 velx !
---	delay serving 1st ball for 1.5secs
	1500 speedtmr TIMEOUT
	SHOWBALL
--- and make some sounds before serving
	3 FOR BONK 50 ms MUTE 450 ms NEXT
	;

pri BALLTIMER? ( -- rdyflg )
	--- ready yet?
	speedtmr TIMEOUT? DUP 0EXIT
	--- yes, set next timeout period
	speed W@ speedtmr TIMEOUT
    ;

	*** SCORING ***


--- calculate how many bricks have been removed and display
pri .SCORE
	BRICKS? DUP rem W! SWAP - score C!
	<VGA blue PEN white PAPER 586 2 VXY
	score C@ .AS"  ###/"  rem W@ .AS" ### "
	2 2 VXY balls C@ .AS"  # balls "
	VGA>
	;

pri ?PADDLE
	ballx@ bally@ ballw + 1+  PADDLE? IF 500 energy W! THEN
	;

pri LEFT?	velx @ 0< ;
pri UP?		vely @ 0< ;

pri HIT? ( -- colorflg )
--- check color at ball position
	ballx@ 1+ bally@ 1- XY@  DUP white =
--- just bounce off the white border
	IF BONK
--- exit if black (not solid)
	ELSE DUP 0EXIT
--- must be a brick, retrieve the brick index
      ballx@ bally@ BRICK#
--- smash&bang  track score
      SMASH BANG  .SCORE
    THEN
	;

pri ?HORZ
---	determine horizontal direction of rebound based on current direction
	LEFT? IF ballx@ 1- ELSE ballx@ ballw + 1+ THEN ( ballx )
--- and ball y  fetch pixel if hit something - reverse ball x velocity
    bally@ 1+   XY@         IF BONK velx NEGATE! THEN
    ;
pri ?VERT
--- UP? if use top of ball    else down uses bottom of ball xy
	UP? IF ballx@ 1+ bally@ 1- ELSE ballx@ 1+ bally@ ballw + 1+ THEN
--- if it has hit something then reverse vertical direction
    XY@ IF BONK vely NEGATE! THEN
    ;
pri ?BRICK
---	only smash a brick if the top center of the ball hits it
	HIT? IF vely +-! THEN
    ;
--- change the direction if the ball has hit something
pri ?BOUNCE
	?PADDLE
    ?BRICK ?HORZ  ?VERT
    ;

--- Check if ball is ready for next movement and proceed
pub ?BALL    BALLTIMER? IF HIDEBALL MOVEBALL ?BOUNCE SHOWBALL THEN ;



	*** GAME CONTROLS ***

pri ALERTBOX
	290 x 240 y 60 w 16 h <VGA PEN PANEL VGA>
	;
pub GAMEOVER
	" GAME OVER"
pri ALERT ( str -- )
	white ALERTBOX
--- display alert text in box
	red PEN white PAPER 295 244 VXY VGA PRINT$
--- mute audio and stop playback & ?       exit ot console
	ROUT PIN MUTE 1 COGSTOP     2 COGSTOP CON CONSOLE
	;

pub NEWGAME
	black PAPER CLRSCR
---	play audio track but not on right channel
	" BREAKOUT" PLAY$ rch C~
	NEWPADDLE WALLS BORDER
---	reset balls and score
	3 balls C! score C~
	.SCORE	NEWBALL
	;

--- faster ball -- less delay but clamp
pri FASTER		speed W@ IF speed W-- THEN ;
--- slower ball -- more delay
pri SLOWER		speed W++ ;

--- general game flags
byte boflgs


--- game control keys ---
pub GAMEKEY ( ch -- )
	?DUP 0EXIT ( ignore if null )
    a>A SWITCH
	'Z' CASE <PADDLE BREAK --- paddle left
	'X' CASE PADDLE> BREAK --- paddle right
	'+' CASE FASTER BREAK --- faster ball
	'=' CASE 5 speed W! BREAK --- reset ball speed
	'-' CASE SLOWER BREAK
	'_' CASE 100 speed W! BREAK --- real slow
	' ' CASE MUTE WKEY $1B = IF CON CONSOLE THEN  BREAK
	'B' CASE NEWBALL BREAK
	'W' CASE WALLS BREAK
	'<' CASE HIDEBALL ballw 1- 2 MAX ballwh BREAK --- smaller
	'>' CASE HIDEBALL ballw 1+ ballwh BREAK --- bigger ball
	'N'  CASE NEWGAME BREAK
	^[  CASE " CONSOLE" ALERT ROUT PIN MUTE BREAK
	    CASE@ '0' '9' WITHIN IF CASE@ boflgs C! THEN
	;


pri btns	20 ; --- first pin of CONTROL buttons
byte btn
2 longs btntmr

pub BUTTONS
	btntmr TIMEOUT?	0EXIT	40 btntmr TIMEOUT
	btns 4 PINS 15K PULLDOWN SETPIN
	0 4 FOR btns I+ PIN@ IF " WZNX" I+ C@ OR THEN NEXT
	btn C@ OR btn C~
	;


pub ACTION
	--- make it speed up proportionaly to the score (disabled)
\	130 score C@ - 3 / speed W!
--- only use serial keyboard if this is the console cog
\	COGID 0= IF KEY ELSE BUTTONS THEN GAMEKEY
	BUTTONS GAMEKEY
---
	duration TIMEOUT? IF ROUT PIN MUTE THEN
	?BALL
---	debug, slow ball down when approaching wall
	1 boflgs SET? IF bally@ 130 < IF 50 ms THEN THEN
---	testing: autostart a new game
	score C@ #total = IF NEWGAME THEN
	;

pub BREAKOUT
	8 BPP 360p !VGA
	boflgs C~
	NEWGAME
pub CONTINUE
	0 ALERTBOX
	6 TERM
	BEGIN ACTION AGAIN
	;


\ pub GO	BREAKOUT ;

{
TO DO
FRACTIONAL BALL XY DIRECTION
BMP PLAYING FIELD
WAVE FILE SOUND EFFECTS

176 lines and 1,510 bytes compiled,  with 0 errors in 623ms  ok

}

END
