TAQOZ

( Si5351 Clock Generator )

IFDEF *CLKGEN*
FORGET *CLKGEN*
}
pub *CLKGEN*			PRINT" Si5351 Clock generator 190800-0000" ;

$C4	:= Si5351

pub CG! ( dat reg -- )		Si5351 I2CREG! ;
pub CG@				Si5351 I2CREG@ ;
--- assign clkgen as DUMP source
pub CG				' CG@ DUP DUP DUMP! ;
pub =CG	( dev -- )		' Si5351 :=! ;
pub .CG       0 $100 CG DUMP ;



\ /Set of Si5351A register addresses
3	:= CLK_ENABLE_CONTROL
15	:= PLLX_SRC
16	:= CLK0_CONTROL
17	:= CLK1_CONTROL
18	:= CLK2_CONTROL
26	:= SYNTH_PLL_A
34	:= SYNTH_PLL_B
42	:= SYNTH_MS_0
50	:= SYNTH_MS_1
58	:= SYNTH_MS_2
177	:= PLL_RESET
183	:= XTAL_LOAD_CAP


900 25 /	:= qa           --- Division factor 900/25 MHz
0		:= qb           --- Numerator, sets b/c=0
1048575		:= qc		--- Max. resolution, but irrelevant in this case (b=0)

\ byte _cgreg

pub CGREG!	0 CG! ' CGREG! C++ ;

pub CGREGS
\	_cgreg C!
	' CGREG! C!
	$FF CGREG! $FF CGREG!
	OVER $30000 AND 16>> CGREG!
	OVER 8>> CGREG!
	OVER CGREG!
	DUP 16>> >N $F0 OR CGREG!
	DUP 8>> CGREG!
	DUP CGREG!
	;


pub RDIV ( 7bit ch -- )	7 AND 3 << 44 + SWAP 7 AND 4 << SWAP CG! ;

--- Set PLLs (VCOs) to internal clock rate of 900 MHz
--- Equation fVCO = fXTAL * (a+b/c) (=> AN619 p. 3
pub !CG

\  unsigned long a, b, c;
\  unsigned long p1, p2, p3;

--- Init clock chip
	$D2 XTAL_LOAD_CAP CG!		--- Set crystal load capacitor to 10pF (default),
                                        --- for bits 5:0 see also AN619 p. 60
	0 CLK_ENABLE_CONTROL CG!	--- Enable all outputs
	$0F CLK0_CONTROL CG!		--- Set PLLA to CLK0, 8 mA output
	$2F CLK1_CONTROL CG!		--- Set PLLB to CLK1, 8 mA output
	$2F CLK2_CONTROL CG!		--- Set PLLB to CLK2, 8 mA output
	$A0 PLL_RESET CG!			--- Reset PLLA and PLLB

	qa 7 << qb 7 << qc / + 512 - ( p1 )
	qb 7 <<  qc qb 7 << qc / * - ( p2 )

	SYNTH_PLL_A CGREGS
	SYNTH_PLL_B CGREGS
	2DROP
	;

pub CGFREQ ( syn freq -- )
	25,000,000 qa UM* ROT UM// ( syn rm fdiv. )


	qa 7 << qb 7 << qc / + 512 - ( p1 )
	qb 7 <<   qc qb 7 << qc / * - ( p2 )


	SWAP CGREGS
	2DROP
	;

\ void si5351_set_freq(int synth, unsigned long freq)
{

  unsigned long  qa, b, c = 1048575;
  unsigned long f_xtal = 25000000;
  double fdiv = (double) (f_xtal * 36) / freq; //division factor fvco/freq (will be integer part of a+b/c)
  double rm; //remainder
  unsigned long p1, p2, p3;


  a = (unsigned long) fdiv;
  rm = fdiv - a;  //(equiv. b/c)
  b = rm * c;
  p1  = 128 * a + (unsigned long) (128 * b / c) - 512;
  p2 = 128 * b - c * (unsigned long) (128 * b / c);
  p3 = c;

}





{
  --- Set VCOs of PLLA and PLLB to 900 MHz

  --- Formula for splitting up the numbers to register data, see AN619

  p1 = 128 * a + (unsigned long) (128 * b / c) - 512;
  p2 = 128 * b - c * (unsigned long) (128 * b / c);
  p3  = c;

  ---Write data to registers PLLA and PLLB so that both VCOs are set to 900MHz intermal freq
  si5351_write(SYNTH_PLL_A, 0xFF);
  si5351_write(SYNTH_PLL_A + 1, 0xFF);
  si5351_write(SYNTH_PLL_A + 2, (p1 & 0x00030000) >> 16);
  si5351_write(SYNTH_PLL_A + 3, (p1 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_A + 4, (p1 & 0x000000FF));
  si5351_write(SYNTH_PLL_A + 5, 0xF0 | ((p2 & 0x000F0000) >> 16));
  si5351_write(SYNTH_PLL_A + 6, (p2 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_A + 7, (p2 & 0x000000FF));

  si5351_write(SYNTH_PLL_B, 0xFF);
  si5351_write(SYNTH_PLL_B + 1, 0xFF);
  si5351_write(SYNTH_PLL_B + 2, (p1 & 0x00030000) >> 16);
  si5351_write(SYNTH_PLL_B + 3, (p1 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_B + 4, (p1 & 0x000000FF));
  si5351_write(SYNTH_PLL_B + 5, 0xF0 | ((p2 & 0x000F0000) >> 16));
  si5351_write(SYNTH_PLL_B + 6, (p2 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_B + 7, (p2 & 0x000000FF));

}

: CG25
 $53 $0002 CG! $00 $0003 CG! $00 $000F CG!
 $8C $0010 CG! $0C $0011 CG! $8C $0012 CG! $8C $0013 CG!
 $8C $0014 CG! $8C $0015 CG! $8C $0016 CG! $8C $0017 CG!
 $00 $001A CG! $01 $001B CG! $00 $001C CG! $10 $001D CG!
 $00 $001E CG! $00 $001F CG! $00 $0020 CG! $00 $0021 CG!
 $00 $0032 CG! $01 $0033 CG! $00 $0034 CG! $10 $0035 CG!
 $00 $0036 CG! $00 $0037 CG! $00 $0038 CG! $00 $0039 CG!
 $00 $005A CG! $00 $005B CG! $00 $0095 CG! $00 $0096 CG!
 $00 $0097 CG! $00 $0098 CG! $00 $0099 CG! $00 $009A CG!
 $00 $009B CG! $00 $00A2 CG! $00 $00A3 CG! $00 $00A4 CG!
 $92 $00B7 CG!
;
{
0 TABLE CGTBL
---	 00    01    02    03    04    05    06    07    08    09    10    11    12    13    14    15
	$11 | $F9 | $53 | $00 | $00 | $FF | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $90 | $00 |
	$8C | $0C | $8C | $8C | $8C | $8C | $8C | $8C | $00 | $00 | $00 | $01 | $00 | $10 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $01 | $00 | $10 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
	$FF | $0C | $00 | $00 | $00 | $30 | $1E | $92 | $60 | $60 | $B8 | $02 |

: CG25	188 FOR I CGTBL + C@ I CG! NEXT ;

: CGLOAD ( tbl -- )	256 FOR DUP I + C@ I CG! NEXT ;
}

{
Si5351A-B02075-GT  Crystal Frequency: 27 MHz Internal Load Capacitance (CL): 10pF I2C Address = 0x6F
CLK0 = 24.576 MHz, Reference = Crystal
CLK1 = OFF
CLK2 = OFF

Si5351A-B04486-GT  Crystal Frequency (MHz): 25.000000000 Internal Load Capacitance (pF): 10 Default I2C address: 0x62
Output Clock Configuration:
CLK0 (MHz): 49.152000000 from PLLA
CLK1 (MHz): 24.000000000 from PLLB
CLK2 (MHz): 45.158400000 from PLLB

Si5351A-B-GT Standard part   Default I2C address: 0x60





TAQOZ# lsi2c --- I2C DEVICES
  $A4           RV-3028 RTC
  $DE           UNKNOWN DEVICE ok
TAQOZ# $DE =CG ---  ok
TAQOZ#  ---  ok
TAQOZ# 0 $20 CG DUMP ---
00000: 11 F9 43 00  00 FF 00 F0  00 00 00 00  00 00 90 00     '..C.............'
00010: 8C 0D 8C 8C  8C 8C 8C 8C  00 00 00 01  00 10 00 00     '................'
TAQOZ# lsi2c --- I2C DEVICES
  $A4           RV-3028 RTC
  $DE           UNKNOWN DEVICE ok
TAQOZ# 0 7 CG! ---  ok
TAQOZ#  ---  ok
TAQOZ# lsi2c --- I2C DEVICES
  $A4           RV-3028 RTC
  $C0           Si5351A CLOCK GEN ok
TAQOZ# 0 $20 CG DUMP ---
00000: FF FF FF FF  FF FF FF FF  FF FF FF FF  FF FF FF FF     '................'
00010: FF FF FF FF  FF FF FF FF  FF FF FF FF  FF FF FF FF     '................' ok
TAQOZ# $C0 =CG ---  ok
TAQOZ# 0 $20 CG DUMP ---
00000: 11 F9 43 00  00 FF 00 00  00 00 00 00  00 00 90 00     '..C.............'
00010: 8C 0D 8C 8C  8C 8C 8C 8C  00 00 00 01  00 10 00 00     '................' ok

Register 7:  The clock generator refers to this register as "I2C_ADDR_CTRL"
and clears the two most-significant bits.
AN619 lists this register as "Reserved".  What is Register 7 and does it need to be initialized?

Register 187:  Fanout Enable - The description of this register in AN619 is woefully inadequate.
 Is there a better description?
 The clock generator does not load it but I have seen other sample code set it to 0xC0 and,
 sometimes, 0xC2.  Does it need to be initialized and, if so, to what?

Register 205:  The clock generator refers to this register as "SLAB_FIXREGS_EN" and sets
the most-significant bit to 1 (0x80).
This is the only place I have seen this register referenced.
Again, what is this register and does it have to be initialized?
}


END
