\ AUTOBOOT TAQOZ ROM IN FLASH
\ TAQOZ ROM FORTH
\ eeee	1101 1	0	0	R	 A	A	AAAAAAAAA	AAAAAAAAA
\ JMP $FD02C

$FC16D43F

\ P2 RCFAST is around 25MHz - set 115200 baud
62 2 ADO I PIN L 25000000 115200 / 16 << 7 + WXPIN H LOOP


25000000 115200 / 16 << 7 + WXPIN

$00D9_0007 WXPIN

: FLASHER
--- Erase first 4k of Flash
    0 SFER4' TAB
--- Erase and use SD buffer area to build binary image
    SDBUF $400 ERASE
    SDBUF
\   eeee	11000	0	0	0	L	I	DDDDDDDDD	NNNNSSSSS
--- Set TXD and RXD modes
    $FC0CF83E OVER ! 4+ ( wrpin #$7C,#$3E)
    $FC0C7C3F OVER ! 4+ ( wrpin #$3E,#$3F)
--- Set baud rates based on 25MHz clock @115200 baud ( rate << 16 + 7 )
\    eeee	01100	0	0	C	Z	I	DDDDDDDDD	SSSSSSSSS
    $F60600D9 OVER ! 4+ ( mov $100,#$D9)
\    eeee	00000	1	1	C	Z	I	DDDDDDDDD	SSSSSSSSS
    $F0660010 OVER ! 4+ ( shl $100,#16)
\   eeee	00010	0	0	C	Z	I	DDDDDDDDD	SSSSSSSSS
    $F1060007 OVER ! 4+ ( add $100,#7)
--- set TXD and RXD baud rates
\   EEEE 1100000 1LI DDDDDDDDD SSSSSSSSSS
    $FC16003E OVER ! 4+  ( wxpin $100,#$3E)
    $FC16003F OVER ! 4+  ( wxpin $100,#$3F)
--- jump to the TAQOZ in ROM entry point
    $FD8FD02C OVER ! 4+ ( jmp #\$FD02C)
--- Calculate checksum for 1kB Flash
    " Prop" @ 0 SDBUF $400 ADO I @ + 4 +LOOP - SWAP !
--- Write 1kB to SPI Flash
    SDBUF 0 $400 SFWRS
;








: IMAGE
    $FC0CF83E ,    $FC0C7C3F ,    $F60600D9 ,    $F0660010 ,
    $F1060007 ,    $FC16003E ,    $FC16003F ,    $FD8FD02C ,
    $AB282C3A ,
: FLASHER
    SDBUF $400 ERASE
    ' IMAGE SDBUF 36 CMOVE
    0 SFER4   SDBUF 0 $400 SFWRS
    ;





word    _3,SFCMD,SPIWM,EXIT
SFRDS	word    ROT,SFRD,SPIRX,DROP,SPICE,EX

$FC164  := spi_cmd8
$FC168  := spi_cmd
$FC188   := spi_in

code BOOTER
--- copy TAQOZ image from Flash to RAM
        loc     PTRA,\#$E0000
        loc     PTRB,\#0

        mov     pa,#32
        mov     pb,#$0E0000_03
        call    #\spi_cmd
        decod   y,#17                   'ready to input 128kB from SPI
        wrfast  #0,#0                   'ready to write bytes to hub
.data   call    #\spi_in                 'get byte
        wfbyte  x
        djnz    y,#.data
        drvh    #spi_cs
        jmp     #\0


: BOOTFLASH
    $E0000 SFER64 $F0000 SFER64
    0 $E0000 $20000 SFWRS    --- backup 128k-128 into Flash
    0 SFER4 SDBUF $400 ERASE
    ' BOOTER SDBUF XX CMOVE
    SDBUF 0 $400 SFWRS
;
fd02c     fedfefd0                 loc     PTRA,#_hubrom           ' copy all of ROM to low 64K'
fd030     fef0efcc                 loc     PTRB,#$C000
fd034     ff000008                 rep     #2,##$1000
fd038     fcdc0400
fd03c     fb041761                 rdlong  fx,PTRA++
fd040     fc6417e1                 wrlong  fx,PTRB++



loc     eeee 1110 1WWR	AAAAAAAAAAAAAAAAAAAA


code BOOTER
--- copy TAQOZ image from Flash to RAM
        loc     PTRA,\#$E0000
        loc     PTRB,\#0

        mov     pa,#32
        mov     pb,#$0E0000_03
        call    #\spi_cmd
        decod   y,#17                   'ready to input 128kB from SPI
        wrfast  #0,#0                   'ready to write bytes to hub
.data   call    #\spi_in                 'get byte
        wfbyte  x
        djnz    y,#.data
        drvh    #spi_cs
        jmp     #\0



