TAQOZ

$164    := x0
$165    := y0

CODE FLASHROM
                decod   y0,#17                   'load 128k
                wrfast  #0,#0                   'ready to write bytes to hub
.l0             call    #\$FC188     'spi_in                 'get byte
                wfbyte  x0                       'store byte into hub
                djnz    y0,#l0                'loop for next byte (y=0 after)
                rdword  x0,#0                    ' read abs jump address of first instruction
                jmp     x0                    
        end



{
fc2b8 163          i               res     1               'universal
fc2b8 164          x               res     1
fc2b8 165          y               res     1
fc2b8 166          z               res     1

spi_in      = $FC188

; 0000 COG FLASH LOADER FOR TAQOZ  
; 0000..$03FF sum = "Prop" = $706F_7250
; CONTINUES READING IN FROM FLASH AFTER $3FF
                decod   y,#17                   'load 128k
                wrfast  #0,#0                   'ready to write bytes to hub
.data           call    #spi_in                 'get byte
                wfbyte  x                       'store byte into hub
                djnz    y,#.data                'loop for next byte (y=0 after)
                rdword  x,#0                    ' read abs jump address of first instruction
                jmp     x                    
long            





                decod   y,#10                   'ready to input $400 bytes from SPI
                wrfast  #0,#0                   'ready to write bytes to hub
.data           call    #spi_in                 'get byte
                wfbyte  x                       'store byte into hub
                djnz    y,#.data                'loop for next byte (y=0 after)

                rdfast  #0,#0                   'ready to read longs from hub
                rep     @.sum,#$100             'ready to read and sum $100 longs
                rflong  z                       'read long
                add     y,z                     'sum long
.sum
                cmp     y,csum          wz      'verify checksum, z=1 if okay
                bitz    flags,#spi_ok           'if program verified, set spi_ok flag

' TRY SERIAL IF Z 

        if_z    setq    #$FF                    'if SPI program, move it into cog $000..$0FF
        if_z    rdlong  0,#0

                drvh    #spi_di                 'check pull-down on spi_di, leave floating
                callpa  #spi_di,#check_pulldn   'c=0 if pull-down

        if_nc   jmp     #serial_done            'if pull-down on spi_di, boot if SPI okay (z=1) or shut down


' Serial done
' on entry, z=1 if SPI program
'
serial_done     call    #reset_pins             'reset pins

        if_z    jmp     #0                      'if SPI program, run it, else shut down


csum            byte    "Prop"                          'checksum


}

END
