TAQOZ
IFDEF *MANDELBROT*
	Cx org
	FORGET *MANDELBROT*
}
: *MANDELBROT*		PRINT" MANDELBROT VGA DEMO 190800-0000 " ;

( NOTE: Adapted from a routine written by Martin H 2017 )

--- Constants prefixed with # as a "constant" reminder
20			:= #MaxIter

pri #YSIZE	rows 20 - ;
\ pri #XVAL	cols 2/ NEGATE ;	--- Stating value for X
pri #XSIZE	cols 20 - ; --- X size
\ pri #YVAL	#YSIZE 2/ NEGATE ;

\ rows 20 -		:= #YSIZE
cols 2/ NEGATE		:= #XVAL	--- Stating value for X
\ cols 20 -		:= #XSIZE	--- X size
#YSIZE 2/ NEGATE	:= #YVAL



pub SCALE		5 << ;
20 SCALE		:= #RESCALE
AT #RESCALE 2+ 		:= =res

10			:= #top
10			:= #left

--- variables to hold values during the escape calculation.
long Cx
long Cy
long Zx
long Zy

long esccnt
long maxcnts
byte colexp


--- stores the row column values from the stack for the escape calculation.
pri INIT_VARS ( row cell -- )
	SCALE DUP Cx ! Zx !
	SCALE DUP Cy ! Zy !
	1 esccnt ! ;

--- Compute squares, but rescale to remove extra scaling factor.
pri ZSQ ( var -- sqr )		@ ABS DUP #RESCALE U*/ ;

--- Increment ESCCNT and compare to max iterations.
pri COUNT?  	esccnt ++ esccnt @ #MaxIter > ;

--- Performs a single iteration of the escape calculation.
pri DOESCAPE
    Zx ZSQ   Zy ZSQ   2DUP + ( Zx2 Zy2 Zx2+Zy2 )
--- escape if ((Zx*Zx)+(Zy*Zy))>ER2
    #RESCALE 4* >
    IF esccnt @ maxcnts @ MAX maxcnts !
      2DROP TRUE
    ELSE ( Zx2   Zy2 )
      - Cx @ +   ( result )      Zx @ Zy @ #RESCALE 2/ */
---   Zy=2*Zx*Zy + Cy; Zx=Zx2-Zy2 +Cx;
    Cy @ + Zy ! Zx !
      COUNT?
    THEN ;


\ Iterates on a single cell to compute its escape factor.
pri DOCELL ( row cell -- )
	INIT_VARS BEGIN DOESCAPE UNTIL
---   expand the color or set as black
	esccnt @ #MaxIter < IF esccnt @ colexp C@ 1 MAX 16 MIN W* ELSE 0 THEN
---	and plot the pixel and advance
	PIXEL! 1 X+!
	;

\ For each cell in a row.
pri DOROW  	#left x #XVAL #XSIZE ADO DUP I DOCELL LOOP DROP 1 Y+! ;

pub EXP		colexp C! ;
pub ITS		AT #MaxIter :=! ;

pub DOBROT
	#top y maxcnts ~
	#YVAL #YSIZE ADO  I DOROW KEY $1B = IF LEAVE THEN LOOP
	;
\ For each row in the set.
pub MANDELBROT
	white PAPER CLRSCR !PAL
	#left 1- x #top 1- y #XSIZE 2+ w #YSIZE 2+ h white PEN RECT
---	quick lores fill before more detail?
	#MaxIter 50 > IF
	  #MaxIter 20 ITS
	  DOBROT ITS
	THEN
	DOBROT
	;


pub ZOOM ( n -- )	SCALE AT #RESCALE :=! MANDELBROT ;

--- PAN ZOOM
\ pub MANDEL ( x y z -- )	-ROT #YSIZE 2/ - AT #YVAL :=! #XSIZE 2/ - AT #XVAL :=! ZOOM ;
pub MANDEL ( x y z -- )		-ROT #YSIZE 2/ - AT #YVAL :=! #XSIZE 2/ - AT #XVAL :=! ZOOM ;

\ Run the computation with defaults
pub MBGO			-120 0 200 MANDEL ;
pub MB3200		-1760 2000 3200 MANDEL ;
11 EXP
{
 -110 140 200 mandel
 -220 280 400 mandel
 -440 500 800 mandel
 -880 1000 1600 mandel
 -1760 2000 3200 mandel
}
END
