TAQOZ
IFDEF *MANDELBROT*
	Cx org
	FORGET *MANDELBROT*
}
: *MANDELBROT*		PRINT" MANDELBROT VGA DEMO 190800-0000 " ;

( NOTE: Adapted from a routine written by Martin H 2017 )

--- Constants prefixed with # as a "constant" reminder
20			:= #MaxIter

pri #YSIZE	rows 20 - ;
\ pri #XVAL	cols 2/ NEGATE ;	--- Stating value for X
pri #XSIZE	cols 20 - ; --- X size
\ pri #YVAL	#YSIZE 2/ NEGATE ;

\ rows 20 -		:= #YSIZE
cols 2/ NEGATE		:= #XVAL	--- Stating value for X
\ cols 20 -		:= #XSIZE	--- X size
#YSIZE 2/ NEGATE	:= #YVAL



pub SCALE		5 << ;
20 SCALE		:= RESCALE
\ AT #RESCALE 2+ 		:= =res

10			:= #top
10			:= #left

--- variables to hold values during the escape calculation.
long Cx
long Cy
long Zx
long Zy

long esccnt
long maxcnts
byte colexp


--- stores the row column values from the stack for the escape calculation.
pri INIT_VARS ( row cell -- )
	SCALE DUP Cx ! Zx !
	SCALE DUP Cy ! Zy !
	1 esccnt ! ;

--- Compute squares, but rescale to remove extra scaling factor.
pri ZSQ1 ( var -- sqr )		@ ABS DUP RESCALE U*/ ;

OFF LISTING


code ZSQ
	rdlong	xx,a		' @'
	abs	xx,xx		' ABS '
	qmul	xx,xx
	getqx	xx
	getqy	yy
	rdlong	a,#@RESCALE 2+
	setq	yy
	qdiv	xx,a
_ret_	getqx	a
	end
{
    Zx ZSQ   Zy ZSQ   2DUP + ( Zx2 Zy2 Zx2+Zy2 )
--- escape if ((Zx*Zx)+(Zy*Zy))>ER2
    #RESCALE 4* >
}
---       Zx @ Zy @ #RESCALE 2/ */

--- Cy @ + Zy ! Zx !
code doesc1
	rdlong	xx,#Cy
	add	a,xx
	wrlong	a,#Zy
	wrlong	b,#Zx
	2DROP;
	end

code doesc3
	sub	b,a		' - Cx @ + '
	rdlong	a,#Cx
	add	b,a		' b = 1st result'
	DROP;
	end

---      - Cx @ +   ( result )      Zx @ Zy @ #RESCALE 2/ */
code doesc2
	sub	b,a		' - Cx @ + '
	rdlong	a,#Cx
	add	b,a		' b = 1st result'
	rdlong	xx,#Zx		' Zx @ Zy @  * '
	rdlong	yy,#Zy
	mov	zz,xx
	xor	zz,yy		' sign bit in msb'
	abs	xx
	abs	yy
	qmul	xx,yy
	getqx	xx
	getqy	yy		' yyxx = Zx * Zy'
	rdlong	a,#@RESCALE 2+		' #RESCALE '
	sar	a,#1		' 2/ '
	setq	yy
	qdiv	xx,a
	getqx	a
	mov	zz,zz wc
 _ret_	negc	a
	end


code M*/ ( s1 s2 d3 -- )
	mov	zz,c
	xor	zz,b
	abs	c
	abs	b
	qmul	c,b
	getqx	c
	getqy	b
	setq	b
	qdiv	c,a
	getqx	c
	getqy	d
	DROP;

	end

{	( n1  n2 -- )
nx+Cx  (z )

	- Cx @ +   ( result )
        Zx @ Zy @ RESCALE 2/ */
}
--- Increment ESCCNT and compare to max iterations.
pri COUNT?  	esccnt ++ esccnt @ #MaxIter > ;

--- Performs a single iteration of the escape calculation.
pri DOESCAPE
    Zx ZSQ   Zy ZSQ   2DUP + ( Zx2 Zy2 Zx2+Zy2 )
--- escape if ((Zx*Zx)+(Zy*Zy))>ER2
    RESCALE 4* >
    IF esccnt @ maxcnts @ MAX maxcnts !
      2DROP TRUE
    ELSE ( Zx2   Zy2 )
     doesc3  ( - Cx @ +  )  ( result )      Zx @ Zy @ RESCALE 2/ */
\	doesc2
---   Zy=2*Zx*Zy + Cy; Zx=Zx2-Zy2 +Cx;
\    Cy @ + Zy ! Zx !
	doesc1
      COUNT?
    THEN ;
{
pri DOESCAPE
    Zx ZSQ   Zy ZSQ   2DUP + ( Zx2 Zy2 Zx2+Zy2 )
--- escape if ((Zx*Zx)+(Zy*Zy))>ER2
    RESCALE 4* >
    IF esccnt @ maxcnts @ MAX maxcnts !
      2DROP TRUE
    ELSE ( Zx2   Zy2 )
      - Cx @ +   ( result )      Zx @ Zy @ RESCALE 2/ */
---   Zy=2*Zx*Zy + Cy; Zx=Zx2-Zy2 +Cx;
    Cy @ + Zy ! Zx !
      COUNT?
    THEN ;
}

\ Iterates on a single cell to compute its escape factor.
pri DOCELL ( row cell -- )
	INIT_VARS BEGIN DOESCAPE UNTIL
---   expand the color or set as black
	esccnt @ #MaxIter < IF esccnt @ colexp C@ 1 MAX 16 MIN W* ELSE 0 THEN
---	and plot the pixel and advance
	PIXEL! 1 X+!
	;

\ For each cell in a row.
pri DOROW  	#left x #XVAL #XSIZE ADO DUP I DOCELL LOOP DROP 1 Y+! ;

pub EXP		colexp C! ;
pub ITS		AT #MaxIter :=! ;

pub DOBROT
	#top y maxcnts ~
	#YVAL #YSIZE ADO  I DOROW KEY $1B = IF LEAVE THEN LOOP
	;
\ For each row in the set.
pub MANDELBROT
	CLRSCR !PALETTE
	#left 1- x #top 1- y #XSIZE 2+ w #YSIZE 2+ h white PEN RECT
---	quick lores fill before more detail?
	#MaxIter 50 > IF
	  #MaxIter 20 ITS
	  DOBROT ITS
	THEN
	DOBROT
	;


pub ZOOM ( n -- )	SCALE AT RESCALE :=! MANDELBROT ;

--- PAN ZOOM
\ pub MANDEL ( x y z -- )	-ROT #YSIZE 2/ - AT #YVAL :=! #XSIZE 2/ - AT #XVAL :=! ZOOM ;
pub MANDEL ( x y z -- )	-ROT #YSIZE 2/ - AT #YVAL :=! #XSIZE 2/ - AT #XVAL :=! ZOOM ;

\ Run the computation with defaults
pub MBGO			-120 0 200 MANDEL ;
pub MB400			-220 280 400 MANDEL ;
pub MB3200		-1760 2000 3200 MANDEL ;
11 EXP
{
 -110 140 200 mandel
 -220 280 400 mandel
 -440 500 800 mandel
 -880 1000 1600 mandel
 -1760 2000 3200 mandel
}
END
