TAQOZ

( I2C BUS )

FORGET *I2C*
pub *I2C* 	." I2C BUS DRIVER 191000-0000" ;

57	:= *SDA
56	:= *SCL

: :=!	2+ ! ;
: 1&	1 AND ;
: PIN!	SWAP IF HIGH ELSE LOW THEN ;


: I2CPINS ( scl sda -- )	' *SDA :=! ' *SCL :=! ;

byte i2cflg
pub i2cdev	$A4 ;

--- wait but timeout while busy
pub ?I2C
	i2cflg C@ IF
	  1500 BEGIN 1- i2cflg C@ 0= OVER 0= OR UNTIL
	  DROP i2cflg C~
	THEN
	;

pub <I2C --- 1,168 cycles= 4,672ns @250MHz
	?I2C
pub <I2C>	--- restart without checking busy
	*SDA FLOAT *SCL HIGH
	*SDA LOW i2cflg C~~ *SCL LOW
	;


pub I2C>
	--- pull SDA high from low while clock high
	*SDA LOW *SCL HIGH ( 1 DROP ) *SDA HIGH
	--- free up I2C lines
 	*SDA FLOAT *SCL FLOAT
 	i2cflg C~						--- i2c bus free
	;

pri I2CBIT!	DUP 1& *SDA PIN! *SCL HIGH *SCL LOW  2/ ;

byte ack
pub ack?	ack C@ 0= ;

pub I2C! ( data -- )
	REV 24 >>
	8 FOR I2CBIT! NEXT
	DROP *SDA FLOAT						--- Float SDA
	*SCL HIGH *SDA PIN@ *SCL LOW
	ack C!
	;

pub ackI2C@ 	0
--- 25.5us @96MHz
--- Fetch a byte from the I2C bus - mirror ack signal 0 in = 0 out
pub I2C@	( ack -- data  ) --- 6,144 cycles= 24,576ns @250MHz
	*SDA FLOAT 0  ( ack iomask dat )
	  8 FOR 2* *SDA PIN@ 1& OR *SCL HIGH *SCL LOW NEXT
	--- make SDA an high output
	*SDA HIGH
	--- clock out ack bit
	SWAP I2CBIT! DROP *SCL FLOAT
 	;

pub nakI2C@	TRUE I2C@ ;


pub I2CWR ( adr -- ) 		1 ANDN <I2C I2C! ;
pub I2CRDREG ( dev reg -- )	OVER I2CWR I2C!
pub I2CRD ( adr -- ) 		1 OR <I2C I2C! ;

pub I2CRD? ( adr -- ack )	I2CRD ack? ;

\ pub lsi2c	128 FOR I 2* I2CRD? IF I 2* .B SPACE THEN NEXT I2C> ;

pub I2CC@	i2cdev I2CWR I2C! i2cdev I2CRD nakI2C@ ;
pub I2C		' i2cdev C! DUMP: I2CC@ I2CC@ I2CC@ ;


pub I2CREG! ( dat reg dev -- )	I2CWR I2C! I2C! I2C> ;
pub I2CREG@ ( reg dev -- dat )	DUP I2CWR SWAP I2C! I2CRD nakI2C@ I2C> ;



pub lsi2c	128 FOR I 2* I2CRD? IF I 2* .B SPACE THEN NEXT I2C> ;


pub *CLKGEN*			." Si5351 Clock generator 190800-0000" ;

\ $C0	:= Si5351
$DE	:= Si5351

: CG!!	' Si5351 2+ ! ;

pub CG! ( dat reg -- )		Si5351 I2CREG! ;
pub CG@				Si5351 I2CREG@ ;
pub CG				DUMP: CG@ CG@ CG@ ;



\ /Set of Si5351A register addresses
3	:= CLK_ENABLE_CONTROL
15	:= PLLX_SRC
16	:= CLK0_CONTROL
17	:= CLK1_CONTROL
18	:= CLK2_CONTROL
26	:= SYNTH_PLL_A
34	:= SYNTH_PLL_B
42	:= SYNTH_MS_0
50	:= SYNTH_MS_1
58	:= SYNTH_MS_2
177	:= PLL_RESET
183	:= XTAL_LOAD_CAP


900 25 /	:= a           --- Division factor 900/25 MHz
0		:= b           --- Numerator, sets b/c=0
1048575		:= c		--- Max. resolution, but irrelevant in this case (b=0)

\ byte _cgreg

pub CGREG!	0 CG! ' CGREG! C++ ;

pub CGREGS
\	_cgreg C!
	' CGREG! C!
	$FF CGREG! $FF CGREG!
	OVER $30000 AND 16>> CGREG!
	OVER 8>> CGREG!
	OVER CGREG!
	DUP 16>> >N $F0 OR CGREG!
	DUP 8>> CGREG!
	DUP CGREG!
	;


pub RDIV ( 7bit ch -- )	7 AND 3 << 44 + SWAP 7 AND 4 << SWAP CG! ;

--- Set PLLs (VCOs) to internal clock rate of 900 MHz
--- Equation fVCO = fXTAL * (a+b/c) (=> AN619 p. 3
pub !CG

\  unsigned long a, b, c;
\  unsigned long p1, p2, p3;

--- Init clock chip
	$D2 XTAL_LOAD_CAP CG!		--- Set crystal load capacitor to 10pF (default),
                                        --- for bits 5:0 see also AN619 p. 60
	0 CLK_ENABLE_CONTROL CG!	--- Enable all outputs
	$0F CLK0_CONTROL CG!		--- Set PLLA to CLK0, 8 mA output
	$2F CLK1_CONTROL CG!		--- Set PLLB to CLK1, 8 mA output
	$2F CLK2_CONTROL CG!		--- Set PLLB to CLK2, 8 mA output
	$A0 PLL_RESET CG!			--- Reset PLLA and PLLB

	a 7 << b 7 << c / + 512 - ( p1 )
	b 7 <<   c b 7 << c / * - ( p2 )

	SYNTH_PLL_A CGREGS
	SYNTH_PLL_B CGREGS
	2DROP
	;

pub CGFREQ ( syn freq -- )
	25,000,000 a UM* ROT UM// ( syn rm fdiv. )


	a 7 << b 7 << c / + 512 - ( p1 )
	b 7 <<   c b 7 << c / * - ( p2 )


	SWAP CGREGS
	2DROP
	;

\ void si5351_set_freq(int synth, unsigned long freq)
{

  unsigned long  a, b, c = 1048575;
  unsigned long f_xtal = 25000000;
  double fdiv = (double) (f_xtal * 36) / freq; //division factor fvco/freq (will be integer part of a+b/c)
  double rm; //remainder
  unsigned long p1, p2, p3;


  a = (unsigned long) fdiv;
  rm = fdiv - a;  //(equiv. b/c)
  b = rm * c;
  p1  = 128 * a + (unsigned long) (128 * b / c) - 512;
  p2 = 128 * b - c * (unsigned long) (128 * b / c);
  p3 = c;

}





{
  --- Set VCOs of PLLA and PLLB to 900 MHz

  --- Formula for splitting up the numbers to register data, see AN619

  p1 = 128 * a + (unsigned long) (128 * b / c) - 512;
  p2 = 128 * b - c * (unsigned long) (128 * b / c);
  p3  = c;

  ---Write data to registers PLLA and PLLB so that both VCOs are set to 900MHz intermal freq
  si5351_write(SYNTH_PLL_A, 0xFF);
  si5351_write(SYNTH_PLL_A + 1, 0xFF);
  si5351_write(SYNTH_PLL_A + 2, (p1 & 0x00030000) >> 16);
  si5351_write(SYNTH_PLL_A + 3, (p1 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_A + 4, (p1 & 0x000000FF));
  si5351_write(SYNTH_PLL_A + 5, 0xF0 | ((p2 & 0x000F0000) >> 16));
  si5351_write(SYNTH_PLL_A + 6, (p2 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_A + 7, (p2 & 0x000000FF));

  si5351_write(SYNTH_PLL_B, 0xFF);
  si5351_write(SYNTH_PLL_B + 1, 0xFF);
  si5351_write(SYNTH_PLL_B + 2, (p1 & 0x00030000) >> 16);
  si5351_write(SYNTH_PLL_B + 3, (p1 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_B + 4, (p1 & 0x000000FF));
  si5351_write(SYNTH_PLL_B + 5, 0xF0 | ((p2 & 0x000F0000) >> 16));
  si5351_write(SYNTH_PLL_B + 6, (p2 & 0x0000FF00) >> 8);
  si5351_write(SYNTH_PLL_B + 7, (p2 & 0x000000FF));

}
: CGLOAD ( tbl -- )	188 FOR DUP I + C@ I CG! NEXT ;

: CG25A
 $53 $0002 CG! $00 $0003 CG! $00 $0007 CG! $00 $000F CG!
 $8C $0010 CG! $0C $0011 CG! $8C $0012 CG! $8C $0013 CG!
 $8C $0014 CG! $8C $0015 CG! $8C $0016 CG! $8C $0017 CG!
 $00 $001A CG! $01 $001B CG! $00 $001C CG! $10 $001D CG!
 $00 $001E CG! $00 $001F CG! $00 $0020 CG! $00 $0021 CG!
 $00 $0032 CG! $01 $0033 CG! $00 $0034 CG! $10 $0035 CG!
 $00 $0036 CG! $00 $0037 CG! $00 $0038 CG! $00 $0039 CG!
 $00 $005A CG! $00 $005B CG! $00 $0095 CG! $00 $0096 CG!
 $00 $0097 CG! $00 $0098 CG! $00 $0099 CG! $00 $009A CG!
 $00 $009B CG! $00 $00A2 CG! $00 $00A3 CG! $00 $00A4 CG!
 $92 $00B7 CG!
;

byte w1		w1 C~

pre |	[C] GRAB w1 C@ IF 8 << + [C] || w1 C~ ELSE w1 C++ THEN ;


CREATE CGTBL
$11 | $F9 | $53 | $00 | $00 | $FF | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $90 | $00 |
$8C | $0C | $8C | $8C | $8C | $8C | $8C | $8C | $00 | $00 | $00 | $01 | $00 | $10 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $01 | $00 | $10 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 | $00 |
$FF | $0C | $00 | $00 | $00 | $30 | $1E | $92 | $60 | $60 | $B8 | $02 |

: CG25	188 0 DO I CGTBL + C@ I CG! LOOP ;


CREATE CLK20 256 ALLOT
CLK20 256 ERASE

: O 	SWAP CLK20 + C! ;

\ : O SWAP CG! ;
$0002 $53 O
$0003 $00 O
$0007 $00 O
$000F $00 O
$0010 $0F O
$0011 $0C O
$0012 $0F O
$0013 $8C O
$0014 $8C O
$0015 $8C O
$0016 $8C O
$0017 $8C O
$001A $00 O
$001B $01 O
$001C $00 O
$001D $10 O
$001E $00 O
$001F $00 O
$0020 $00 O
$0021 $00 O
$002A $00 O
$002B $01 O
$002C $00 O
$002D $10 O
$002E $00 O
$002F $00 O
$0030 $00 O
$0031 $00 O
$0032 $00 O
$0033 $01 O
$0034 $00 O
$0035 $14 O
$0036 $80 O
$0037 $00 O
$0038 $00 O
$0039 $00 O
$003A $00 O
$003B $02 O
$003C $00 O
$003D $10 O
$003E $C0 O
$003F $00 O
$0040 $00 O
$0041 $00 O
$005A $00 O
$005B $00 O
$0095 $00 O
$0096 $00 O
$0097 $00 O
$0098 $00 O
$0099 $00 O
$009A $00 O
$009B $00 O
$00A2 $00 O
$00A3 $00 O
$00A4 $00 O
$00B7 $92 O
FORGET O

: CG20 CLK20 CGLOAD ;

END
