TAQOZ
( I2C BUS )

FORGET *I2C*
pub *I2C* ;

57	:= *SDA
56	:= *SCL

: I2CPINS ( scl sda -- )	' *SDA :=! ' *SCL :=! ;

: CLKMHZ	CLKHZ 1000000 U/ ;

{
' I2C support
' CLKOUT ( iobit dat -- iobit dat2 ) REG27=iomask ) Shift msb bit out,  clock high, clock low
CLKOUT          outl    tos+1              ' ensure output will be active low
                drvl    clockpins
                shl     tos,#1 wc
                dirnc   tos+1                   ' make it an output if it is a low else float
' CLOCK ( REG27=iomask ) Toggle multiple bits on the output)
CLOCK           outnot  clockpins
                tjz     clkdly,#ckx
                mov     fx,clkdly
        _ret_   djnz    fx,#$
ckx             ret

' $01CA
' CLKIN ( iobit dat -- iomask dat2 )
CLKIN           dirl    tos+1
                testp   tos+1 wc
                rcl     tos,#1
                jmp     #CLOCK


' #0027
clockpins       long 0                                  ' I/O mask for CLOCK instruction
clkdly          long 0
}
byte i2cflg
pub i2cdev	$A4 ;

--- wait but timeout while busy
pub ?I2C
	i2cflg C@ IF
	  1500 BEGIN 1- i2cflg C@ 0= OVER 0= OR UNTIL
	  DROP i2cflg C~
	THEN
	;

pub <I2C --- 1,168 cycles= 4,672ns @250MHz
	?I2C
pub <I2C>	--- restart without checking busy
	*SDA FLOAT *SCL HIGH
	*SDA LOW i2cflg C~~ *SCL LOW
	;


pub I2C>
	--- pull SDA high from low while clock high
	*SDA LOW *SCL HIGH ( 1 DROP ) *SDA HIGH
	--- free up I2C lines
 	*SDA FLOAT *SCL FLOAT
 	i2cflg C~						--- i2c bus free
	;

pri I2CBIT!	DUP 1& *SDA PIN! *SCL HIGH *SCL LOW  2/ ;

byte ack
pub ack?	ack C@ ;

pub I2C! ( data -- )
	REV 24 >>
	8 FOR I2CBIT! NEXT
	DROP *SDA FLOAT						--- Float SDA
	*SCL HIGH *SDA PIN@ *SCL LOW
	ack C!
	;




pub ackI2C@ 	0
--- 25.5us @96MHz
--- Fetch a byte from the I2C bus - mirror ack signal 0 in = 0 out
pub I2C@	( ack -- data  ) --- 6,144 cycles= 24,576ns @250MHz
	*SDA FLOAT 0  ( ack iomask dat )
	  8 FOR 2* *SDA PIN@ 1& OR *SCL HIGH *SCL LOW NEXT
	--- make SDA an high output
	*SDA HIGH
	--- clock out ack bit
	SWAP I2CBIT! DROP *SCL FLOAT
 	;

pub nakI2C@	TRUE I2C@ ;


pub I2CRD ( adr -- ack ) 1 OR <I2C I2C! ;
pub I2CWR ( adr -- ack ) 1 ANDN <I2C I2C! ;

pub lsi2c	$100 0 DO <I2C I 1+ I2C! ack? 0= IF I .BYTE SPACE THEN 2 +LOOP I2C> ;

pub I2CC@	i2cdev I2CWR I2C! i2cdev I2CRD nakI2C@ ;
pub I2C		' i2cdev C! DUMP: I2CC@ I2CC@ I2CC@ ;


		--- RV-3028 RTC ---

--- RTC BCD STORE - store byte as BCD in RTC register
pub RTCB! ( byte reg -- )	SWAP 10 U// 4 << OR SWAP
pub RTC! ( byte reg -- )	$A4
pub I2CREG! ( dat reg dev -- )	I2CWR I2C! I2C! I2C> ;

pub RTC@ ( reg -- byte )	$A4
--- fetch reg from 8-bit reg addr
pub I2CREG@ ( reg dev -- dat )	DUP I2CWR SWAP I2C! I2CRD nakI2C@ I2C> ;

$29 bytes rtcbuf
pub RDRTC ( bytes -- )		$A4 I2CWR 0 I2C! $A4 I2CRD   rtcbuf OVER ADO 1- DUP 0= I2C@ I C! LOOP DROP I2C> ;

pub !RTC			$BC $37 RTC! ;

pub RTC				DUMP: RTC@ RTC@ RTC@ ;


pub UTIME@ ( -- secs )		0 27 4 ADO I RTC@ OR 8 ROR LOOP ; \ 27 RTC@ 28 RTC@ 8<< + 29 RTC@ 16<< + 30 RTC@ 24 << + ;
pub UTIME! ( secs -- )		27 4 ADO DUP I RTC! 8>> LOOP DROP ;

pub TIME! ( hhmmss -- )		100 U// SWAP 0 RTCB! 100 U// SWAP 1 RTCB! 2 RTCB! ;
pub DAY!			7 AND 3 RTC! ;
pub DATE! ( yymmdd -- )		100 U// SWAP 4 RTCB! 100 U// SWAP 5 RTCB! 6 RTCB! ;

pub BCDDEC			DUP >N SWAP 4 >> 10 * + ;
pub DT@				$21 RDRTC rtcbuf + 2+ 0 3 FOR 100 * OVER C@ BCDDEC + SWAP 1- SWAP NEXT NIP ;
pub TIME@			0 DT@ ;
pub DATE@			4 DT@ ;
pub DAY@			3 RTC@ ;

pub .6				.AS" ######" ;
pub .DT				DATE@ .6 '-' EMIT TIME@ .6 ;

pub .DATE			DATE@ 20000000 + .AS" ####/##/## "  ;
pub .DAY			DAY@ 1- 3 * " MONTUEWEDTHUFRISATSUN" + 3 CTYPE SPACE ;
pub .TIME			TIME@ .AS" ##:##:##" ;
pub .FDT			.DATE .DAY .TIME ;


END
