$40000 MOUT
$60000 FL TAQOZ ( Primary kernel extensions - terse version for testing logging )
0000 NFA' END 8 + $0C0 CMOVE --- make a backup of TAQOZ configuration at the end of the dictionary

	--- EXTEND MODE HEADER ---

pub *EXTEND*		PRINT" Primary kernel extensions 200426-1000" ;

0 @ := VEC0	--- lock in reset vector constant since loc 0 gets trashed at times

pub CPA! ( n nfa -- )	DUP $20 AND IF CPA M! ELSE CPA W! THEN ;

\ ALIAS <for> <as>
pre ALIAS	[C] NFA' [G] DUP CFA [C] CREATE$ @WORDS CPA!   C@ $E0 AND @WORDS C+! ;



ALIAS \ ***
ALIAS AND &
ALIAS ANDN !&
ALIAS XOR ^
ALIAS = ==
ALIAS ' AT


pub TAQOZ# ;

( P2 CONTROL )
public

$1F0 :=     IJMP3       --- interrupt call   address for INT3
$1F1 :=     IRET3       --- interrupt return address for INT3
$1F2 :=     IJMP2       --- interrupt call   address for INT2
$1F3 :=     IRET2       --- interrupt return address for INT2
$1F4 :=     IJMP1       --- interrupt call   address for INT1
$1F5 :=     IRET1       --- interrupt return address for INT1
$1F6 :=     PA       	--- CALLD-imm return, CALLPA parameter, or LOC address
$1F7 :=     PB  	--- CALLD-imm return, CALLPB parameter, or LOC address

$1F8 :=     PTRA        --- pointer A to hub RAM
$1F9 :=     PTRB        --- pointer B to hub RAM
$1FA :=     DIRA        --- output enables for P31..P0
$1FB :=     DIRB        --- output enables for P63..P32
$1FC :=     OUTA        --- output states for P31..P0
$1FD :=     OUTB        --- output states for P63..P32
$1FE :=     INA         --- input states for P31..P0 also debug interrupt call address
$1FF :=     INB        --- input states for P63..P32 also debug interrupt return address

27	:= CLKREG			--- store clock mask here for CLOCK  '
28	:= CLKDLY			--- delay register ( 0=none)'
6	:= KBCLK
7	:= KBDAT


private

$10	:= _xin
$14	:= _cpuhz
$18	:= _clkcfg
$1C	:= _baud
$20	:= _vgacfg
$24	:= _vspin
\ $28	:= @vgainit
\ $2C	:= kbpins
\ $30
\ $34

--- some common constants
public

64 KB		:= 64KB
1,000,000	:= 1M

--- run a TAQOZ task in another cog
pub RUN ( task cog -- )		DUP NEWCOG 5000 WAITX TASK W! ;

--- Run the code that follows this word as a cog task
pub RUN: ( cog -- )		R> SWAP RUN ;

( to use: ' <mytask> 1 RUN )

--- Set the lower address to trace from and enable tracing
pub TRACE! ( floor -- )		TRACE $1EF COG! ;




--- create names for some kernel variables
public

--- print n as 5 hex digits
pub .M ( n --- )	DUP 16>> .H .WORD ;

--- Set the prompt or use 0 to reset to default
pub PROMPT! ( cfa -- )	uprompt W! ;

--- Print code pointer prompt
pri .HERE		." TAQOZ[" HERE 16>> ?DUP IF .BYTE THEN HERE .WORD ." ]# " ;

--- Change prompt to include current code pointer
pub PAGER		' .HERE uprompt W! ;

--- Plain non-interactive responses for remote operation - Remove prompt and accept strings
pub REMOTE		flags C~ AT NOP PROMPT! AT NOP uaccept W! $CE REG W++ ;

--- Reset prompt to local interactive
pub LOCAL		1 flags SET uprompt W~ uaccept W~ ( linenum W~ ) CON ;



	*** ANSI TERMINAL SUPPORT ***

pub *ANSI*			PRINT" ANSI TERMINAL SUPPORT 200410-0000" ;
pub ESC ( ch -- )		$1B CONEMIT CONEMIT ;

pub %HOME			'H'
 pri ESCB ( ch -- )		'[' ESC CONEMIT ;

pub %PEN ( col -- )		7 AND '3'
 pri COL ( col fg/bg -- )	ESCB '0' + CONEMIT 'm' CONEMIT ;
pub %PAPER ( col -- )		'4' COL ;


 pri CUR ( cmd n -- )		'[' ESC SWAP
 pri .PAR			SWAP . CONEMIT ;
pub %XY ( x y -- )		';' SWAP CUR 'H' .PAR ;


pub %CLS 			$0C CONEMIT ;
--- Erase the screen from the current location
pub %ERSCN			'2' ESCB 'J' CONEMIT ;
--- Erase the current line
pub %ERLINE			'2' ESCB 'K' CONEMIT ;


pub %CURSOR ( on/off -- )	'?' ESCB 25 .
 pri asw				IF 'h' ELSE 'l' THEN CONEMIT ;

pub %PLAIN			'0'
 pri ATR ( ch -- )		ESCB 'm' CONEMIT ;
pub %REVERSE			'7' ATR ;
pub %BOLD			'1' ATR ;

pub %WRAP ( on/off -- )		'?' ESCB '7' CONEMIT asw ;

\ pub %MARGINS ( top bottom -- )	'[' ESC SWAP ':' .PAR 'r' .PAR ;


public
--- ANSI COLORS
0	:= %black
1	:= %red
2	:= %green
3	:= %yellow
4	:= %blue
5	:= %magenta
6	:= %cyan
7	:= %white





	*** DEFERENCE ***

--- simple single level defer (needs to be tied in with accept )
pub <-		NOP  AT NOP AT <- W! ;
pub ->		R>  ( AT DEFERRED DUP 2+ 6 <CMOVE ) AT <- W! ;

pub CALL$ ( string -- )
	DUP C@
	IF DUP SEARCH ( str nfa )
	  ?DUP IF NIP CFA CALL
	  ELSE ( str ) unum W@ ?DUP IF CALL ELSE DROP THEN
	  THEN
	ELSE DROP
	THEN ;

long nx'	--- eval string ptr

 pri EVALKEY	nx' @ C@ DUP IF nx' ++ ELSE ukey W~ THEN ;

pub EVALUATE
	$20 OVER DUP LEN$ + W!
	nx' ! ' EVALKEY ukey W!
	BEGIN GET$ DUP LEN$ WHILE NUMBER 0= IF @WORD CALL$ THEN  REPEAT
	DROP
	;


 	*** DICTIONARY MODULE HIDE/REVEAL  ***


4  := #vocabs
#vocabs longs vocabs
--- only default FORTH vocab
pub FORTH	vocabs #vocabs 4* ERASE ;



pub @VOCAB ( index -- addr )	4* vocabs + ;

--- push this vocab to the top of the search list
pub +VOCAB ( nfa --- )
	vocabs vocabs 4+ #vocabs 1- 4* <CMOVE
	vocabs !
	;

pub SEARCH-VOCABS ( str -- nfa )
	0 #vocabs
	ADO
	  I @VOCAB @ ?DUP IF OVER SWAP ( str str list ) FIND$ ( str nfa ) ?DUP ?LEAVE ELSE 0 LEAVE THEN
	LOOP
	( str nfa )
	?DUP IF NIP ELSE @WORDS FIND$ THEN
	;

FORTH

--- Called from vocab control word and links in
pri (VOCAB)
	R> @ NFA+ +VOCAB
	' SEARCH-VOCABS ufind W!
	;

pre VOCAB ( <name> <including> -- )
---	First create a dummy link word with no skip (04)	1
	-4 uwords +! $04_8000 @WORDS !   @WORDS
---	Then create a definition that calls the vocab linking code
	[C] CREATE: AT (VOCAB) HERE 2- W! DUP  HERE ! 4 ALLOT
---	Then calculate the link displacement and update it
	[C] NFA' [G] OVER - SWAP 2+ W!
	;

pub POLLS		NOP NOP NOP NOP NOP NOP NOP NOP ;

--- Init and clear all polling vectors
pub !POLLS		AT POLLS 16 ADO AT NOP I W! 2 +LOOP ;

pub POLL:
	R>
pub +POLL
	AT POLLS 16 ADO
	  I W@ AT NOP = IF DUP I W! LEAVE THEN
	  DUP I W@ = ?LEAVE
	2 +LOOP
	DROP AT POLLS keypoll W!
	;


	*** SOFT TIMERS ***

--- define simple timers which uses one word for milliseconds and a long for CNT origin
pub TIMEOUT ( ms dvar -- )
	CNT@ OVER 4+ ! W!
	;
pub TIMEOUT? ( var -- flg )
	DUP 4+ @ CNT@ - ABS 1000 CLKHZ U*/ ( var mslap )
	SWAP W@ U>
	;
pub ?UNTIL ( var -- )	BEGIN DUP TIMEOUT? UNTIL DROP ;





--- redefine | literal byte compile to compile pairs of bytes automatically
pri ~b	0 ;
' ~b W@ := w
pre |	[G] >B ~b IF 8<< ~b >B + [C] || w ELSE w $100 + OR THEN AT ~b W! ;
--- negate long at adr
pub +-! ( adr -- )		DUP @ NEGATE SWAP ! ;
pre REVECTOR ( <target> <new> -- ) [C] AT [C] AT [G] 1+ SWAP W! ;

private
long _el
byte _sp
pri SPINNER
---	check if enough time has elapsed -  then update
	CNT@ _el @ - ABS CLKHZ 10 / > 0EXIT CNT@ _el !
---	output next char and backspace
	_sp C@ 3 AND " |/-\" + C@ EMIT 8 EMIT _sp C++
	;

pub .BITS ( n bits -- ) 	FOR DUP 1& . 2/ NEXT DROP ;

pub .BYTES ( adr bytes -- )	ADO IC@ .BYTE SPACE LOOP ;

pub #c		',' ;

--- process all digits for printing from right to left while inserting commas every third digit
pri #S, ( val -- 0 )
	0 SWAP
	BEGIN
---	while double not zero and not first digit
	  DUP 12 REG @ OR 3RD 0= OR
	WHILE
---	  after 1st check group if comma
	  OVER IF OVER 3 // 0= #c 0<> AND IF #c HOLD THEN THEN
---	  prepend a digit and increment digit count
	  # b++
	REPEAT
	NIP
	;
--- print a double number right justified
pub D.DECS ( dval. digits -- )	SWAP <D>
pub .DECS ( val digits -- )	>R <# #S, #> R> OVER LEN$ - 0 MAXS SPACES PRINT$ ;

pub >STR ( number -- string ) 	DUP ABS <# #S SWAP 0< IF '-' HOLD THEN #> ;

pub .DP ( num left-digits -- )
	SWAP >STR SWAP FOR C@++ EMIT NEXT
	'0' OVER DUP LEN$ ADO IC@ OR LOOP '0' <>
	IF '.' EMIT
	  BEGIN C@++ WHILE DUP NUMBER DROP IF DUP C@ EMIT THEN REPEAT
	THEN DROP
	;
--- print a double number
pub D.				0
pub D.R ( dval. digits -- )	SWAP <D>
pub U.R				SWAP <# #S #> DUP LEN$ ROT SWAP - 0 MAXS SPACES PRINT$ ;

--- print bytes as bytes or kilobytes
\ pri .KB				DUP 10 >> IF 10 >> .AS" *|kB" ELSE .AS" *| B" THEN ;

--- Print memory capacity
pub .MEM
	DUP >STR LEN$ SWITCH
	1 3 <CASE> .DEC PRINT" B" BREAK
	1000 U/
	4 6 <CASE> .DEC PRINT" KB" BREAK
	1000 U/
	7 9 <CASE> .DEC PRINT" MB" BREAK
	1000 U/ .DEC PRINT" GB"
	;

--- to Upper Case
pub a>A ( ch -- ch )		DUP 'a' 'z' WITHIN IF $20 - THEN ;

pub $= ( str1 str2 -- flg )
	OVER LEN$ OVER LEN$ =
	IF
	  DUP LEN$
pub C$= ( adr1 adr2 len -- flg )
	  ADO C@++ IC@ <> IF 0= LEAVE THEN LOOP
	  0<>
	BREAK
	2DROP FALSE
	;

32 bytes X$
pub $+ ( str1 str2 -- strx )	SWAP X$ $! X$ DUP LEN$ + OVER LEN$ 1+ CMOVE X$ ;

\ S2 X$ LEN2+1


--- replace the inline 10-bit literal with a new value
pub >!				$3FF AND w + R> W! ;



' 0EXIT 9 - := PAGE0

\ pub .HADR	CRLF DUP 16>> .H $FFFF AND .WORD ." : " ;

pub .NFA ( nfa -- )	C@++ $1F AND CTYPE ;

pub CFA>NFA ( cfa -- nfa )
	@WORDS
	BEGIN DUP W@
	WHILE 2DUP CFA = IF NIP EXIT THEN NFA+
	REPEAT 2DROP 0
	;

pub LWORDS
	@WORDS
	BEGIN ( cnt width words )
	  DUP .ADDR
	  DUP W@
	WHILE ( cnt width words )
	  DUP CFA .M
	  DUPC@ 5 >> DUP 3 + SPACES 3 * " pub-1-pri-3-pre-5--6--7-" + 3 CTYPE
	  SPACE
	  DUP .NFA
	  NFA+
	REPEAT
	DROP
	;


--- Test header to see if it is a *MODULE* name
---		Starts with *	  Ends with *                           and len is > 3
pri MOD?	DUP 1+ C@ '*' =	  OVER DUP C@ $1F AND + C@ '*' =    AND SWAP C@ $1F AND 3 > AND ;

pub MWORDS ( width -- )
	0 @WORDS DUP .ADDR
	BEGIN ( cnt width words )
	  OVER 4TH > OVER MOD? OR IF ( DUP .ADDR ) CRLF NIP 0 SWAP THEN
	  DUP W@
	WHILE ( cnt width words )
	  DUP C@ $1F AND 1+ ROT + SWAP
	  DUP C@++ $1F AND CTYPE SPACE
	  DUP MOD? IF CRLF CRLF THEN
	  NFA+
	REPEAT
	3DROP
	;

--- Rename kernel WORDS to wORDS before creating new WORDS
'w' NFA' WORDS ?DUP IF 1+ C! THEN

pre WORDS
	delim 1+ C@ $20 =
	IF
	  GET$ DUP UPPER$ DUP " -L" $= IF DROP LWORDS EXIT; THEN
	  DUP " -M" $= IF DROP 100 MWORDS EXIT; THEN
	THEN
	[C] wORDS
	;

--- Print TAQOZ control key assignments ---
pub .CTRLS
	32 FOR I 2* AT GET$ $40 - + W@ ?DUP IF CRLF I .B ."  ^"  I '@' + EMIT SPACE DUP CFA>NFA ?DUP IF .NFA DROP ELSE .M THEN THEN NEXT
	;

pri .CV
         @WORDS
         BEGIN
           DUP W@
         WHILE
           DUP CFA W@ 4TH 4TH WITHIN
             IF CRLF DUP CFA 2+ @ .L
             DUP CFA W@ $141 = IF ."  = " ELSE ."  @ " THEN
             DUP .NFA
             THEN
           NFA+
         REPEAT
         3DROP
          ;

pub .CONVARS 	$140 $141 .CV ;
pub .VARS   	$140 $140 .CV ;
pub .CONS 	$141 $141 .CV ;


6 bytes dz
--- DUMP MEMORY AS BYTES BUT SKIP ANY 128 BYTE PAGE THAT IS ALL 0'S OR FF'S
pub DUMPZ ( src cnt -- )
	$AA REG dz 6 CMOVE
	ADO
	  0 I 128 ADO I dz W@ ?DUP IF CALL ELSE C@ THEN + LOOP
	  ?DUP IF $FFFF.FFC0 <> IF dz $AA REG 6 CMOVE  I 128 DUMP THEN ELSE CRLF I .M ." : " THEN
	128 +LOOP
	;


private
long _pinmode
IFDEF PIN
'p' NFA' PIN 1+ C! --- rename PIN to pIN to make way for new def
}

pub PIN		pIN _pinmode ~ ;

--- Create a pin code range for Rev B pins instructions
pub PINS ( from for -- pins )	1- 6 << + ;


pub .DEC2 	.AS" ##" ;

pub .io
	64 FOR
	  I $1F AND 0= IF CRLF  THEN
	  I 7 AND 4 = IF ." -" THEN
	  I 7 AND 0= IF I .AS"   ##:"  THEN
	  I PIN@ 1& I |< DIRA I 5 >> + COG@ AND IF 2+ THEN
	  " lhLH" + C@ EMIT
	NEXT
;

--- type out printable characters or substitute with a dot
\ pub CTYPE ( adr cnt -- )	ADO I C@ .EMIT LOOP ;

pri .OK		IF ."  OK!" THEN ;

pri .SUCCESS
	SPACE IF ." SUCCESS!" BREAK ." ERROR!"
	;
pub TAB				9 EMIT ;
pub TABS			CR FOR TAB NEXT ;

--- redirect (using uemit/ukey) all character I/O to the code that follows
pub EMIT:			R> EMIT! ; \ uemit W! ;
pub KEY:			R> ukey W! ;
--- null output device - discard data
pub NULL			EMIT: DROP ;

long bufptr
long bufwr
long bufsz

--- direct output to a new buffer in memory or add to that buffer
pub =BUF ( address size -- )	bufsz ! bufptr ! bufwr ~
pub +BUF			EMIT: bufptr @ bufwr @ + C! bufwr @ 1+ bufsz @ // bufwr ! ;

pub CONOUT
	EMIT:
pub MBXEMIT
	BEGIN outbox C@ 0= UNTIL outbox C!
	;


--- create a table of preallocated bytes
pre TABLE ( bytes -- ) ( -- addr )
	HERE 2+ [G]
---	create name and allow bytes
	[C] CREATE: DUP ALLOT
---	erase any allocated bytes
	?DUP IF ERASE ELSE DROP THEN
	;

pub HERE: R> ;

--- compiles the current data ptr before creating a new word
pre module			org@ [C] , [C] CREATE$ [C] ] ;

		*** BENCHMARKS ***

pub fibo ( n -- f )  		0 1 ROT FOR BOUNDS NEXT DROP ;


pub fibos  1 46 ADO CRLF I .AS" fibo(*|#) = " LAP I fibo  LAP .LAP ."  result = " .DECL 5 +LOOP ;


 	*** SERIAL MODES ***

pri dl				7 ; --- bit length of asynch serial smartpin interface
pub -bit ( n -- )		1- AT dl C! ;
pri BAUD ( baud mode -- )	WRPIN CLKHZ SWAP U/ 16<< ( dl 0= IF 8 BIT THEN ) dl + WXPIN H 8 -bit ;
pub TXD ( baud -- )		$7C BAUD 0 WYPIN ;
pub RXD ( baud -- )		$3E BAUD ;
---				config save	set rxd mode & tx mode
pub CONBAUD ( baud -- )		DUP _baud !  	63 PIN DUP RXD 62 PIN TXD ;





		*** P2 CLOCK CONTROL ***

pub *P2CLOCK*		PRINT" P2 CLOCK CONTROL 190800-0000" ;

public
long _clk  \  _clk ~
private
long _fin
--- set the
pub CLKSET			_clk @ DUP _clkcfg ! HUBSET ;
( PLL should run between 100 to 200MHz )

--- CC: Usage: 30 pf or 15 pf or 0 pf or -15 pf to disable
pri +CC
pri pf ( pf -- )		15 / 1+   3 AND 2 << $0C
pri CLK! ( data mask -- )	_clk @ SWAP ANDN OR _clk ! ;

--- E: - enable PLL
pub PLLEN			24 |< _clk SET ;
pub PLLOFF			24 |< _clk CLR ;

--- DDDDDD:
pub XIDIV ( 1..64 -- )		1- $3F AND 18 << $00FC0000 CLK! ;
( ends up as multiply)
pub VCOMUL ( 1..1024 -- )	1- $3FF AND 8 << $3FF00 CLK! ;

--- PPPP: Divide the PLL by 2 4 6 ... 30 for the system clock when SS = %11 --- 1 = 31 = no divide
pub +PPPP
pub PLLDIV ( 2..30 -- ) 	2/ 1- >N 4 << $0F0 CLK! ;

--- SS: clock source
pub +SS
pub CLKSRC			CLKSET DUP 1 > IF 200,000 WAITX THEN 3 AND 3 CLK! CLKSET ;

pub USEPLL			3 CLKSRC ;
pub USEXTAL			2 CLKSRC ;

public
CLKHZ 1,000,000 U/ := CLKMHZ

ALIAS CLKHZ clkfreq	--- alias for common "clkfreq" name

pri HZ!
	DUP _cpuhz ! 1,000,000 U/
	DUP AT CLKMHZ :=!
---	CPUHZ/4_000_000
	4/ AT us @ $1FF ANDN OR AT us !
	;


--- Set P2 CLOCK to selected MHZ ( simple PLL settings only )

pub CLKHZ! ( HZ --- )
---	align to multiples of XIN
	$10 @ U/ $10 @ *
pri CLKHZ1! ( hz -- )
	_clk ~ HZ!
---	defaults of 15pF and an XI divide of 1
	  15 pf PLLEN 1 XIDIV
---	then multiply up the base input frequency
	  CLKHZ _xin @ U/ VCOMUL
---	default PLL divider of 1 and enable
	  1 PLLDIV USEPLL
---	reload to calculate baud rate setting
	_baud @ CONBAUD
pub !CLKHZ
	NOP NOP NOP NOP
	;

pub RCSLOW		20,000 HZ! 1 HUBSET _clk ~ ;

---			nominal rcfast freq ( Use <new value> AT RCFAST 2+ ! )
pub RCFAST		25,100,000	CLKHZ1! 0 HUBSET _clk ~ ;

--- quick clock set to MHZ - but delay for transmit characters during interactive
pub CLKMHZ!		5 ms M CLKHZ! ;
pub CRUISE		200 CLKMHZ! ;



		*** HUB ***

\ %0100_xxxx_xxxx_xxxx_xxxx_xxxR_RLLT_TTTT     Set filter R to length L and tap T

pub FILTER! ( tap0..31 len0..3 filter0..3 -- )	3 AND 7 << SWAP 3 AND 5 << OR SWAP $1F AND OR HUBSET ;


			*** SMART PINS ***

pub *SMARTPINS*		PRINT" SMARTPIN FUNCTIONS and drive modes 190800-0000" ;




	*** PIN DRIVE MODES ***


pub FAST			0 ;
pub 1K5				1 ;
pub 15K				2 ;
pub 150K			3 ;
pub 1ma				4 ;
pub 100ua			5 ;
pub 10ua			6 ;
pub OPEN			7 ; ( float )

pub CLOCKED			$100
pri 14P				14
pri PINM ( val field -- )	<< _pinmode SET ;

pub !IN				$80 14P ; --- inverted input
pub !OUT			$40 14P ;
pub SOURCE			11 PINM ;
pub SINK			8 PINM ;

pub OPEN-DRAIN			OPEN SOURCE FAST SINK ;


--- convert frequency to count value depending upon system clock
pub NCOCNT ( hz -- cntval )	CLKHZ 4 << SWAP U/ 0 $10 ROT UM/ ;
--- convert nanoseconds to counter value based on CLKHZ
pub NSCNT ( ns -- cntval )	1000 * 1,000,000,000,000. CLKHZ UM/ U/ ;


--- WRPIN in combo with modes - float, shift, combine, wrpin, low (DIR=1)enables smartpin
pub WRFNC ( MMMMM -- )		F 2* _pinmode @ OR WRPIN L ;

--- mute smartpin functions on current pins(pins)
pub MUTE			F 0 WRPIN ;

	*** SMARTPIN FREQUENCY GENERATION ***

pub MHZ ( MHz -- )		1000 *
pub KHZ	( kHz -- )		1000 *
--- setup smartpin to output a square wave frequency
pub HZ ( Hz -- )		NCOCNT
--- select NCO frequency mode
pub NCO ( count -- )		%1_00110
pub SETNCO ( val mode --)	WRFNC 1 WXPIN WYPIN ;

--- Duty mode smartpin (frequency varies with duty)
pub DUTY ( val -- )		%01_00111 SETNCO ;

pub BLINK ( pin -- )		PIN 2 HZ ;


	*** SMARTPIN PWM ***

--- pulse-width modulation output : use: 25 100 1 PWM!
pub PWM ( duty frame div -- )	%1_01001
pri PWM!			WRFNC SWAP 16<< OR WXPIN WYPIN ;
pub TRI ( duty frame div -- )	%01_01000 PWM! ;
--- switch-mode PWM
pub SMPS ( duty fram div -- )	%01_01010 PWM! ;

	*** SMARTPIN PULSES ***

pub PW ( width -- )		%01_00101 WRFNC WXPIN ;

pub PULSE			1
pub PULSES ( cnt -- )		WYPIN ;
pub HILO ( high low -- )	%01_00100 WRFNC SWAP OVER+ SWAP 16<< OR WXPIN ;


	*** SMARTPIN ANALOG ***

--- SMART PINS - %AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0

( 12-bit analog to digital to analog, 19.5k samples/second )

pub DAC ( bits -- )		%101_000_0000000_01_00011 WRFNC |< WXPIN ;

pub V ( volts*1000 --- )	16<< 3300 U/ WYPIN ;

( RevA A/D --- TODO: needs to be updated )

pub ADC ( cycles -- )		%100_011_0000000_00_01111 WRFNC WXPIN 0 WYPIN ;

private
64 words amin	64 words aref
pri AREF			@PIN 2* aref + ;
pri AMIN			@PIN 2* amin + ;
pub SETADC ( min ref -- )	AREF W! AMIN W! ;
pub VOLTS@ ( -- volts*1000 )	RDPIN AMIN W@ - 1000 AREF W@ U*/ ;

	*** SMARTPIN SERIAL ***




		*** SD CARD SUPPORT ***

pub *EASYFILE*		PRINT" SD CARD and FAT32 with VIRTUAL MEMORY  190800-0000" ;


org@	org ( marks start of block for DATLEN )
private
0	bytes	sdvars		--- mark start of variables array
4	bytes	ocr		--- operating conditions registers
16	bytes	cid		--- card ID
16	bytes	csd		--- card specific data
	long	sdsize		--- numbero of sectors
	long	@sdrd
	long	@sdwr
	long	sdsum		--- checksum of sector contents
	long	seccrc		--- sector crc

	long	readsect	--- current buffered sector
	long	filesect	--- starting sector of current file ( could be a directory)'
	long	opensect	--- starting sector of open file'

	long	_fread
	long	_fwrite
	long	mntd		--- serial number of mounted device
	word	_fkey

	byte	sdcmd
	byte	wrflg		--- true if sector has been modified
\	byte	mntd
\	byte	sdcrc

	byte	wrens		--- write enables
	byte	file#
	byte	fq
	byte	sdhc
	byte	blklen
16 	bytes	bitbuf

	*** PARITION RECORDS ***

--- 4 primary partitions
64	bytes	parts	--- STATE,[HEAD,[SECT(2),TYPE,HEAD],SECT(2)],1STSECT(4),PARTSEC(4)
				---  00    82    03 00   0B   50    CA C6     $2000  $00ECC000
	word	parsig


	*** FAT32 BOOT RECORD ***

3	bytes	fat32		--- jump code +nop
8	bytes	oemname		--- MSWIN4.1
	word	b/s		--- 0200 = 512B (bytes/sector)
	byte	s/c		--- 40 = 32kB clusters (sectors/cluster)
	word	rsvd		--- 32 reserved sectors from boot record until first fat table
	byte	fats		--- 02
2	res			--- Maximum Root DirectoryEntries (non-FAT32)
2	res			--- Number of Sectors inPartition Smaller than 32MB (non-FAT32)
	byte	media		--- F8 hard disk  (IBM defined as 11111red, where r is removable, e is eight sectors/track, d is double sided. )
2	res			--- Sectors Per FAT in Older FATSystems (N/A for FAT32)
2	res			--- Sectors Per Track --- 3F 00
2	res			--- Number of Heads --- FF 00
	long	hidden		--- Number of Hidden Sectors before Partition --- 00 20 00 00
( 32 )
	long	s/p		--- $00EC_C000  Number of sectors * byte/sect (512) = capacity'
	long	s/f		--- $0000_0766 Number of sectors per FAT table'
2	bytes	fat?		--- 0000 fat flags (b3..0 = active fat copy, b7=mirroring)
2	res	fatver		--- 0000 fat version MAJOR.MINOR
( 44 )
	long	rootcl		--- $0000_0002 Cluster Number of the Start of the Root Directory'
	word	infosect	--- 0001 info = Sector Number of the FileSystem Information Sector  (from part start)
	word	bbsect		--- 0006 boot = Sector Number of the Backup Boot Sector (from part start)
12	res			--- 00s
( 64 )
	byte	ldn		--- 80 logical drive number of partition
1	res	ldnh		--- 01 unused or high byte of ldn
	byte	extsig		--- 29 extended sig
	long	serial		--- $63FE_C331 serial number of partition
11	bytes	volname		--- volume name
8	res	fatname		--- "FAT32   " always FAT32 - (don't trust)
2	res			--- align to a long for FREAD
( 90 )

--- --- --- --- --- --- --- --- --- --- --- --- --- ---

	long freeclusters	--- Read from info sector
	long lastcluster	--- Read from info sector
---	calculated from scan at mount
	long usedcl		--- Used Clusters
	long freecl		--- Free Clusters
	long used%		--- percentage used *100


	long mksiz		--- size used to create a file if file not found - 0 = none

--- --- --- --- --- --- --- --- --- --- --- --- --- ---
--- create room for some system variables in this table

	long	rootdir		--- sector address of root directory (MBR,GAP,BOOT,INFO,BACKUP,FAT1,FAT,ROOT)
	long	cwdir
	long	fat1
	long	fat2
	long	cwdsect
org@ sdvars -	:= sdsz		--- size of array used to hold all raw SD card related values + FAT etc
cwdsect fat32 - := fatsz	--- size of array used to hold all fat32 related values

14	bytes cwd$

	byte	f?


	*** DIRECTORY STRUCTURE ***
private
0	org	--- use relative offsets

8	res	fnam
3	res	fext
1	res	fatr		--- 5=archive,4=subdir,3=vol-label,2=system/fixed,1=hidden,0=readonly
1	res	00		\ MUST BE 00' user atrs
( 13)
1	res	fcms		\ create time 10ms
2	res	fctime
2	res	fcdate
2	res	fadate
2	bytes	fch		--- no actual bytes in memory - just the label
2	bytes	ftime
2	bytes	fdate
2	bytes	fcl
4	bytes	fsize

	!org --- reset org back to previous
public
BUFFERS		:= SDBUF	--- sector buffers

pri !SDBUF				SDBUF $800 ERASE ;


pri SDBUF+ ( offset -- adr )		SDBUF + ;

pub SDCK ( -- ck )			2 COG@ ;
pub SDDI ( -- di )			3 COG@ ;
pub SDDO ( -- do )			4 COG@
pub SDCS ( -- cs )			5 COG@ ;


pri SDSPI				&60.58.59.61 SPIPINS ;
--- set SD PINS
pub SDPINS				AT SDSPI :=! ;
pub !SDIO				AT SDSPI 2+ 4 ADO IC@ FLOAT LOOP ;	--- release SPI I/O to SD

pub SD? ( -- flg )
	SDSPI
	SDCS LOW 2 us SDCS FLOAT 5 us SDCS PIN@ SDCS HIGH
 	DUP ?EXIT mntd ~
	;

---					byte clocks
pri SDCLK				8 CLKS ; \ SDCK HIGH  ;
pri RELEASE				SPICE SDCLK SDCK HIGH !SDIO ;

pri SDCLK3				24 CLKS ;
--- clock SD for token but timeout false if not found
pri TOKEN ( marker -- flgX )
	AT SDSPI 3 + C@ HIGH
	10000 BEGIN OVER 0 SPIRD <> WHILE 100 us 1- DUP 0= IF NIP EXIT; THEN REPEAT
	2DROP TRUE
	;
\ pri !CRC				$95 sdcrc C! ;
pub CMD ( data cmd -- res )
	DUP sdcmd C!
---	setup SD pins for SPI and preclock
	SDSPI SDCLK
---	write cmd and 32-bits of data
	SPIWC SPIWL
---	send a crc of CMD8 or CMD0 - others ignore value
	sdcmd C@ IF $87 ELSE $95 THEN SPIWB
pri SDRES
---	  retry for read until <> $FF
	0 4000 FOR SPIRD >B DUP $FF <> ?NEXT DROP
	;
pub ACMD ( data acmd -- res )
	0 55 CMD DROP CMD
	;
pri DAT?
	SDRES $FE =
	;

pri SDSTAT ( -- stat )	16 CLKS 0 13 CMD SDRES 8<< OR ;

pri SDDAT! ( adr -- ) --- read info into memory
	$FE TOKEN IF DUP 16 ADO 0 SPIRD I C! LOOP SDCLK3 THEN DROP
	;


--- CSD BIT FIELDS ---

pri XSHR
	FOR
	0 bitbuf 16
	  ADO IC@ DUP 2/ ROT OR I C!
	    1& IF $80 ELSE 0 THEN
	  LOOP
	 DROP
 	NEXT
	;

pri CSD@
	csd
pri BITS@	( bith bitl adr -- dat )
	bitbuf 16 CMOVE
 	DUP XSHR - 1+ |<
	1-
	0 bitbuf 12 + 4 ADO 8 << IC@ OR LOOP
	AND
	;

--- init SD card into SPI mode
pri !SD!
	sdcmd C~~ 5 FOR 0 0 CMD 1 = ?NEXT 0EXIT
---	check operation conditions
	5 FOR $1AA 8 CMD 1 = ?NEXT 0EXIT
	0 SPIRL $1AA = 0EXIT
---	Issue ACMD 41 with slow clocks
	0 1000 0 DO 30 |< 41 ACMD IF 200 FOR SDCK HIGH 2 us SDCK LOW 2 us NEXT ELSE 1+ LEAVE THEN LOOP 0EXIT
---	operation conditions (voltages) note: spec says do this before acmd41 but does not work
	0 58 CMD ?EXIT 0 SPIRL DUP ocr ! 0EXIT
---	card information
	0 10 CMD 0= IF cid SDDAT! THEN
---	card specific data
	0 9 CMD 0= 0EXIT csd SDDAT!
	;

pub !SD ( --- ocr|false )
---	setupSD pins and reset variables and buffer
	SDSPI sdvars sdsz ERASE	!SDBUF readsect ~~
	SD? IF
	  SDCLK3 20 FOR
---	    attempt init and check if last operation was 9
	    !SD! sdcmd C@ 9 = DUP 0= IF 50000 CLKS THEN
	  ?NEXT
	  DROP SPICE 800 CLKS
	  69 48 CSD@ 1+ 10 <<   sdsize !
	THEN
	ocr @
	;


		--- CARD INFO ---

pri .LINE	CRLF 4 SPACES DUP PRINT$ LEN$
pri .LINE@	32 - ABS '.' SWAP EMITS SPACE ;
pri .***	SPACES ." ***" SPACE ;
pri .TITLE	CRLF CRLF 20 OVER LEN$ 2/ - .*** PRINT$ 1 .*** ;

pri .MFG
	SWITCH
	1 CASE   ." PANASONIC" BREAK
	2 CASE   ." TOSHIBA  " BREAK
	3 CASE   ." SANDISK  " BREAK
	$1B CASE ." SAMSUNG  " BREAK --- PROGRADE
	$1D CASE ." AData    " BREAK
	$27 CASE ." PHISON   " BREAK --- AgfaPhoto, Delkin, Integral, Lexar, Patriot, PNY, Polaroid, Sony, Verbatim
	$28 CASE ." LEXAR PNY" BREAK
	$31 CASE ." SILICON POWER " BREAK
	$41 CASE ." KINGSTON " BREAK
	$74 CASE ." TRANSCEND" BREAK
	$76 CASE ." PATRIOT  " BREAK
	$82 CASE ." SONY     " BREAK
	CASE@  ."  UNKNOWN" .B
	;

pub .CID
	."  CARD: "
pri .CARD
	cid C@ .MFG
	SPACE cid 1+ 2 CTYPE
	SPACE cid 3 + 5 CTYPE
	."  REV" cid 8 + C@ .B
	."  #" cid 9 + @ U.
	."  DATE:" cid 14 + C@ cid 13 + C@ >N 8 << + DUP 4 >>  2000 + . >N .AS" /*|"
	cid 15 + C@ 1& ?EXIT
	."  BAD CID "
	;


private
0 TABLE ma	0 | 1 | 5 | 10 | 25 | 35 | 60 | 100 | 1 | 5 | 10 | 25 | 35 | 45 | 80 | 200 |

\ Card information
pri .ma		ma + + C@ ?DUP IF .DECL ELSE ." 0.5" THEN ." ma" ;
pri .CURRENT
	  " Iread Vmin" .LINE	61 59 CSD@ 0 .ma
	  " Iread Vmax" .LINE	58 56 CSD@ 8 .ma
 	  " Iwrite Vmin" .LINE	55 53 CSD@ 0 .ma
	  " Iwrite Vmax" .LINE	52 50 CSD@ 8 .ma
	  ;


pri .xs ( ns -- )
	DUP 1 M => IF 1 M / .AS" #~#ms" EXIT THEN
	DUP 1,000 => IF 1,000 / .AS" #~#us" EXIT THEN
	.AS" #~#ns"
	;

private
0 TABLE tval
	&13.12.10.00 ,
	&30.25.20.15 ,
	&50.45.40.35 ,
	&80.70.60.55 ,

pri TACC ( -- ns )
	119 112 CSD@ --- b6..3=tval b2..0=tru
	DUP 3 >> tval + C@ ( *10)
	SWAP 7 AND 1 SWAP 1+ FOR 10 * NEXT 100 / *
	;
pri .TACC
	" LATENCY" .LINE
 	TACC .xs
	119 112 CSD@ ?DUP 0EXIT 100 * .AS" +*|# clocks "
	;

pri .TRANS
	" SPEED" .LINE
	103 96 CSD@ .AS" ##MHz "
	;
pub .CSD
	sdhc C~
	" CSD" .TITLE
	127 126 CSD@
	IF
	  " CARD TYPE" .LINE 	." SDHC" sdhc C~~
	  .TACC  .TRANS
	  " CLASSES" .LINE 	95 84 CSD@ 20 << REV 12 .BITS
 	  " BLKLEN" .LINE	83 80 CSD@ DUP blklen C! |< .DECL
---	                                    total sectors
	  " SIZE" .LINE  	sdsize @ 2000 U/ .DECL ." MB"
	  .CURRENT
	  EXIT;
	THEN
	."  NOT SDHC!"
	;

pub .OCR
	" OCR" .TITLE
	" VALUE" .LINE ocr @ .L ( $C0FF_8000 )
	ocr @ 30 >> 3 <> IF ."  invalid!" THEN
	" RANGE" .LINE
	27 ocr @ 15 >> $1FF AND BEGIN DUP 1& 0= WHILE 2/ b++ REPEAT OVER .AS" #.#V to "
	BEGIN DUP 1& WHILE 2/ b++ REPEAT DROP .AS" #.#V"
	;


--- FILE PERMISSIONS ---


pub RO		0		--- Read only - write protected
pri wm		wrens C! ;
pub RW		1 wm ;		--- Read/Write access - write enabled
pub RWC		3 wm ;		--- Read/Write & create
pub RWS		7 wm ;		--- Read/Write/System permission
pri RW?		1 wrens SET? ;

pri B>S ( bytes -- sectors )	L>S SWAP IF 1+ THEN ;


		*** SD CARD MEMORY ACCESS ***

pri SDWR?	@sdwr @ ;

pub SDWR ( src sect --  )
	@sdwr ~
---	never sector 0 or if write protected unless RWS used
	DUP 0<>	 RW? AND 4 wrens SET? OR
	IF
---	 sector write command
	 SDCLK3  24 CMD
	  IF DROP
---		    start token, data
	  ELSE SDCLK3 $FE SPIWB 512 SPITX
---	    read data response
	    0 TOKEN $FF TOKEN AND
	  THEN
---	 always reset any RWS permissions after op - set crc in sdwr
	  4 wrens CLR   @sdwr ! RELEASE
	BREAK
---	else write protect fail
	2DROP
	;

--- SD WRTIE MULTIPLE SECTORS
pub SDWRS ( ram sector bytes -- )
	@sdwr ~ RW?
	IF
	  B>S --- convert bytes to sectors
	  ADO
	    DUP I SDWR 512 + SDWR? 0= ?LEAVE
	  LOOP
	  DROP RELEASE
	BREAK 3DROP
	;

--- only flush sector if it has been written to
pub ?FLUSH
	wrflg C@ 0EXIT
pub FLUSH
	SDBUF readsect @ SDWR wrflg C~
	;

pri SDRDBLK ( dst -- crc/flg )
	512 SPIRX sdsum !
	0 SPIRD SPIRD 31 |< OR
	;

pub SDRD ( sector dst --  ) --- read sector into memory and update sector number
	OVER readsect !
pub SDRDX ( sector dst -- ) --- read sector into memory silently
	SDCLK SWAP 17 CMD DUP 0=
	IF DROP DAT?
	  IF SDRDBLK ELSE SDSTAT 2DROP 0 THEN
	THEN
---	save crc as a flag  -- only lower 16-bits of seccrc = crc with flag in b31
	DUP @sdrd ! seccrc !
	RELEASE
	;


pri SDWAIT --- wait for data token with timeout (only used in SDRDS)
	1000 BEGIN 1- DAT? OVER 0= OR UNTIL 0=
	;

--- read multiple sectors in continuous multiblock mode -- update @sdrd pointer
pub SDRDS ( sector dst bytes --  )
---	convert bytes to sectors
	B>S
---	multiblock read
	-ROT SWAP 18 CMD
	IF --- command not accepted
	  2DROP FALSE
	ELSE ( sectors dst )--- process read token and read block if available '
	  DAT?
	  IF --- data available, read in a block
	    SWAP FOR DUP SDRDBLK DROP 512 + SDWAIT ?NEXT
	  ELSE --- no more data available, terminate
	    2DROP SDSTAT DROP SPICE FALSE
	  THEN
	THEN
---	update the read index
	RELEASE  @sdrd !
---	cancel multiblock read on error
	  2000 BEGIN 1-   0 12 CMD 0=   OVER 0=   OR UNTIL DROP
	RELEASE
	;

pub SECTORF ( sect -- sdbuf )
	?FLUSH SDBUF SDRD	\ 2048 SDRDS
	SDBUF
	;

--- S>M
pub SECTOR ( sect -- sdbuf )
	DUP readsect @ <> IF SECTORF EXIT; THEN
	DROP SDBUF
	;


--- return starting sector at current FILE
pub @FILE ( -- sector )			filesect @ ;
pub @OPEN ( -- sector )			opensect @ ;

--- Convert SD file address to hub ram address where file is buffered
pub SDADR ( sdadr -- ramadr )		L>S @FILE + SECTOR + ;

--- fetch long from SD virtual memory in current file
pub SD@ ( xaddr -- long )		SDADR @ ;
pub SDW@				SDADR W@ ;
pub SDC@ ( sdaddr -- byte )		SDADR C@ ;

--- store long to SD virtual memory in current file
pub SD! ( data xaddr -- )		SDADR ! wrflg C~~ ;
pub SDC!				SDADR C! wrflg C~~ ;

pub SD				' SDC@ ' SDW@ ' SD@ DUMP! ;



--- at ROOT sector
pub @ROOT ( -- sector )			rootdir @ ;
pub @CWD				cwdir @ ;
pub CWD!				cwdir ! ;

--- at BOOT sector
pub @BOOT ( -- sector )			parts 8 + @ ;
pri @FAT ( fat# -- sector )		s/f @ * @BOOT rsvd W@ + + ;

pri FATSZ ( -- fatsz )			sdsize @ @BOOT - ;


--- open ROOT sector as a file

pub ROOT				" /" cwd$ $! @ROOT CWD!
pub CWD 				@CWD
pub OPEN-SECTOR				_fread ~ filesect ! ;


--- Close file by flushing, switching to read-only and use sector 0
pub CLOSE-FILE
pub FCLOSE				FLUSH RO 0 OPEN-SECTOR readsect ~~ ;


--- change current working directory
pub CD# ( sect -- )			cwdsect ! ;


		*** CLUSTERS ***


pub FAT1				fat1 @ OPEN-SECTOR ;
pub FAT2				fat2 @ OPEN-SECTOR ;


pri @CLUSTER ( index -- xadr )		FAT1 4* ;

pri CLUSTER@ ( index -- cluster )	@CLUSTER SD@ ;


pri FreeClusters? ( size -- #clusters clust1 )
	--- calculate clusters required
     B>S s/c C@ U/ ( clusters )
      0
     BEGIN
       --- find a free cluster
       BEGIN DUP CLUSTER@ WHILE 1+ REPEAT
       --- check for sufficient contiguous clusters ( clusters index )
       0 OVER 3RD ADO I @CLUSTER SD@ OR DUP IF NIP I SWAP LEAVE THEN LOOP
       ( clusters chain flag )
     WHILE
       1+
     REPEAT
     ;



--- count number of clusters allocated from start cluster
pub #C 	( cluster# -- clusters )
---	backup current sector
	filesect @ >L
--- scan through fat1 as a file
	FAT1
	0 SWAP BEGIN b++ 4* SD@ DUP $0FFF_FFF8 => UNTIL DROP
---	restore sector
	L> OPEN-SECTOR
	;

pub I>D ( dirIndex -- diradr )
	CWD 5 << SDADR
	;


--- Convert Directory address to first cluster
pub D>C ( diradr -- cluster#0 )
---	cluster low and cluster high
	fcl OVER+ W@ SWAP fch + W@ W>L
	;

--- Convert Directory address to starting sector
pub D>S ( diradr -- sector )
	D>C
--- Convert Cluster to sector
pub C>S ( clust# -- sector )
	rootcl @ -
pri C>S2
	s/c C@ * @ROOT +
	;

--- convert a sector to a cluster ( result 0 = out of range  ; 2 = 1st )
pub S>C ( sector -- cluster )
	@ROOT - s/c C@ U/ 2+
	;

--- convert sector to total allocated clusters
pri S>C# ( sector -- clusters )
	S>C #C s/c C@ * 9<<
	;

pub I>S ( dirIndex -- sector )
	I>D D>S
	;

--- find the directory entry that matches the file sector ( 2.3us @120MHZ for entry #30)
pub S>D ( sector -- diradr )
	0 BEGIN DUP I>D C@ WHILE DUP I>D D>S 3RD = IF NIP I>D EXIT; THEN 1+ REPEAT
	2DROP 0
	;

--- read the file size of the open file from its directory entry
pub @FSIZE ( -- adr )
	@OPEN S>D 28 +
	;

pub FSIZE@	@FSIZE @ ;


pri ?FREE
---	Calculate used/unused
	0 0 usedcl 12 ERASE
	sdsize @ @ROOT - ( data-sectors )
	s/c C@ U/ ( data-clusters ) 2+ ( where root is cluster 2 )
	2 DO I CLUSTER@ IF b++ ELSE 1+ THEN LOOP
	2DUP + 3RD 10000 * SWAP U/
	used% ! freecl ! usedcl !
	;

pub GETFAT
---	read fat32 as a byte array
	@BOOT SECTORF fat32 90 CMOVE
---	sectors rsvd to fat1  ... size of fat tables
	rsvd W@                s/f @ fats C@ *  + ( offset from fat boot )
\	rootcl @ 2- C>S2
	hidden @ + 	rootdir !
---	'' save time by precalculating FAT table addresses
	0 @FAT fat1 ! 1 @FAT fat2 !
	\ ?FREE
---	Open info sector
	@BOOT infosect W@ + OPEN-SECTOR
	$1E8 SD@ freeclusters !
	$1EC SD@ lastcluster !
	;



pub MOUNT
	SD? 0EXIT !SD DROP !SD DROP !SD 0EXIT
	0 SECTORF $1FE + W@ $AA55 <> " INVALID PARTITION" ?ERROR
	$1BE SDBUF+ parts 66 CMOVE
	fat32 fatsz ERASE
	RO --- disable sector sdwr
	GETFAT
	ROOT serial @ mntd !
--- PRINT CID AS CONFIRMATION
	.CID
	1 MB mksiz !
	;
---	MOUNT FAT32 if not already mounted
pub ?MOUNT
	SD? serial @ mntd @ = AND mntd @ 0<> AND 0=
	  IF 10 ms MOUNT ( $0D KEY! ) ELSE SD? 0= IF mntd ~ THEN THEN
	;
pub MOUNTED?
	?MOUNT mntd @
	;

		*** DIRECTORY ***

pri @FNAME ( -- hubadr )
	0
pri @DIR ( offset -- hubadr ) --- return with the indexed directory plus offset in hub RAM
	I 5 << + CWD SDADR
	;

pub .NAME
	@FNAME 8 CTYPE
	8 @DIR C@ $20 <> IF '.' EMIT 8 @DIR 3 CTYPE EXIT; THEN
	SPACE
pri GAP	3 SPACES
	;

pub .DECX ( num ch -- )		EMIT .AS" ##" ;
pub .DATE
	fdate @DIR DUP W@ DUP 9>> 1980 + .DEC4
	5 >> >N '-' .DECX $1F AND '-' .DECX
	ftime @DIR W@ DUP 11 >> $20 .DECX
	5 >> $3F AND ':' .DECX
	;



--- Print dir entry rg+1=mode
pri .ENTRY
	8 f? SET? IF CRLF I .AS" ##\#: " THEN
	.NAME SPACE 8 f? SET? ( ls or dir ? )
	IF
	  11 @DIR C@ DUP .BYTE SPACE 8 AND 0=
	  IF
---	 $0000_9678   2018-12-24 02:56
	  @FNAME D>S .L GAP .DATE
---	 display file size
	  SPACE 28 @DIR @ DUP 14 .DECS
\	  100,000,000 U< DUP 1& . 0EXIT
	  27 >> ?EXIT
	  ."  /" @FNAME D>S S>C# 14 .DECS
	  EXIT

---	 display file header
	    GAP @FNAME D>S 512 SDBUF+ SDRDX
	    512 SDBUF+ 20 ADO IC@ .EMIT LOOP
	    EXIT
	  THEN
	THEN
	fq C++ fq C@ 7 AND ?EXIT CRLF
	;

pub DIR
	8
pri .DIR
	f? W! MOUNTED? 0EXIT
---	scan root directory from start sector for max dir entries of 1 cluster? (index)
	0 s/c C@ 4 <<
	ADO
---	  Look for a valid dir entry and print it '
	  @FNAME C@ $20 $7E WITHIN IF .ENTRY THEN
	LOOP SPACE
	;

pub DIRW
	CRLF 0 .DIR
	;




pri .FYEAR ( fdate -- )
     9>> #1980 + SPACE .DEC4
     ;

IFNDEF .ASMONTH
pri .ASMONTH ( index -- )
     >N 1- 3 *
     " JanFebMarAprMayJunJulAugSepOctNovDec" + 3 CTYPE
     ;
}
pri .FDATE ( fdate -- ) --- print date in Unix format
     DUP 5 >> .ASMONTH                            --- extract day of the month to index into name string
      ( date )
      $1F AND 3 U.R                        --- day of the month
     ;
pri .FTIME ( ftime -- )
      DUP 11 >> .DEC2 ':' EMIT
      5 >> 6 BITS .DEC2
     ;


pub .FNAME ( --- )
     IC@ $20 >                            --- skip invalid index/entry
     IF
       $10 11 I+ SET? IF '[' EMIT THEN
       11 0 DO
         J I+ C@ DUP $20 > IF I 8 = IF '.' EMIT THEN DUP EMIT THEN DROP
       LOOP
       $10 11 I+ SET? IF ']' EMIT THEN
     THEN
;

pri ACTIVE? ( -- flg )	seccrc @ $8000.0000 <> ;

byte  lscnt

word udir

pri (DIR) ( code -- )
    ?MOUNT
     CRLF volname 11 CTYPE
pub (SLIST) ( method -- )
    udir W!
     FCLOSE
    @ROOT s/c C@            	--- scan and list rootdir by sector up to one cluster long
    ADO
       I SECTOR DROP
       ACTIVE?
       IF
         SDBUF 512                 	--- scan the buffer for dir entries
         ADO                    	--- up to 16 dir entries/sector
           11 I+ C@ $0F >            	--- accept only valid entries
           IC@ $80 < AND            	--- but ignore if 1st character has 8th bit set
           IC@ '?' <> AND            	--- ignore "deleted" entries
            IF udir W@ CALL THEN        --- all good, list this one using the directed method
         32 +LOOP                    	--- next dir entry 32 bytes (assumes standard 8.3)
       ELSE
         LEAVE                    	--- no more dir sectors - leave loop
       THEN
    LOOP
    ;

--- List a single directory entry in FTP compatible format
pri (.LIST) ( <index> )
      PRINT" -rwxrwxrwx 1 502     500"				--- dummy permissions
      I fsize + @ .AS"  9|\# "	--- print file size "1048576"
      I fdate + W@ .FDATE					--- DATE "24"
--- most systems expect either the time or the year if it is older than 6 months
       2 SPACES I ftime + W@ .FTIME
       SPACE .FNAME CRLF						--- FILE NAME "LOG0001.TXT"
    ;

pub .LIST        AT (.LIST) (SLIST) ;				--- set list method



pre ls
     delim 1+ C@ $20 =
     IF
       GET$ " -l" $=
       IF CRLF .LIST EXIT; THEN
     THEN
     lscnt C~ AT DIRW (DIR)
    ;





--- Load text input from a sector
pub FLOADS ( sector -- ) --- load file as console input then restore on null to console input '
	OPEN-SECTOR ukey W@ _fkey W!
	KEY:
pub FGET ( -- ch ) --- Read the next byte from the file
	_fread @ SDC@ DUP
	  IF _fread ++ EXIT THEN
	_fkey W@ ukey W! _fkey W~
	;

--- Read file offset to memory
pub FREAD ( sdsrc hubdst bytes -- )
	4 ALIGN ADO DUP SD@ I ! 4+ 4 +LOOP DROP
	;
--- Write memory to file offset
pub FWRITE ( hubsrc sddst bytes -- )
	4 ALIGN ADO DUP @ I SD! 4+ 4 +LOOP DROP
	;




public --- 8.3 directory entry structure
0 bytes dirbuf
private
8 bytes -fname
3 bytes -ext
1 bytes -atr		---  (0:read-only, 1:hidden, 2:system, 3:volume label, 4:directory, 5:archive, 6-7: undefined)
1 res 0
1 bytes -fcms
2 bytes -fctime
2 bytes -fcdate
2 bytes -fadate
2 bytes -fclsth
2 bytes -ftime
2 bytes -fdate
2 bytes -fclstl
4 bytes -fsize

public
16 bytes file$

pri GETF$
	GET$
pub >F83 ( str -- buf )
	DUP file$ $!
	dirbuf $20 ERASE
	-fname 12 $20 FILL
---	str buf
	-fname OVER LEN$ 0 DO
	  OVER I+ C@ a>A
	  DUP '.' = IF 2DROP -ext ELSE OVER C! 1+ THEN
	LOOP
	2DROP -fname
	;

pub FOPEN# ( index -- )
	I>D D>S OPEN-SECTOR
	;

pri FFIND ( -- sdrel )
	0 s/c C@ 4 << ( total possible entries )
	0 DO
	  I I>D C@
	  IF I I>D -fname 11 C$= IF DROP I I>D DUP dirbuf 32 CMOVE LEAVE THEN
	  THEN
	LOOP
	;




pri FreeDir? ( --- faddr )
	CWD 0 BEGIN DUP SDC@ WHILE 32 + REPEAT
	;


---
pri ClaimClusters ( for from -- from )
     FAT1 \ RW
     DUP 3RD ADO 1 I+ I @CLUSTER SD! LOOP					--- link clusters
     ( #clusters clust1 )
     SWAP OVER+ 1- $0FFFFFFF SWAP @CLUSTER SD!					--- mark end cluster
     FLUSH
     ;


pre mk  [G] GET$
pub mk$ ( size namestr --  )
	dirbuf $20 ERASE
	--- as 8.3 and write the name of the file to the directory buffer
	>F83 dirbuf 11 CMOVE
	--- set archive attribute
	$20 -atr C!
	--- stamp create date and time
\	DATE@ @CDATE FDATE! TIME@ @CTIME FTIME!
	--- Set size of file to maximum & preallocate clusters
		DUP -fsize ! FreeClusters? ClaimClusters
	--- write first cluster
	CWD L>W -fclsth W! -fclstl W!
\	FSTAMP
	--- add directory record to directory
	FreeDir? DUP ( xadr ) SDADR ( bufptr )
	--- write directory entry
	dirbuf SWAP 32 CMOVE FLUSH

     ;


--- Force file open  - create to size of it not found
pub MAKE ( size -- )	mksiz ! RWC ;


pub FOPEN$ ( str -- flg )
	>F83 DROP
pub REOPEN-FILE
---	check mount and find 8.3 file name
	?MOUNT	FFIND ?DUP
---	if found then convert directory entry to starting sector
	IF D>S
	ELSE
---	else if create flag set then create a preallocated size file  - else fail
	  2 wrens SET? IF mksiz @ file$ mk$ D>S  ELSE 0 THEN
	THEN
---	open the sector although 0 = fail (mbr sector 0 is protected anyway)
	OPEN-SECTOR
	@FILE DUP opensect !
	;

--- File Open using name in stream - use @FILE to return file sector handle which is 0 if not open
pre FOPEN ( <name> -- )
---	execute any preceding code which may be permissions or options, then get string from console
	[G] GET$ SPACE
	FOPEN$ ?DUP IF PRINT" Opened @" PRINT ELSE PRINT" not found " THEN
	;

ALIAS FOPEN$ OPEN-FILE$
ALIAS FOPEN OPEN-FILE


pre cwd ( <dir> -- )
pre CD
	[C] FOPEN @FILE CWD!
	file$ cwd$ $!
	;


pub pwd		cwd$ PRINT$ ;



pre FLOAD ( <name> -- )
	[C] FOPEN @FILE FLOADS
	;

pre RENAME# ( dir# <new> -- )
	[G] GETF$ CWD SWAP 5 << SDADR
pri RENAME!
	11 CMOVE FLUSH
	;

pre RENAME ( <old> <new> -- )
	GETF$ DROP FFIND DUP
	  IF GETF$ SWAP RENAME! BREAK
	.SUCCESS
	;

pre cat
	[C] FOPEN \ 0 SD PRINT$
	@FILE 0EXIT
	0 0 BEGIN OVER SDC@ KEY $1B <> AND WHILE
	OVER SDC@ $0A = IF DUP $0D <> IF CR THEN ELSE DUP $0D = IF $0A EMIT THEN THEN
	DROP DUP SDC@ DUP EMIT
	b++
	REPEAT
	2DROP CRLF
	;

pre QV
	[C] FOPEN 0 SDADR $80 DUMP
	;










		*** DISK REPORTING ***

pub *DISK*	PRINT" SD DISK REPORTING & FORMATTING TOOLS 190800-0000" ;

pri .SPD ( offset sector -- )
	CNT@ 8 FOR OVER SDBUF SDRD NEXT
	CNT@ - ABS 3 >> CLKMHZ U/ ROT - .AS" *|#us" DROP
	;
pub .SPEEDS
	" SPEEDS" .TITLE
 	CNT@ SDBUF SDRDBLK DROP CNT@ - ABS CLKMHZ U/ ( readspeed )
	" LATENCY" .LINE 8 FOR DUP I 20 << .SPD ',' EMIT NEXT DROP

---				  Up to 4GB print sector speed in 0.5GB increments
	" SECTOR" .LINE 8 FOR 0 I 20 << .SPD ',' EMIT NEXT
---	Read a 256k block into unused memory
	" BLOCKS" .LINE 0 $8.0000 $4.0000 LAP SDRDS LAP
---	Report the equivalent multi-block read speed
	CLKHZ $4.0000 1000 / LAP@ U*/ .DECL ." kB/s @" .CLK
	;

pub .SD
	.CID .OCR .CSD .SPEEDS
	;

		*** PARTITIONS ***

--- Check file system type and return with known name
pri ?FS ( n -- str/flg )
	SWITCH
	11 CASE " FAT32 CHS" BREAK
	12 CASE " FAT32 LBA" BREAK
	7 CASE " exFAT?" BREAK
	6 CASE " FAT16" BREAK
	FALSE
	;

--- Print Cylinder Head Sector
pri .CHS ( xxcccshh -- )
	24 BITS
	DUP 16 >> OVER 14 >> 3 AND 8 << + PRINT ',' EMIT
	DUP >B PRINT ',' EMIT
	8>> $3F AND PRINT
	;



pub FORMAT.MBR
	!SDBUF
---	copy boot config table for reference in unused area at start
	0 SDBUF $100 CMOVE
	parts 66 ERASE
---	valid partition flags
	$AA55 parsig W!

\	$80 parts C!
---	fs+CHS
	$0CFFFFFE parts 1+ !
--- This sets up 4MB hiddenbefore parition according to SD compliance (But >32GB 16MB)
	sdsize @ 70,000,000 U> IF $8000 ELSE $2000 THEN  parts 8 + !
---	TOTAL SECTORS = SDSIZE-<hidden>
	FATSZ parts 12 + !
---	copy parts to buffer
	parts $1BE SDBUF+ 66 CMOVE
---	Write MBR
	RWS SDBUF 0 SDWR
	;

pri .MBS ( adr -- )
	@ DUP .DECL ."  = "
pub .MB ( sectors -- )
	512 1,000 U*/
	DUP 1,000 U<
	IF .DECL ." kB"
	ELSE 1,000 U/ .DECL ." MB"
	THEN
	;

pub .MBR
	" MBR" .TITLE
---	Scan all 4 antries : check active partition type
	4 0 DO I 4 << parts + DUP 4+ C@
	  IF
	    " PARTITION" .LINE I PRINT SPACE DUPC@ DUP .BYTE SPACE 0= IF ." IN" THEN ." ACTIVE"
	    " FILE SYSTEM" .LINE DUP 4+ C@ ?FS ?DUP IF PRINT$ ELSE ." UNFORMATTED " THEN
	    " CHS START" .LINE 1+ DUP @ .CHS
	    " CHS END" .LINE 4+ DUP @ .CHS
	    " FIRST SECTOR" .LINE 3 + DUP @ .L
	    " TOTAL SECTORS" .LINE 4+ .MBS
	    CRLF
	  ELSE DROP
	  THEN
	LOOP
	0 OPEN-SECTOR $170 16 SD DUMPL
	;

pri CLSZ ( bytes -- )
	DUP 0= IF DROP FATSZ 10 >> THEN
---	limit 512..64k      binary multiple scaled
	512 MAX 64KB MIN    >| |< 9>>  >!
pri #s/c
	64
	;

pri !FSINFO
	!SDBUF
	" RRaA" SDBUF $!
	" rrAa" $1E4 SDBUF+ $!
	-1 $1E8 SDBUF+ !
	2 $1EC SDBUF+ !
	$AA55 $1FE SDBUF+ W!
---	update file information sector
	SDBUF @BOOT 1+ SDWR
	;

pri !FATX
	!SDBUF
	$0FFF_FFF8 DUP 0 SDBUF+ ! 8 SDBUF+ !
\	$0FFF_FFFF 4 SDBUF+ !
	-1 4 SDBUF+ !
	RW s/f @ ADO SDBUF I SDWR !SDBUF SPINNER LOOP
	;

pub !FATS
	fat1 @ !FATX
	fat2 @ !FATX
	;

pub FORMAT.FAT
	fat32 fatsz ERASE
---	jump code (redundant?)
	$905BEB fat32 !
---	name of formatting system
	" TAQOZ P2" oemname $!
	512 b/s W!
	#s/c 0= IF 0 CLSZ THEN #s/c s/c C!
---	RESERVED ??? check
\	#s/c 8 + rsvd W!	( should this be set to a constant 32? )
	32 rsvd W!
	2 fats C!
	$F8 media C!
	@BOOT hidden !

---	sectors/track
\	#s/c media 3 + W!
	$3F media 3 + W!
---	number of heads
\	#s/c 2* media 5 + W!
	$FF media 5 + W!
---	sectors/partition = sectors/sd - hidden
	FATSZ DUP s/p !

---	calculate sectors/fat +  fudge

	sdsize @ @BOOT - #s/c >| 7 + >> ( #s/c 2/ +  )    s/f !
\	#s/c >| 7 + >>          #s/c 2/ +     s/f !
	0 fat? !		--- clear fat flags and fatver (4 bytes)
	2 rootcl !
	1 rootcl 4+ W!		--- partition info sector
	6 bbsect W!		--- backup boot sector
	128 ldn W!		--- logical drive#
	$29 extsig C!
	RND serial !
---	 Volumne name FAT name
	" P2 CARD    FAT32   " volname 19 CMOVE
---
	@BOOT rsvd W@ + DUP fat1 !  s/f @ + fat2 !
---	update buffer with our copy of FAT
	!SDBUF fat32 SDBUF 96 CMOVE
	$AA55 $1FE SDBUF+ W!
---	write FAT32 boot sector
	SDBUF @BOOT SDWR
---	write backup boot sector
	SDBUF @BOOT 6 + SDWR
---	then info sector
	!FSINFO
---	and init and zero all the FAT entries (takes a while)
	!FATS
	;

pri .res	" res" .LINE  ;
pri .PS		SWAP .LINE rootcl + W@ DUP .W ."  = " @BOOT + .L ;


pub .FAT --- print FAT32 BOOT RECORD
	parts 4 + C@ ?FS 0= " FORMAT" ?ERROR
	  " FAT32" .TITLE
	  " OEM" .LINE oemname 8 CTYPE
	  " Byte/Sect" .LINE b/s W@ DUP PRINT
	  " Sect/Clust" .LINE s/c C@ DUP PRINT ."  = " * ( 1000 * ) .MEM
\	  .res s/c 1+ 2 .BYTES
	  " FATs" .LINE fats C@ PRINT
\	  .res fats 1+ 4 .BYTES
	  " Media" .LINE media C@ .BYTE
\	  .res media 1+ 2 .BYTES
	  " Sect/Track" .LINE media 3 + W@ .W
	  " Heads" .LINE media 5 + W@ .W
	  " Hidden Sectors" .LINE hidden .MBS
	  " Sect/Part" .LINE s/p .MBS
	  " Sect/FAT" .LINE s/f .MBS
	  " Flags"  .LINE 8 fat? SET? IF ." Mirroring to" THEN fat? C@ >N PRINT
	  " Ver" .LINE fat? 2+ 2 .BYTES
	  " ROOT Cluster" .LINE rootcl @ .L ."  SECTOR: " rootdir @ .L
	  " INFO Sector"  4 .PS
	  " Backup Sector"  6 .PS
	  .res rootcl 8 + 12 .BYTES
	  " Drive#"  .LINE ldn C@ PRINT --- Should be 0 or 128
	  " Ext sig" .LINE extsig C@ DUP .B $29 = .OK
	  " Part Serial#" .LINE serial @ DUP .L ."  #" U.
	  " Volume Name" .LINE volname 19 CTYPE
	\  " FAT Name" .LINE  volname 11 + 8 CTYPE
	;

pub .FREE
	?FREE
	" FREE" .line freecl @ s/c C@ * .MB
	" USED" .LINE usedcl @ s/c C@ * .MB
	used% @ .AS"  (##.##%) "
	;


pub .DISK	.SD  .MBR .FAT ;

--- erase root directory cluster
pub FORMAT.ROOT
	!SDBUF RW
---	populate with a single volume entry
	" ROOTDIR    " SDBUF $! 8 11 SDBUF+ C!
	@ROOT s/c C@ ADO SDBUF I SDWR !SDBUF LOOP
	;

pub FORMAT
	wrens C@ 7 = !SD AND
	IF
	  FORMAT.MBR
	  FORMAT.FAT
	  GETFAT
 	  FORMAT.ROOT
	  MOUNT .DISK
 	ELSE
	  ."  FAILED!"
	THEN
	0 CLSZ	--- reset default cluster size
	;






	--- Old style Forth disk block ---

pub .BLOCK ( blk# -- )
	CRLF ." BLOCK " DUP .
	10 << $400 ADO I $3F AND 0= IF CRLF THEN
	  I SDC@ DUP $20 $7E WITHIN 0= IF DROP '.' THEN EMIT
	  LOOP
	;

long bn
pri .EDIT	CLS PRINT" FILE: " file$ PRINT$ ;
pri VK
	KEY a>A SWITCH
	',' CASE -1 bn +! TRUE BREAK
	'.' CASE 1 bn +! TRUE BREAK
	'<' CASE -10 bn +! TRUE BREAK
	'>' CASE 10 bn +! TRUE BREAK
	$1B CASE R> DROP BREAK
	'H' CASE CLS .EDIT bn @ 10 << $400 SD DUMP FALSE BREAK
	$0D CASE bn ! 0 TRUE BREAK
	$08 CASE DROP 0 FALSE BREAK
 	CASE@ '0' '9' WITHIN IF 10 * CASE@ '0' - + CR DUP . 8 SPACES FALSE BREAK
	FALSE
	;

pub EDITBLOCK ( blk -- )
	bn ! 0 BEGIN
	  .EDIT
	  bn @ DUP .BLOCK 1+ .BLOCK CRLF DUP . 8 SPACES
	  BEGIN VK UNTIL
	AGAIN
	;


pub LISTBLOCKS
	0 BEGIN DUP SDC@ KEY 0= AND
	WHILE
	DUP .BLOCK 1+
	REPEAT
	DROP
	;



pri BIX			" _BOOT_P2.BIX" ;
pri MBR! ( sig -- ) 	FCLOSE RWS  $17C SD! ;

--- Backup to filename or FLASH : options: DISABLE, FLASH, MBR, BIX
pre BACKUP
	GET$
pub BACKUP$ ( " MBR" BACKUP$ )
	VEC0 0 !
	DUP UPPER$
\	SPACE NFA' END 8 + $1.0000 OVER - ERASE
	DUP " DISABLE" $= IF DROP 0 MBR! FLUSH ( BIX FOPEN$ @FILE IF RENAME THEN ) EXIT; THEN
	DUP " FLASH" $= IF DROP SFJID 1+ IF SFBU THEN SFJID 1+ .SUCCESS BREAK
	MOUNTED?
	IF
	DUP " BIX" $= IF DROP BIX THEN
	DUP " MBR" $=
---	    Create MBR signature and          point to sector 1 as 64k file       then open sector 1
	  IF --- backup to MBR      start       bytes
	    DROP " ProP" @ MBR!	    1 $174 SD! $2.0000 $178 SD! FCLOSE
---	    Use sector 1 in the hidden partition for the file
	    1 OPEN-SECTOR RW 0 @FILE $2.0000 RW SDWRS
	    RO SDWR? .SUCCESS EXIT
---	    else open the specified filename
	  ELSE FOPEN$
	  THEN
	  IF --- backup to file - including hidden file
	    RW 0 @FILE $F000 RW SDWRS
\	    $100 $300 ADO 0 I SD! 4 +LOOP 1 FLUSH
	    RO SDWR? .SUCCESS
	  BREAK
	THEN
	0 .SUCCESS
	;

--- BACKUP to SD MBR shortcut
pub BU		MOUNT " MBR" BACKUP$ ;


	*** I2C SUPPORT ***

ALIAS I2C.STOP I2C>
ALIAS I2C.RESTART <I2C>

pub i2cdev			$A4 ;
pub I2CRD? ( adr -- ack )	1 OR I2C.START I2C.WR 0= ;
pub I2CRD ( adr -- )		I2CRD? DROP ;
pub I2CWR ( adr -- ) 		1 ANDN I2C.START I2C.WR DROP ;
pub I2C! ( data -- )		I2C.WR DROP ;
pub I2C@ 			0 I2C.RD >B ;
pub nakI2C@			TRUE I2C.RD >B ;

pub I2CRDREG ( dev reg -- )	OVER I2CWR I2C! I2CRD ;


pub I2CC@			i2cdev I2CWR I2C!    i2cdev I2CRD ;
\ pub I2C				AT i2cdev C! DUMP: I2CC@ I2CC@ I2CC@ ;
pub I2C				AT i2cdev C! AT I2CC@ DUP DUP DUMP! ;

--- Set the I2C BUS FREQUENCY in kHz
pub I2C.KHZ ( khz -- )		1000 W* CLKHZ SWAP / 72 - 2 SAR 0 MAXS 8 COG! ;


	*** RV-3028 RTC ***

pub *RTC*			PRINT" RV-3028 RTC DATE and TIME 190800-0000" ;


pub RTC? ( -- flg )		$A4 I2CRD? ;

--- RTC BCD STORE - store byte as BCD in RTC register
pub RTCB! ( byte reg -- )	SWAP 10 U// 4 << OR SWAP
pub RTC! ( byte reg -- )	$A4
pub I2CREG! ( dat reg dev -- )	I2CWR I2C! I2C! I2C.STOP ;

pub RTC@ ( reg -- byte )	$A4
--- fetch reg from 8-bit reg addr
pub I2CREG@ ( reg dev -- dat )	DUP I2CWR SWAP I2C! I2CRD nakI2C@ I2C.STOP ;

$29 bytes rtcbuf
pub RDRTC ( bytes -- )			$A4 0 rtcbuf ROT4
pub I2CLOAD ( dev reg dst cnt -- )	2SWAP I2CRDREG ADO I2C@ I C! LOOP nakI2C@ DROP I2C.STOP ;

pub !RTC			( $BC ) $B4 $37 RTC! ;

\ pub RTC				DUMP: RTC@ RTC@ RTC@ ;
pub RTC				AT RTC@ DUP DUP DUMP! ;


pub UTIME@ ( -- secs )		0 27 4 ADO I RTC@ OR 8 ROR LOOP ; \ 27 RTC@ 28 RTC@ 8<< + 29 RTC@ 16<< + 30 RTC@ 24 << + ;
pub UTIME! ( secs -- )		27 4 ADO DUP I RTC! 8>> LOOP DROP ;

pub TIME! ( hhmmss -- )		!RTC 100 U// SWAP 0 RTCB! 100 U// SWAP 1 RTCB! 2 RTCB! ;
pub DAY!			7 AND 3 RTC! ;
pub DATE! ( yymmdd -- )		!RTC 100 U// SWAP 4 RTCB! 100 U// SWAP 5 RTCB! 6 RTCB! ;

pub BCDDEC			DUP >N SWAP 4 >> 10 * + ;
pub DT@ ( index -- decimal )
	I2C.START 10 us I2C.STOP
	$21 RDRTC rtcbuf + 2+ 0
	 3 FOR 100 * OVER C@ BCDDEC + SWAP 1- SWAP NEXT NIP
	;

pub TIME@			0 DT@ ;
pub DATE@			4 DT@ ;
pub DAY@			3 RTC@ ;

pub .6				.AS" ######" ;
pub .DT				DATE@ .6 '-' EMIT TIME@ .6 ;

pub .DATE			DATE@ 20000000 + .AS" ####/##/## "  ;
pub .DAY			DAY@ 1- 3 * " MONTUEWEDTHUFRISATSUN" + 3 CTYPE SPACE ;
pub .TIME			TIME@ .AS" ##:##:##" ;
pub .FDT			.DATE .DAY .TIME ;





	*** DECOMPILER ***

pub *DECOMPILER*	PRINT" A decompiler for TAQOZ 190825-0000" ;

pri dflg	HERE: 0 [

private
20 bytes ifs
byte ex		--- exit flag
byte ind
word wcode		--- current wordcode

long wnfa		--- NFA of current decomps
long wptr
long wsrc


pri dflg?	 1 dflg SET? ;
pri eflg?	 2 dflg SET? ;

pri @SEE++	2
pri @SEE+	wptr +! ;
pri @SEE	wptr @ ;
2 longs xcfa
pri SEE@	@SEE W@ xcfa @ + ;

--- create a temporary dummy def so that we can find the CFAs for unnamed words
: T BEGIN $1234 $12345678 UNTIL uemit $0FF " STRING" ;
AT T 16 + W@		--- address and read " string literals
AT T 14 + W@		--- 10-bit literal
AT T 12 + W@		--- register offset
AT T 10 + W@		--- address and read UNTIL
AT T 4 + W@		--- address and read a LONG literal
AT T W@			--- address and read a WORD literal
FORGET T		--- discard temp def and now use parameters for constants
:= (W)			--- 16-bit WORD
:= (L)			--- 32-bit LONG
8>> := (IF)		--- IF or UNTIL branch
8>> := (R)		--- 8-bit register offset
10 >> := (S)		--- 10-bit literal
:= (")

--- find .AS" runtime cfa
: T .AS" ##" ;
( AT T 2+ W@ ) AT T W@
FORGET T
\ := (EXIT)
:= (AS)

--- find ." runtime cfa using temp def
: T ." HELLO WORLD! " ;
AT T W@
FORGET T
:= (.")

--- find cfa for a long constant
AT SDBUF W@ := (LC)
(LC) 1-	:= (DS)

pri 'EMIT	''' EMIT ;
pri $		'$' EMIT ;
pri .D		SPACE '(' EMIT DUP . ')' EMIT
\ pri .ASC	SPACE DUP $20 $7E WITHIN IF 'EMIT EMIT 'EMIT ELSE DROP THEN ;
pri .ASC	SPACE $20 MAX $7F MIN EMIT ;
pri .M:		CRLF .M ." : " ;

pri .STR	'"' EMIT SPACE @SEE++ @SEE PRINT$ '"' EMIT @SEE LEN$ 1+ 2 ALIGN @SEE+ ;
pri INDENT	ind C@ 0 MAX SPACES ;
pri +ind	2 ind C+! ;
pri -ind	ind C@ IF -2 ind C+! THEN ;

--- print value of 10-bit encoded literal
pri .W10	SEE@ $3FF AND
pri .LIT	dflg? IF DUP 11 > IF DUP . 3 SPACES DUP DUP 16 >> IF .L ELSE .W THEN .ASC  ELSE .  THEN ELSE . THEN ;

--- add an IF branch to address so that indentation and a THEN can be added
--- and the address to the ifs array
pri +if ( addr -- )
	2 dflg SET? IF DUP ."  (+" .W ." ) " THEN
	ifs ifs 2+ 18 <CMOVE ifs W!
\	4 dflg SET? IF ifs 10 DUMPW THEN
	;

pri -if ( addr -- )
	2 dflg SET? IF DUP ."  (-" .W ." ) " THEN
	ifs 20 ADO DUP I W@ = IF 0 I W! LEAVE THEN 2 +LOOP DROP
\	4 dflg SET? IF ifs 10 DUMPW THEN
	;

pri if? ( addr -- flg )
---	find matching address and clear with flag else loop and exit false
	ifs 20 ADO DUP I W@ = IF ( 0 I W! ) UNLOOP EXIT THEN 2 +LOOP DROP 0
	;


--- forward address referenced?
pri fad? ( addr -- flg )
	0 ifs 20 ADO OVER I W@ <= OR 2 +LOOP NIP
	;

pri ?CRLF	dflg? 0= IF CRLF INDENT THEN ;

pri .LCON	PRINT" := " @SEE 2+ @ .LIT 6 @SEE+ ;

pri ?GOTO
	8 dflg CLR
---	jump bit set? (only valid for a threaded call adddress, not asm or encoded)
	SEE@ 1& SEE@ AT SPACE => AND
	IF
---	check if this might be jump because it is an ELSE
	  @SEE 2+ if? ( ptr cfa flg ) @SEE SEE@ U< AND
	  IF @SEE 2+ -if PRINT" ELSE " SEE@ 1 ANDN +if
	  ELSE

	  ( ptr cfa ) SEE@ @SEE > @SEE SEE@ > AND
	    IF PRINT" REPEAT " ELSE ( PRINT" GOTO" ) 8 dflg SET THEN
	  THEN
	  dflg? IF SEE@ 1 ANDN DUP CFA>NFA 0= IF .W SPACE ELSE DROP THEN  ( ptr cfa ) THEN
---	set ex termination flag if not a forward reference AND not nested
	  @SEE fad? NOT ind C@ 6 < AND IF ex C++ THEN
	THEN
	;

pri CASE?			CASE@ = OR ;

pri ?DOS
	0  AT FOR CASE?  AT DO CASE?   AT ADO CASE?   IF +ind THEN
	;
pri ?LOOPS
	0   AT NEXT CASE?   AT ?NEXT CASE?   AT LOOP CASE?   AT +LOOP CASE?   IF -ind THEN
	;

pri .SEE ( cfa -- )
\	xcfa @ + xcfa ~
	SWITCH
	?LOOPS
	dflg? IF CASE@ .WORD SPACE INDENT ELSE SPACE THEN
	?GOTO ?DOS
---	Check for paging call
	PAGE0 DUP 7 - SWAP <CASE> PAGE0 CASE@ - DUP 16<< xcfa 4+ ! PRINT" PAGE" . @SEE++  BREAK

	(.") CASE	PRINT" PRINT" .STR BREAK
	(") CASE	.STR BREAK
	(AS) CASE	PRINT" AS" .STR BREAK
	(W) CASE	@SEE++ CASE@ .LIT @SEE++ BREAK
	(L) CASE	.LCON BREAK
	(DS) CASE	.LCON ex C++ BREAK
	(LC) CASE	.LCON ex C++ BREAK
---	10-bit coded literal?
	CASE@ 10 >> (S) = IF .W10 @SEE++ BREAK

	AT CASE 6 - CASE	." CASE=" @SEE++ BREAK

	AT EXIT CASE	DUP fad? NOT IF PRINT" ;" ex C++ ELSE PRINT" EXIT" THEN @SEE++ BREAK

---	Decoded wordcodes $F800->$FFFF
        CASE@ 8>> SWITCH
	$FD CASE	PRINT" ELSE" SEE@ $80 AND IF ." -" ELSE ." +" THEN SEE@ $7F AND .  @SEE++ BREAK
	(R) CASE	PRINT" REG " SEE@ .B @SEE++ BREAK
---	conditional?     forward IF or back UNTIL ?
	(IF) CASE	?CRLF SEE@ $80 AND 0=
	    IF
	      PRINT" IF" +ind
---	      next   find branch address and remember
	      @SEE 2+ SEE@ >B 2* + DUP +if
	    ELSE
	      PRINT" UNTIL"
	      @SEE 2+ SEE@ $7F AND 2* -
	    THEN
	 ( branch )
	  dflg? IF SPACE .W ELSE DROP THEN @SEE++
	  BREAK

---	default for anything other threaded code
	SEE@ DUP $7FF > IF 1 ANDN THEN CFA>NFA ?DUP IF .NFA THEN
	8 dflg SET? IF ."  ; " THEN
	@SEE++
;


pri ?THENS
---	  display  non-code THEN(s) for matching IF(s) using the ifs table
	BEGIN @SEE if?
	WHILE dflg?
	  IF CRLF 10 SPACES -ind INDENT ELSE -ind THEN
	  PRINT"  THEN" ?CRLF
	  @SEE -if
	REPEAT
	;

pri .NAME ( nfa -- )
	CRLF DUP .M:
	DUP C@ $40 AND IF PRINT" pri " THEN
	DUP C@ $80 AND IF PRINT" pre " THEN
	DUP C@ 5 >> 0= IF PRINT" pub " THEN
	.NFA ?CRLF
	;
pri ?NAME --- check if this address matches a dictionary entry
	@SEE CFA>NFA ?DUP IF .NAME THEN
	;


pub SEECFA ( cfaptr --  )
	xcfa ~
	DUP wsrc ! wptr !			--- save ptr - use @SEE to read pointer
	ifs 24 ERASE		--- clear all variables
	4 ind C!
	@SEE AT SPACE U< IF ."  *CODE* " DROP BREAK
	BEGIN
	  @SEE 1 ANDN wptr !
--- report name of any IPs that match
	  ?NAME
	  ex C~
	  ?THENS
---	  Print address
	  dflg? IF @SEE .M: THEN
	  SEE@ .SEE xcfa 4+ @ xcfa ! xcfa 4+ ~
---	  terminate if flagged or a key pressed
	  ex C@ KEY OR
---	  but not if it still has a forward reference to resolve
	  @SEE fad? NOT AND
---	  but always if we are now reading nulls
	  SEE@ 0= OR
---	 terminate if that was an EXIT and no further nesting
	  @SEE 2- W@ AT EXIT = ind C@ 5 < AND OR
	UNTIL
	CRLF 6 SPACES @SEE wsrc @ - . ."  bytes "
	;


pre SEE
	[C] NFA' [G]  1 dflg SET
pub SEENFA ( nfa -- )
	?DUP
	IF
	  DUP wnfa !
\	  DUP .NAME ?CRLF
	  CFA SEECFA
	  CRLF
	ELSE PRINT"  not found "
	THEN
	;

pre DECOMP
	[C] NFA' [G] 1 dflg CLR SEENFA
	;

\ : SEEALL  @WORDS BEGIN DUP C@ WHILE DUP SEES CPA 2+ REPEAT DROP ;






pub STRIPIT ( nameptr -- nameptr+ )
	SPACE DUP C@++ $1F AND CTYPE			--- Ok, strip it out
	DUP DUP C@ $1F AND 3 + ( 1 ANDN ) ( nameptr cnt )
	DUP >L @WORDS +
	@WORDS ROT SWAP - ( newnames len )
	@WORDS ROT ROT <CMOVE
	L> DUP names W+! +   	 			--- add to names pointer and to current pointer for next word
 	;

--- Strip a single header from the dictionary
pre STRIP ( <name> -- )			[C] NFA' [G] STRIPIT DROP ;

--- RECLAIM memory by striping private headers from the dictionary
--- RECLAIM <opt>
pre RECLAIM ( <to> -- )
	delim 1+ C@ $20 = IF [C] NFA' [G] ELSE $10.0000 THEN ( to )
	4 REG W~
	CRLF CRLF '{' EMIT
	@WORDS DUP >L
	BEGIN
	( to words )
	  2DUP >
	  OVER W@ AND
	WHILE

	  --- Test to see if ATR is private
  	  DUPC@ $40 AND
  	     --- strip header or proceed to next
  	    IF 4 REG W@ 10 // 0= IF CRLF THEN STRIPIT 4 REG W++ ELSE NFA+ THEN
	REPEAT
	--- Report results
	DROP CRLF ." Reclaimed " @WORDS L> DUP >L  - DUP .DECL PRINT"  bytes"
	--- Clear the reclaimed area (not needed really )
	L> SWAP ?DUP IF ERASE ELSE DROP THEN
\	CRLF [C] WORDS
	CRLF '}' EMIT DROP
	;





	*** SERIAL RAM ***

pub *SPIRAM*		PRINT" LY68L6400 8MB SPI RAM ACCESS 191020-0000" ;
{
LY68L6400 8MB SPI RAM

$03	READ
$0B	FAST READ
$02	WRITE
$66	RESET ENABLE
$99	RESET
$C0	SET BURST LENGTH
$9F	READ ID

}


ALIAS SFC@ SRC@
ALIAS SFW@ SRW@
ALIAS SF@ SR@
ALIAS SF SR

pub SRRD				3 SFCMD SPIWM ;
pub !SR					$66 SFCMD SPICE $99 SFCMD SPICE ;
pub SRWRP ( src dst -- )		2 SFCMD SPIWM 512 SPITX SPICE ;
pub SRWRS ( hub srdst bytes -- )	ROT SWAP ADO I OVER SRWRP 512 + 512 +LOOP DROP ;
pub SRC!				2 SFCMD SPIWM SPIWB SPICE ;
pub SRW!				2 SFCMD SPIWM DUP SPIWB 8>> SPIWB SPICE ;
pub SR!					2 SFCMD SPIWM 4 FOR DUP SPIWB 8>> NEXT DROP SPICE ;
pub SRID				$9F SFCMD 0 SPIWM 0 SPIRL 0 SPIRL ;
pub .SR					SRID SWAP .L SPACE .L ;


0	:= srinc
pub SRRDS ( srsrc hubdst bytes -- )
	BEGIN
	  3RD SRRD 	\ $0B SFCMD SPIWM 0 SPIRD DROP
	  DUP 1024 MIN AT srinc 2+ !
	  OVER srinc SPIRX SPICE DROP
	  ROT srinc + ROT srinc + ROT srinc -
	  DUP 0=
	UNTIL 3DROP
	;

--- routine to cache 8MB of a file into SPI RAM
pub FCACHE				@FILE 0 $80.0000 9 >> FOR OVER SECTOR OVER SRWRP b++ 512 + NEXT 2DROP ;


{
SFJID	$EF40_1400	EF WINBOND 40 TYPE  14 W25Q80
#EF
SRID	$0D5D_46A0 $2A46_5C34		0D LYONTEK 5D KGD=PASS




}


{ MEASURE PIN CAPACITANCE AS A FLOAT TO HIGH TIME }
: ?PIN ( pin --  )
	CRLF ." P" DUP . 9 EMIT
	PIN
	0 8 FOR L 100 us F CNT@ BEGIN R UNTIL CNT@ SWAP - ABS + NEXT 3 >>
	10 U.R
	;
: ?PINS ( from for -- ) ADO I ?PIN LOOP ;


pri CRLF+		CRLF 2 SPACES ;

pub .MODULES
	@WORDS
	BEGIN
	  DUP W@
	WHILE
	  DUP MOD?
	    IF CRLF+ DUP .NFA CR TAB TAB DUP CFA EXECUTE
	  THEN
	  NFA+
	REPEAT
	DROP
	;

pub .ASBYTES		.DECL ."  bytes" ;


\ pub lsi2c	128 FOR I 2* I2CRD? IF I 2* .B SPACE THEN NEXT I2C> ;
pri .I2C ( dev -- )
	AT i2cdev C!
	i2cdev I2CRD? 0EXIT
	CRLF i2cdev 2 SPACES .B
	i2cdev SWITCH 2 TABS
	$A4 CASE PRINT" RV-3028 RTC" BREAK
	$A0 CASE PRINT" EEPROM" BREAK
	CASE@ $C0 $DE WITHIN IF PRINT" Si5351A CLOCK GEN" BREAK
	CASE@ $30 $3E WITHIN IF PRINT" MCP9808 TEMPERATURE SENSOR" BREAK

\	$C4 CASE PRINT" Si5351A-B0448 CLOCK GEN" BREAK
	CASE@ $40 $4E WITHIN IF PRINT" I/O EXPLANDER" BREAK
	PRINT" UNKNOWN DEVICE"
	;
pub lsi2c	PRINT" I2C DEVICES"	$80 FOR I 2* .I2C NEXT ;
pub SFBYTES	SFJID 8>> >B |< ;
pri .UBYTES	SWAP .ADRX 2 SPACES .ASBYTES ;
pub .USAGE
	CRLF PRINT" MEMORY MAP"
	CRLF+ PRINT" CODE:" 		2 TABS HERE HERE .UBYTES
	CRLF+ PRINT" WORDS:" 		2 TABS @WORDS " END" SEARCH 6 +  @WORDS - .UBYTES
	CRLF+ PRINT" DATA:" 		2 TABS org@   org@ AT orglen 6 - CALL @ - .UBYTES
	HERE 16>> 0=
	IF
	  CRLF+ PRINT" ROOM:" 		2 TABS @WORDS HERE - 7 SPACES .ASBYTES
	THEN
	;
pub .DEVICES
	CRLF PRINT" DEVICES"
---	SD
	SD? IF CRLF+ PRINT" SD CARD"	2 TABS sdsize @ 512 1,000,000,000 */ . PRINT" GB  " .CARD THEN
---	SPI FLASH
	SFJID 16 >> $FFFF <> IF CRLF+ PRINT" SPI FLASH" 	2 TABS SFBYTES .MEM SPACE
	SFJID 24 >> $EF = IF PRINT" WINBOND" ELSE ." UNKNOWN" THEN  SPACE SFJID .L SPACE SFSID '#' EMIT D. THEN
---	SPI RAM
	SRID DROP 24 >> $0D = IF CRLF+ PRINT" SPI RAM"		2 TABS SRID SWAP .L SPACE .L THEN
---	I2C
	CRLF lsi2c
	;
pub SYSINFO
	CRLF PRINT" KERNEL" 		2 TABS .VER
	PRINT" MODULES:" 		2 TABS .MODULES
	.USAGE
	CRLF PRINT" HARDWARE"
	CRLF+ PRINT" PCB"		2 TABS 4 8 CTYPE $A4 I2CRD? IF PRINT" (P2D2)" THEN
	CRLF+ PRINT" CLOCK IN"		2 TABS _xin @ 2 .DP PRINT" MHZ"
	.DEVICES

	RTC? IF  CRLF TAB TAB .FDT THEN
	CRLF
	;

ALIAS SYSINFO ??

	*** SHORTCUTS ***

pri ~Y		[C] wORDS CRLF PROMPT ; 	AT ~Y ^Y CTRL!
pri ~?		.USAGE CRLF PROMPT ;	AT ~? ^? CTRL!
pri ~W		W CRLF PROMPT ; 	AT ~W ^W CTRL!
pri ~D		DEBUG CRLF PROMPT ;	AT ~D ^D CTRL!
pri ~B		BU CRLF PROMPT ;	AT ~B ^B CTRL!

--- capture rx buffers into $70000 stacked, then erase buffers
pri ~E		$70000 $70300 $0C00 <CMOVE $7F500 $70000 $300 CMOVE $7F500 $300 ERASE ."  SAVED " ; AT ~E ^E CTRL!



--- perform SYSINFO one second after powerup (allows for USB connection etc)
pub MAIN	FORTH 1000 ms KEY 1 <> 0EXIT DISCARD   SYSINFO ;

AUTO MAIN
RECLAIM

END
