forgetram
compiletoflash
\ compiletoram

\ -----------------------------------------------------------------------------

: { ( -- ) \ Long comment
	begin
	 \ end of line if length of next token is zero so fetch new line. Fetch new token.
	  token dup 0= if 2drop cr query token then
	  s" }" compare  \ Search for *)
	until
	immediate 0-foldable ;


(	*** formatted memory dump *** )

: bounds		over + swap ;
: u.n ( n cnt -- )	0 <# swap 0 do # loop #> type ;
: .byte			hex 0 <# # # #> type ;
: .long			hex 0 <# # # # # $5F hold # # # # #> type ;
: .addr			cr hex .long ." : " ;

: dumpq ( a -- )	.addr i #16 bounds do i 3 and 0= if space then i c@ .byte space loop ;
: dumpa ( a -- )	2 spaces #16 bounds do i c@ dup $20 < if drop $2E then dup $7E > if drop $2E then emit loop ;

: dump			bounds do i dumpq i dumpa #16 +loop ;
: dumpl			bounds do i .addr i #16 bounds do i @ .long 2 spaces 4 +loop i dumpa #16 +loop ;


(	*** quick list dictionary *** )

: .name ( nfa -- )	dup C@ $FF = IF ." <end>" ELSE dup 1+ swap c@ type THEN ;
: .new			dup 6 - .addr space nip 0 swap ;
\ stub to newline and print name
: ~w			6 + over 70 > over c@ 15 > or if .new then dup .name ;
\ stub to advance width and word pointer, then check for end
\ : ~n			dup c@ 16 > if nip 80 swap then 6 - @  dup 1+ 0= ;
: ~n	dup c@ 16 > if nip 80 swap then 6 - dictionarynext ;

: ~l	~w #16 over C@ - 1 max spaces #16 rot + swap ~n ;

\ display plain dictionary words with line wrap and address
: w	#80 dictionarystart
	begin ~w 2 spaces dup C@ rot + 2+ swap ~n until
	2drop
	;

\ display tabbed dictionary words with line wrap and address
: ww
	#80 dictionarystart
	begin ~l until
	2drop
	;



\ display tabbed RAM dictionary words with line wrap and address
: rw
	#80 dictionarystart ( mode cnt ptr )
	begin dup 4 + h@ $FFFF = if 2drop exit then ~l until 2drop
	immediate 0-foldable ;


\ display tabbed FLASH dictionary
: fw
	#80 dictionarystart ( mode cnt ptr )
	begin dup 6 + h@ $2D18 <> while dictionarynext drop repeat
	begin ~l until 2drop
	immediate 0-foldable ;


( *** MEMORY DEFINITIONS *** )

$10001010 constant CLKBOOT	\ if set will change default clock
\ DCO CALIBRATION DATA
$10000F30 constant ANA_TSE_T1
$10000F31 constant ANA_TSE_T2
$10000F32 constant DCO_ADJLO_T1
$10000F33 constant DCO_ADJLO_T2

( *** REGISTER DEFINITIONS *** )


( *** GPIO *** )

$40040000 constant P0OUT
$40040004 constant P0OMR
$40040010 constant P0IOCR0
$40040014 constant P0IOCR4
$40040018 constant P0IOCR8
$4004001c constant P0IOCR12
$40040024 constant P0IN
$40040040 constant P0PHCR0
$40040044 constant P0PHCR1
$40040060 constant P0PDISC
$40040070 constant P0PPS
$40040074 constant P0HWSEL

$40040100 constant P1OUT
$40040104 constant P1OMR
$40040110 constant P1IOCR0
$40040114 constant P1IOCR4
$40040118 constant P1IOCR8
$4004011c constant P1IOCR12
$40040124 constant P1IN
$40040140 constant P1PHCR0
$40040144 constant P1PHCR1
$40040160 constant P1PDISC
$40040170 constant P1PPS
$40040174 constant P1HWSEL

$40040200 constant P2OUT
$40040204 constant P2OMR
$40040210 constant P2IOCR0
$40040214 constant P2IOCR4
$40040218 constant P2IOCR8
$4004021c constant P2IOCR12
$40040224 constant P2IN
$40040240 constant P2PHCR0
$40040244 constant P2PHCR1
$40040260 constant P2PDISC
$40040270 constant P2PPS
$40040274 constant P2HWSEL


$40010000 constant SCU
$40010200 constant VDESR	\ Voltage Detector Status Register 0000H U, PV U, PV Page 12-26


$40010300 constant CLKCR	\ Clock Control Register (0300H) Reset Value: 3FF0 0400H
$4001030C constant CGATSET0	\ Clock Gating Set for Peripherals 0 000CH U, PV U, PV, BP Page 12-31
$40010310 constant CGATCLR0	\ Clock Gating Clear for Peripherals 0 0010H U, PV U, PV, BP Page 12-32
$40010314 constant OSCCSR	\ Oscillator Control and Status Register 0014H U, PV U, PV Page 12-33
$40010324 constant SCU_PASS	\ password reg

$40011050 constant ANAVDEL	\ Voltage Detector Control Register
$4001106C constant ANAOFFSET	\ DC01 ADJ

$40010200 constant VDESR	\ Voltage Detector Status Register 0200H U, PV U, PV Page 12-26

\ RCU Registers (SCU)
$40010400 constant RSTSTAT	\ Reset Status 0000H U, PV BE Page 12-35
$40010404 constant RSTSET	\ Reset Set Register 0004H U, PV U, PV Page 12-36
$40010408 constant RSTCLR	\ Reset Clear Register 0008H U, PV U, PV Page 12-37
$4001040C constant RSTCON	\ Reset Control Register 000CH U, PV U, PV Page 12-38

\ GCU Registers (SCU)
$40010008 constant GCU_ID	\ Module Identification Register 0008H U, PV BE Page 12-39
$40010004 constant IDCHIP	\ Chip ID 0004H U, PV SP Page 12-40



$40010000 constant DBGROMID	\ DBGROMID 0000H U, PV SP Page 12-41
$40010014 constant SSW0		\ SSW Support Register 0014H U, PV U, PV Page 12-41
$40010030 constant CCUCON 	\ CCUx Global Start Control Register 0030H U, PV U, PV Page 12-42
$40010038 constant SRRAW	\ RAW Service Request Status 0038H U, PV BE Page 12-42
$4001003C constant SRMSK	\ Service Request Mask 003CH U, PV U, PV Page 12-45
$40010040 constant SRCLR	\ Service Request Clear 0040H U, PV U, PV Page 12-47
$40010044 constant SRSET	\ Service Request Set 0044H U, PV U, PV Page 12-49
$40010024 constant PASSWD 	\ Bit protection Register 0024H U, PV U, PV Page 12-52
$40010048 constant MIRRSTS 	\ Mirror Update Status Register 0048H U, PV BE Page 12-53
$40010054 constant PMTSR	\ Parity Memory Test Select Register 0054H U, PV U, PV Page 12-54



\ TSE
$40011024 constant TSE_CTL
$40011030 constant TSE_IH
$40011034 constant TSE_IL
$40011040 constant TSE_MON


$40020000 constant WDT		\ 4002 0000H 4002 FFFFH Watchdog Timer Registers
$40020000 constant WDT_ID	\ Module ID Register 00H U, PV PV Page 10-9
$40020004 constant WDTCTR	\ Control Register 04H U, PV PV Page 10-10
$40020008 constant WDTSRV	\ Service Register 08H BE PV Page 10-11
$4002000C constant WDTTIM	\ Timer Register 0CH U, PV BE Page 10-13
$40020010 constant WDTWLB	\ Window Lower Bound 10H U, PV PV Page 10-13
$40020014 constant WDTWUB	\ Window Upper Bound 14H U, PV PV Page 10-14
$40020018 constant WDTSTS	\ Watchdog Status Register 18H U, PV PV Page 10-14
$4002001C constant WDTCLR	\ Watchdog Status Clear Register 1CH U, PV PV Page 10-15



$48030000 constant VADC0

$48030008 constant VADC0_ID	\ Module Identification Register 0008H U, PV BE 15-16
$48030000 constant VADC0_CLC	\ Clock Control Register 0000H U, PV PV 15-17
$48030028 constant VADC0_OCS	\ OCDS Control and Status Register 0028H U, PV PV 15-18
$48030080 constant VADCG_CFG	\ Global Configuration Register 0080H U, PV U, PV 15-20
$48030200 constant BRSCTRL	\ Request Source Control Register 0200H U, PV U, PV 15-23
$48030204 constant BRSMR	\ Request Source Mode Register 0204H U, PV U, PV 15-25
$48030180 constant BRSSEL0	\ Request Source Channel Select Register, Group 0 0180H U, PV U, PV 15-27
$48030184 constant BRSSEL1	\ Request Source Channel Select Register, Group 1 0184H U, PV U, PV 15-27
$480301C0 constant BRSPND0	\ Request Source Channel Pending Register, Group 0 01C0H U, PV U, PV 15-28
$480301C4 constant BRSPND1	\ Request Source Channel Pending Register, Group 1 01C4H U, PV U, PV 15-28
$480300A0 constant VADCG_IN0	\ Input Class Register 0 00A0H U, PV U, PV 15-29
$480300A4 constant VADCG_IN1	\ Input Class Register 1 00A4H U, PV U, PV 15-29
$48030280 constant VADCG_RCR	\ Result Control Register 0280H U, PV U, PV 15-31
$48030300 constant VADCG_RES	\ Result Register 0300H U, PV U, PV 15-32
$48030380 constant VADCG_RESD	\ Result Register (debug view) 0380H U, PV U, PV 15-32
$480300E0 constant VADCG_EFLAG	\ Event Flag Register 00E0H U, PV U, PV 15-36
$48030140 constant VADCG_EVNP	\ Event Node Pointer Register 0140H U, PV U, PV 15-37


$48034000 constant SHS0
$48034008 constant SHS0_ID	\ SHS Module Identification Register 0008H U, SV U, SV 15-16
$48034040 constant SHSCFG	\ SHS Configuration Register 0040H U, SV U, SV 15-21
$48034180 constant GNCTR00	\ Gain Control Register 0, Group 0 0180H U, SV U, SV 15-33
$48034000 constant GNCTR10	\ Gain Control Register 0, Group 1 0190H U, SV U, SV 15-33
$48034050 constant SHS0_LOOP	\ SD Loop Control Register 0050H U, SV U, SV 15-35


$E000E010 constant systcsr	\ systick control
$E000E014 constant systrvr	\ 24-bit reload
$E000E018 constant systcvr	\ current value
$E000E01C constant systcal	\ calibration SYST_CALIB




\ Init systick
: !systick	-1 systrvr ! 5 systcsr ! ;
\ Return with value of systick counter
: systicks	systcvr @ ;

( *** TEMPERATURE SENSOR *** )
: !TSE		1 TSE_CTL ! ;
: TSE@		TSE_MON @ ;

\ Password access for next 32 clocks
: PASS		%10011011 SCU_PASS ! ;
\ Disable password
: !PASS		%11000000 SCU_PASS ! ;


{
ADC_AI.003 Additonal bit to enable ADC function
The analog section of ADC is not fully functioning when it is enabled by bit
SHSCFG.ANOFF.
Workaround
To enable the analog section of the ADC, write value 00000001H to register
address 40010500H in addition to the setup as mentioned above.
}
: !VADC
	$8000 SHSCFG !		\ convertor on -  enable write to this reg
	8 VADC0_CLC !		\ enable clock, disable sleep
	1 $40010500 !		\ workaround
	\ ?? VADC0_BRSMR !	\ req source mode
	1 CGATSET0 !		\ enable clock gating (exception)
	;



compiletoram



