IFDEF *SED*
_sed org
FORGET *SED*
}
TAQOZ

pub *SED* PRINT" TAQOZ SIMPLE TEXT EDITOR 210202-2130" ;

{
210203
210202  check and clean up, factor
        Don't refresh display if adding text on same line.
        Improved hex display with highlight
210131  Add super sector BLOCK mode
210129  Added Flash and RAM as targets (4k pages to do)
        Added simple underline cursor to VGA
210128  Added ANSI sequences and hex mode

210126  Created SED to edit config files by sector
        Added addtional controls etc
        Added cursor key sequences etc
NOTES:  Making used of labels_ as comments.
        Trying to keep the layout compact for possible
        editing in the editor itself.
}
DEC
public
0 bytes _sed
private
long tcur           --- cursor postion in file
pri tcur+!      tcur +! ;
pri tw          64 ;    --- editor width (default 64 )
2048  := tblk

pri HEXBLK      16 512 pri BLK! AT tblk 2+ ! AT tw C! ;
pri TXTBLK      2048 BLK! ;

long blksect
$7E000  := BLOCKS
--- S>M
pub BLOCK ( sect bytes -- ram )	OVER blksect @ <>
    IF OVER blksect ! BLOCKS SWAP SDRDS
    ELSE 2DROP THEN BLOCKS ;
pub BLKADR ( offset -- ram )    DUP tblk 1- ANDN
    SWAP OVER - SWAP 9>> @FILE + tblk BLOCK + ;

pub SAVBLK  RW blksect @ IF BLOCKS blksect @ tblk SDWRS ;


--- fetch long from SD virtual memory in current file
pub BC@         BLKADR C@ ;
pub BC!			BLKADR C! wrflg C~~ ;

byte _sf

pri SFADR
    DUP $FFF ANDN DUP sfpage @ <>
    IF DUP sfpage ! BLOCKS 4096 SFRDS
    SWAP $FFF AND ( page off )

    SWAP OVER - SWAP 12 >> tblk SFPAGE ;
pri FLASH@      SFADR C@ ;
pri FLASH!      SFADR C! 1 _sd SET ;

pub SED@        BC@ NOP ;
pub SED!        BC! NOP ; \ tcur @ 0 FSIZE@ 1- WITHIN

pri FLASH?      " FLASH" pri FILE? file$ $= ;
pri RAM?        " RAM" FILE? ;
pri SECTOR?     " SECTOR" FILE? ;

pri [b]         CON? IF %BOLD %red %PEN ELSE red PEN THEN ;
pri [/b]        CON? IF %PLAIN ELSE white PEN THEN ;
pri CURSOR ( on/off -- ) CON? IF %CURSOR ELSE DROP THEN ;
pri WRCUR       cols * + SCR + csp $FF FILL ; ( TO DO: plot)
pri VCUR ( x y -- ) --- set and draw vga cusor
    1- lsp * SWAP csp * SWAP 2DUP VXY
    lsp 2- + 2DUP WRCUR 1+ WRCUR ;
pub XY ( xy -- ) CON? IF %XY ELSE VCUR THEN ;
byte y0
pri TEXTXY      tcur @ 0 MAX tblk // tw U// DUP y0 C! ;
pri TEXTCUR		TEXTXY SWAP 9 + SWAP 3 + XY ;
pri @STATUS     1 tblk tw / 3 + XY ;
--- THEME
pri HDRS        CON? IF %blue %PEN %white %PAPER
    ELSE blue PEN white PAPER THEN ;
pri TXTS        CON? IF %PLAIN %blue %PAPER
    ELSE PLAIN blue PAPER THEN ;

pri SIZE        32 1 XY tblk SPACE . ." x" tw . SPACE ;
pri CLOCK       63 1 XY QTIME@ .AS"  ##:##:## " ;
pri RULER       CRLF 8 SPACES tw FOR I >N .H NEXT
    tw 16 = IF 16 FOR SPACE I .BYTE NEXT THEN ;
pri HEADER      OFF CURSOR 15 EMIT [/b] CLS HDRS
    PRINT" FILE: " file$ PRINT$ 3 SPACES
    SECTOR? IF SPACE @FILE .L THEN SIZE CLOCK ;
pri ROWS        I tw // 0= IF HDRS I .ADDR [/b] SPACE TXTS THEN ;
pri ?CR         tw 16 <> 0EXIT
    I 1+ tw // ?EXIT I SED@ $0D = 0EXIT ." <" ;
pri @TEXT       BLOCKS tblk ;
pri .BYTE!
    I tcur @ = IF [b] .BYTE [/b] ELSE .BYTE THEN SPACE ;
pri ?HEX        tw 16 = 0EXIT   I 1+ tw // ?EXIT
    SPACE I 15 - 16 ADO I SED@ .BYTE! LOOP ;
 pub .BLOCK
    tcur @ tblk 1- ANDN HEADER RULER
    tblk ADO ROWS I SED@ .EMIT ?CR ?HEX LOOP ON CURSOR ;
{ pub .BLOCK
    HEADER RULER \ tcur @ tblk 1- ANDN
    tblk FOR ROWS I BLK@ .EMIT ?CR ?HEX NEXT ON CURSOR ;
}
pri SQUIT       FCLOSE @STATUS file$ PRINT$ PRINT"  CLOSED "
     R> R> 2DROP [/b] ;
pri SEDKEY! ( ch -- ) tcur @ SED!  ;
pri SEDCHAR     DUP EMIT SEDKEY! tcur ++
pri ?BLOCK      y0 C@ TEXTXY NIP <> tw 16 = OR
    IF .BLOCK CRLF PRINT" UNSAVED " THEN ;

pri tINS    ;
pri tDEL    ;

pri ESC2 SWITCH
 INS_    $7E CASE tINS BREAK
 F10_    '1' CASE WKEY DROP BREAK ;

pri ESC3 SWITCH
 DEL_    $7E CASE tDEL BREAK ;

pri ESC5B SWITCH --- ANSI KEY SEQUENCES USE $1B $5B ?? ??
 UP_     'A' CASE tw NEGATE tcur+! BREAK
 DN_     'B' CASE tw tcur+! BREAK
 ->_     'C' CASE tcur ++ BREAK
 <-_     'D' CASE tcur -- BREAK
 HOME_   'H' CASE tcur ~ BREAK
 END_    'F' CASE FSIZE@ tw - tcur ! BREAK
 PGUP_   'V' CASE tblk NEGATE tcur+! BREAK
 PGUP_   '5' CASE WKEY DROP tblk NEGATE tcur+! BREAK
 PGDN_   'U' CASE tblk tcur+! BREAK
 PGDN_   '6' CASE WKEY DROP tblk tcur+! BREAK
 HOME_   '1' CASE WKEY DROP tcur ~ BREAK
 INS_    '@' CASE tINS BREAK
 ESC2_   '2' CASE WKEY ESC2 BREAK
 ESC3_   '3' CASE WKEY ESC3 BREAK ;

pri FNCKEY SWITCH
 F2_     'Q' CASE BREAK ;

pri !TEXT --- space & convert block to CR delimited lines
    @TEXT ADO IC@ 0= IF $20 I C! THEN
    I tblk // ?DUP IF 1+ tw // 0= IF $0D I C! THEN THEN
    LOOP ;

pri SEDESC a>A SWITCH --- ESC <KEY> COMMANDS
 ANSI_   $5B CASE WKEY ESC5B BREAK
 FNC_    $4F CASE WKEY FNCKEY BREAK
 DEL_    $7F CASE tDEL BREAK ;


pri CLRLN   tcur @ tw ADO 0 I SED! LOOP ;
pri SED^X a>A SWITCH
 WIDE_   'W' CASE 128 TXTBLK BREAK
 TEXT_   'T' CASE 64 TXTBLK BREAK
 NARROW_ 'N' CASE 32 TXTBLK BREAK
 HEX_    'H' CASE HEXBLK BREAK
 CLEAR_  'Z' CASE @TEXT $20 FILL BREAK
 CLRLN_  'X' CASE CLRLN BREAK
 REVERT_ 'R' CASE tcur @ tblk + SED@ DROP BREAK ( page in/out)
 BLANKS_ $20 CASE !TEXT BREAK ;

pri SAVEFILE
  RAM? FLASH? OR ?EXIT
  SAVBLK RO MODIFIED
  @STATUS ." SAVED    " file$ FOPEN$ DROP ;

pri SEDKEY TEXTCUR ?DUP 0EXIT SWITCH
 NULL_    0  CASE 10 ms BREAK
 \ FORMAT_ ^B  CASE !TEXT .BLOCK BREAK
 FWD_    ^A  CASE tcur ++ BREAK
 TAB_    ^I  CASE tcur @ 8 + 7 ANDN tcur ! BREAK
 SAVE_   ^S  CASE SAVEFILE BREAK
 EOT_    ^Z  CASE  0 SEDCHAR BREAK
 PAGE_   ^L  CASE tblk tcur+! .BLOCK BREAK
 LF_     ^J  CASE BREAK
 CR_     ^M  CASE tcur @ $3F ANDN tw + tcur ! .BLOCK BREAK
 BS_     ^H  CASE tcur -- $20 SEDKEY! .BLOCK BREAK
 UP_     ^W  CASE tw NEGATE tcur+! .BLOCK BREAK
 \ CANCEL_ ^C  CASE wrflg C~ SQUIT BREAK
 QUIT_   ^Q  CASE SQUIT BREAK
 TEXT_   ^T  CASE 64 TXTBLK .BLOCK BREAK
 HEX_    ^N  CASE HEXBLK .BLOCK BREAK
 SEDCMD_ ^X  CASE WKEY SED^X .BLOCK BREAK
 ESC_    $1B CASE WKEY SEDESC .BLOCK BREAK
 TEXT_       CASE@  SEDCHAR ;

pri SED: ( <addr> -- )
     tcur ! R> DUP 2+ W@ AT SED! W! W@ AT SED@ W!
    .BLOCK  BEGIN KEY SEDKEY AGAIN ;
pre SED ( SED <file> or 0 SED SECTOR or 0 SED FLASH )
    FCLOSE 64 TXTBLK blksect ~
    [G] [C] FOPEN @FILE IF 0 SED: BC@ BC! THEN
    FLASH?  IF SED: FLASH@ FLASH! THEN
    RAM?    IF SED: C@ C! THEN
    HEXBLK
    SECTOR? IF OPEN-SECTOR 0 SED: BC@ BC! THEN
    PRINT"  BAD COMMAND "
    ;
{
pre TEXT>BLOCK ( <src> <dst> -- )
	[G] GET$ SPACE FOPEN$ FSIZE@ ( srcsect )
	GET$ FOPEN$ ( srcsect dstsect )
	3RD AND
	IF ( src size dst )

	ELSE
	  3DROP FALSE
	THEN
	.SUCCESS
;
}
END
\ RECLAIM *SED*
