TAQOZ

IFDEF *W5500*
_W5500	org
FORGET *W5500*
}
pub *W5500*		." WIZNET W5500 driver for TAQOZ V1.0 191007 " ;

$7E000 org
0 bytes _W5500


: BOLD ;
: PLAIN ;
: REVERSE ;
: PCB$		" P2D2 " ;


pub (MBXEMIT)	BEGIN outbox C@ 0= UNTIL outbox C! ;
pub MBXEMIT	DUP $0D = IF ']' (MBXEMIT) THEN DUP (MBXEMIT) $0A = IF '[' (MBXEMIT) THEN ;
pub CONIO	' MBXEMIT uemit W! KEY: DROP ;



$40 bytes eeprom
pri EE!	$FFC0 - eeprom + ! ;
pri EE@ $FFC0 - eeprom + @ ;

--- some default IP settings
&192.168.0.1		:= myGW
&192.168.0.150		:= myIP
&255.255.255.0		:= mySN

BUFFERS	:= BUFFER


( HARDWARE DEFINITIONS )


{ W5500 SPI frame format
ADDRH ADDRL CONTROL <DATA>
7..5	SKT
4,3	X,REG,TX,RX
2	R/W
1,0	00 = VARIABLE LEN DATA


23	:= WIZCE	--- W5500 Ethernet
22	:= WIZDO
21	:= WIZDI
20	:= WIZCK
}



&23.22.21.20	:= @wizpins

\ &20.23.22.21	:= @wizpins

pub WIZPINS	' @wizpins 2+ ! ;

--- Write and update CONTROL byte
pri RDWIZ						0
---							ctl byte
pri WIZADR ( wr -- )					SWAP @wizpins SPIPINS SPIWW
--- entry point only for reference by SWC
pri SWC							0_0 OR SPIWB ;
pri WRWIZ						4 WIZADR ;

pub @COMMON ( 6.8us )					0 $F8
--- write directly to the control byte literal embedded in SWC
pri SWC! ( or andn -- )					' SWC C@ SWAP ANDN OR ' SWC C! ;
pub @RX							$18 $18 SWC! ;
pub @TX							$10 $18 SWC! ;
pub @SOCKET						8 $18 SWC! ;

byte skt2
---							socket constant
pub SKT@						0_0 ;
---		Set the socket number ( calculates address and sets as a SOCKET constant )
pub SKT
pub SOCKET ( skt -- )					DUP ' SKT@ C! 5 << $E0 SWC! ;

--- READ/WRITE METHODS ---
pub LC! ( byte wizadr -- ) ( 17.5us )			WRWIZ SPIWB SPICE ;
pub LW! ( word wizadr -- ) ( 18.8us )			WRWIZ SPIWW SPICE ;
pub L! ( long wizadr -- ) ( 21.1us )			WRWIZ SPIWL SPICE ;

pub LC@ ( wizadr -- byte ) ( 16.8us )			RDWIZ 0 SPIRD SPICE ;
pub LW@ ( wizadr -- word ) ( 18.0us )			RDWIZ 0 SPIRD SPIRD SPICE ;
pub L@ ( wizadr -- long ) ( 20.3us )			RDWIZ 0 SPIRL SPICE ;

--- BLOCK TRANSFER METHODS ---
--- Read a block of memory from the WIZnet - 235us/512 bytes @200MHZ
pub LREAD ( src dst cnt -- )				ROT RDWIZ SPIRX DROP SPICE ;

--- Write a block to the WIZnet - 220us/512 bytes
pub LWRITE ( src dst cnt -- )				SWAP WRWIZ SPITX SPICE ;



( ----------------------------------- REGISTER LEVEL INTERFACE -------------------------------- )

--- EEPROM CONFIG BACKUP ---
--- Use the top part of the 64K EEPROM to save IP settings

$FFC0	:= @gateway
$FFC4	:= @sip
$FFC8	:= @subnet
$FFCC	:= @mac
$FFD0	:= @wcold
$FFE0	:= @ports

\ common registers

--- Access common registers
pub wMODE ( mask -- )			0 @COMMON LC! ;
pub GATEWAY ( addr -- )			DUP @gateway EE! 1 @COMMON L! ;
pub SUBNET ( mask -- )			DUP @subnet EE! 5 @COMMON L! ;
pub MAC ( high low  -- )		DUP @mac EE! $0B @COMMON L! 9 LW! ;
pub SIP ( long -- )			DUP @sip EE! $0F @COMMON L! ;


pri INTS@ ( -- ints )			$15 @COMMON LC@ ;
pri INTMASK ( mask -- )			$16 @COMMON LC! ;


pri @RTR ( -- adr )			$19 @COMMON ;
pri @RCR ( -- adr )			$1B @COMMON ;

pri UIP ( ip -- )			$28 @COMMON L! ;
pri UPORT ( port -- )			$2C @COMMON LW! ;



( SOCKET INTERRUPTS )
4	|< := 	&SENDOK
3	|< := 	&TIMEOUT
2	|< := 	&RECV
1	|< := 	&DISCON
0	|< := 	&CON
{
( SOCKET STATUS CODES )
$00	:=	SOCK_CLOSED
$13	:=	SOCK_INIT
$14	:=	SOCK_LISTEN
$17	:=	SOCK_ESTABLISHED
$1C	:=	SOCK_CLOSE_WAIT
$22	:=	SOCK_UDP
$32	:=	SOCK_IPRAW
$42	:=	SOCK_MACRAW
$5F	:=	SOCK_PPOE

( SOCKET TRANSIENT STATUS CODES )
$15	:=	SOCK_SYNSENT
$16	:=	SOCK_SYNRECV
$18	:=	SOCK_FIN_WAIT
$1A	:=	SOCK_CLOSING
$1B	:=	SOCK_TIME_WAIT
$1D	:=	SOCK_LAST_ACK
$11	:=	SOCK_ARP
$21	:=	SOCK_ARP1
$31	:=	SOCK_ARP2
}


\ Socket registers ( -- addr )
pri sMODE		0 @SOCKET ;		--- mode
pri sCMD!		1 @SOCKET LC! ;		--- command
pri sINTS		2 @SOCKET ;		--- interrupts
pri sSTAT@		3 @SOCKET LC@ ;		--- status
pri sPORT		4 @SOCKET ;		--- 2 byte src port
pri sDHAR		6 @SOCKET ;		--- 6 byte dest hardware address
pri sDIP		$0C @SOCKET ;		--- 4 byte dest IP address
pri sDPORT		$10 @SOCKET ;		--- 2 byte dest port
pri sSSIZE		$12 @SOCKET ;		--- 2 byte dest max seg size
pri sPRO		$14 @SOCKET ;		--- protocol in IP raw mode

pri sRXMEM		$1E @SOCKET ;
pri sTXMEM		$1F @SOCKET ;
pri TXFREE@		$20 @SOCKET LW@ ;
pri TXREAD		$22 @SOCKET ;
pri TXWRITE		$24 @SOCKET ;
pri RXSIZE@		$26 @SOCKET LW@ ;
pri RXREAD		$28 @SOCKET ;
pri RXWRITE		$2A @SOCKET ;
pri KEEPTMR		$2D @SOCKET ;	--- keep alive timer

\ Protocol modes
pri CLOSED		0 sMODE LC! ;
pub TCP			1 sMODE LC! ;
pub UDP			2 sMODE LC! ;
pri IPRAW		3 sMODE LC! ;
pri MACRAW		4 sMODE LC! ;
pri PPPoE		5 sMODE LC! ;





( SOCKET COMMANDS - use currently select socket )

pub sOPEN		1 sCMD! ;
pub sLISTEN		2 sCMD! ;
pub sCONNECT		4 sCMD! ;
pub sDISCON		8 sCMD! ;
pub sCLOSE		$10 sCMD! ;
pub sSEND		$20 sCMD! ;
pub sSENDMAC		$21 sCMD! ;
pub sSENDKEEP		$22 sCMD! ;
pub sRECV		$40 sCMD! ;


pri sCLOSED? 		sSTAT@ 0= ;
pri sINACTIVE?		sSTAT@ $17 < ;
pri sESTAB?		sSTAT@ $17 = ;
pri sCLOSING?		sSTAT@ $18 $1B WITHIN ;	--- closing or wait closing
pri sCONNECTED?		sINTS LC@ &CON AND DUP IF &CON sINTS LC! THEN ; --- Test and reset the connection interrupt;
pri sDISCON?		sINTS LC@ &DISCON AND DUP IF -1 sINTS LC! THEN ;





pub SetPORT
 	sPORT LW!
 	;
pub PORT! ( srcport -- ) --- save port config and set port
 	DUP SKT@ 4* @ports + EE!
	SetPORT
	;

( Set the factory defaults on very first run - generate a random MAC in the 01.FF.xx.xx.xx.xx range )
pub WCOLD
	CRLF ." Setting default IP configuration "
 	myGW @gateway EE!
 	myIP @sip EE!
 	mySN @subnet EE!
---  random MAC at first run, Need to have a unique ID
 	RND @mac EE!
 	8 0 DO 0 I 4* @ports + EE! LOOP
 	$A55A @wcold EE!
 	;

\ Init the SPI for the WIZnet chip
pub !WIZIO		@wizpins SPIPINS @COMMON ;

$02FF := oui2

pub !WIZIP
 	@wcold EE@ $A55A <> IF WCOLD THEN
--- Assign a default gateway
	@gateway EE@ GATEWAY
	@subnet EE@ SUBNET
	@sip EE@ SIP
	oui2 @mac EE@ MAC
  	8 0 DO I 4* @ports + EE@ I SOCKET SetPORT LOOP
	;

pri !TXBUFS	BUFFER $800 ERASE 8 FOR I SOCKET @TX BUFFER 0 $800 LWRITE @RX BUFFER 0 $800 LWRITE NEXT ;

pub !WIZ 	!WIZIO !TXBUFS !WIZIP ;


byte autosend		--- Flag to control whether LANSEND sends when it receives a LF or not
$0A autosend C!		--- preset to autosend



{ Since the W5500??? read and write index registers are unreadable until a connection has been established
or cannot be written incrementally until a send then these are buffered for when they become readable
}

--- tx write buffers for 8 sockets
8 words txwr

pub @txwr ( -- addr )   	txwr SKT@ 2* + ;
pub txwr@ ( -- value )		@txwr W@ ;

--- invalidate all txwr pointers (W5500 workaround)
pub !TXWR		txwr 16 $FF FILL ;

long txtime
long txsize

\ TIMER sendtimer
pri WAITSEND ( -- )
--- don't bother if it's empty
 	txsize @ 0EXIT
	1000
 	FOR
--- until sent
 	  sINTS LC@ &SENDOK AND
 	  TXREAD LW@ TXWRITE LW@ = AND
 	?NEXT DROP
--- reset the sent interrupt flag
 	&SENDOK sINTS LC!
 	;

\ Request WIZnet to send off current transmit data in buffer
pub LANSEND ( -- )
--- Clear send interrupt
 	&SENDOK sINTS LC!
--- update TXWRITE register and command WIZnet to SEND
 	txwr@ TXWRITE LW! sSEND
	WAITSEND
--- reset txsize (buffer empty)
  	txsize ~
 	;

--- check to see if anything still needs to be sent
pub ?SEND ( -- )
--- 	Exit if buffer empty
 	txsize @ 0EXIT
	LANSEND
	;

pub ?SENDPOLL
--- 	1/128 sec timeout since last
	txtime @ CNT@ - ABS CLKHZ 7 >> >
 	0EXIT ?SEND
	;


--- send out a character through the WIZnet - either block mode or autosend
pub LANEMIT ( ch -- )
 	txwr@
---	 write character to buffer
	OVER SWAP ( ch ch index ) @TX LC!
  	@txwr W++ CNT@ txtime !
 	txsize ++
--- 	SEND if this is an CRLF end of line and autosend is active
	$0A = autosend C@ AND
--- 	AUTOSEND if buffer size is large enough already
 	txsize @ $3F0 > OR
	  IF LANSEND THEN
	;


pub LANKEY ( -- ch )
 	RXSIZE@
 	IF
--- 	read a character from the receive buffer
 	  RXREAD LW@ DUP @RX LC@
--- 	update read index
 	  SWAP 1+ RXREAD LW! sRECV
 	ELSE
--- 	implement a keypoll for when LANKEY is doing nothing
\ 	  keypoll W@ ?DUP IF CALL THEN
 	  0
 	THEN
	;

( Redirect console output to the LAN )
pub LAN
	' LANEMIT uemit W!
 	' LANKEY ukey W!
--- 	force an update (assumed valid) if the index is "invalid"
	@txwr @ -1 = IF TXWRITE LW@ @txwr ! THEN
	;

( diagnostic to the terminal to reflect what is begin typed to the LAN )
pub LANCONEMIT
 	DUP MBXEMIT LANEMIT
 	;

--- use both LAN and CON for output
pub LANCON
	CONIO CRLF LAN
 	' LANCONEMIT uemit W!
	;


	long	lanpolls
pri LANPOLL	NOP lanpolls ++ ;

  	byte _get#
33 	bytes _get$

pub INPUT$ ( -- str )
	_get# 32 ERASE
	BEGIN BEGIN ( LANPOLL ) LANKEY lanpolls -- ?DUP UNTIL
	DUP $0D <>
	WHILE _get# C@ $1F AND _get$ + C! _get# C++
	REPEAT
	DROP _get$
	;





--- set WIZnet chip as source for any DUMP type operations
pub WIZ    DUMP: LC@ LW@ L@ ;

$800	:= WBUFSZ


pri LSEND 		DUP @txwr W+! TXWRITE LW@ SWAP @TX LWRITE LANSEND ;

long vread
long vwrite --- maintain a read/write pointer for any virtual memory writes


---  Read from WIZnet buffer into file until buffer is exhausted
--- Used by FTP STOR
pri LREADSKT ( dst --- )
	vwrite !
	BEGIN
	  RXSIZE@ ?DUP
	WHILE ( cnt )
--- 	fetch receive read index for this socket
	  RXREAD LW@ ( cnt index )
 	  SWAP
	  vwrite @ SWAP ( wizptr filedst cnt )
	  DUP >R
--- 	read WIZnet buffer directly into file and update vwrite+1
	  @RX LREAD vwrite ++
--- 	update read index in advance
	  R> RXREAD LW@ + RXREAD LW!
--- 	signal that buffer up to READ index has been read
	  sRECV
	  10 ms
	REPEAT
	;


16 longs sktbuf						--- holding buffer for socket registers

pri @SKTBUF 		sktbuf + ;

pri .IPX	DUP >B .AS" ###" 8>> ;

pub .IP1
	 @SKTBUF @
	.IPX "." EMIT .IPX "." EMIT .IPX "." EMIT .IPX DROP
	;

pri .IP ( off -- )		3 SPACES .IP1 ;



pri .PTR  		C@++ 8<< SWAP C@ + ( $7FF AND ) .WORD "." EMIT ;

pri .@SKTBUF		@SKTBUF .PTR ;

IFNDEF SWAPB
pri SWAPB ( word -- word2 	\ Swap the bytes in a 16-bit word )
 	DUP 8>> SWAP >B 8<< OR
 	;
}


{
SKT HH:MM:SS MODE  PORT DEST  TXRD TXWR RXRD RXWR RXSZ  IR STATUS        	IP ADDR
#1  00:00:00 TCP 	21 52775 967F.967F.	.	.	. 00 17 ESTABLISHED	192.168.016.002.
}
pub .SKTHD		CRLF BOLD ." SKT HH:MM:SS MODE  PORT  DEST TXRD TXWR RXRD RXWR RXSZ  IR STATUS            IP ADDR" PLAIN ;

 pub .SKT
	DUP SOCKET 0 sktbuf $30 @SOCKET LREAD			--- read in registers
	0 @SKTBUF C@ IF CRLF "#" EMIT . 2 SPACES .TIME ELSE DROP BREAK
 	0  @SKTBUF C@ SPACE
	4* " CLSDTCP UDP IPRWMACRPPP !06!!07!" + 4 CTYPE SPACE
	4 @SKTBUF W@ SWAPB 5 U.R SPACE				--- PORT
 	16 @SKTBUF W@ SWAPB 5 U.R SPACE 			--- DPORT
	$22 .@SKTBUF $24 .@SKTBUF				--- TXRD TXWR
 	$28 .@SKTBUF $2A .@SKTBUF				--- RXRD RXWR
 	$26 .@SKTBUF SPACE					--- RX SIZE
  	2 @SKTBUF C@ .BYTE SPACE				--- INT REG
 	3 @SKTBUF C@ DUP .BYTE					--- STATUS REG
\	pri .SSTAT ( byte -- )					--- STATUS DESCRIPTION
 	SWITCH SPACE
 	  0 CASE ." closed      " BREAK
 	$13 CASE ." INIT        " BREAK
 	$14 CASE ." LISTEN      " BREAK
	$16 CASE ." SYNRECV     "  $0C .IP BREAK
   	$17 CASE ." ESTABLISHED "  $0C .IP BREAK
  	$18 CASE ." FIN WAIT    "  $0C .IP BREAK
 	$1C CASE ." closed wait " $0C .IP BREAK
 	$22 CASE ." UDP OPEN    " BREAK
 	$32 CASE ." IPRAW OPEN  " BREAK
 	;

pub .SOCKET ( n -- )	.SKTHD .SKT ;

pub .SOCKETS
	.SKTHD 8 0 DO I .SKT LOOP CRLF
	;
pub ifconfig
	0 sktbuf $40 @COMMON LREAD	\ read in common registers
 	BOLD
	CRLF ." NETWORK STATUS:" PLAIN
 	CRLF ." LINK " 		1 $2E @SKTBUF SET? IF ." *UP*" ELSE ." DOWN" THEN
	CRLF ." HARDWARE: " PCB$ PRINT$ ."  using WIZnet W5500 V" $39 @SKTBUF C@ .
 	CRLF ." SRC IP "	$0F .IP
 	CRLF ." MASK   "	5 .IP
 	CRLF ." GATEWAY"	1 .IP
	CRLF ." MAC       "	9 @SKTBUF 6 ADO I C@ .BYTE ." ." LOOP
	.SOCKETS
	;

\ SOCKETS - W5500 has 8 sockets - define 4 of them
0	:= NETMAN --- network management
1	:= FTP
2	:= FTPDAT
3	:= TELNET
4	:= HTTP --- uses sockets 4..7
32 bytes skt$ " NETFTPDATTELWEBWEBWEBWEB" skt$ $!

{

8 0 DO CRLF I SKT @RX 0 $40 WIZ DUMP  @TX 0 $40 WIZ DUMP @SOCKET 0 $40 WIZ DUMP  LOOP


}

\ END






\ TAQOZ



IFDEF *EASYNET*
netvars org
FORGET *EASYNET*
}

pub *EASYNET*		." WIZNET NETWORK SERVERS 160707.1500 " ;



: FILEIN	KEY: FGET ;
: FSIZE@	dirbuf 28 + @ ;

: FILE$		file$ ;
: RENAME$	2DROP ;
: RIGHT$	DUP LEN$ ROT - + ;
: (cat)		0 SD PRINT$ ;
: APPEND	DROP ;
: FSTAMP	;
: TIMEOUT	2DROP ;
: ALARM		2DROP ;



0 bytes netvars

long @FWRITE


pub READYLED		DROP ;
pub LANLED		DROP ;
pri LEDS		NOP ;


pub LOCATE$ ( ch str -- str \Locate the first ch in the string and return else null )
	0 SWAP DUP LEN$ ADO OVER I C@ = IF DROP I LEAVE THEN LOOP
	NIP
	;

pub COMPARE$ ( str1 str2 -- flg \ Compare two strings for equality )
	OVER LEN$ OVER LEN$ =
	IF
	DUP LEN$
	ADO C@++ I C@ <> IF DROP 0 LEAVE THEN LOOP
	0<>
	ELSE 2DROP FALSE
	THEN
	;


pri UNKNOWN
\ 	delim C@ 1+ $0D <> IF BEGIN KEY $0D <> WHILE DROP REPEAT THEN		\ if there is more than get it and discard
	1000 BEGIN  BEGIN KEY WHILE DROP 1000 REPEAT 1- ?DUP 0= UNTIL
	LANCON ." 550 Unknown command " @WORD PRINT$ CRLF LANSEND
	;



\ LANLED blink variables
byte ledcnt
byte ledon


( Console diagnostic message handler )
byte msgs
pub MSGS ( on/off -- ) msgs C! ;

long msgstk
pri <MSG ( level -- )				--- print message to console if message priority is => message setting with 0 being the highest
	uemit @ msgstk ! msgs C@ <=
 	  IF CONIO ELSE NULL THEN
 	CR REVERSE .DT ."  #" SKT@ DUP PRINT SPACE 3 * skt$ + 3 CTYPE SPACE
 	;
pri MSG>	PLAIN CRLF msgstk @ uemit ! ;


pri FlushSkt				@WORD 1- 32 ERASE ;		--- erase any garbage that has already been accumulated


{ HELP LANSKT ( -- )
Set console's socket backup to the current one - allows console processing of server commands
}
\ pub LANSKT				SKT@ skt2 C! LAN ;

{ HELP UpdateTXWR
Due to limitations of WIZnet read/write register access a copy is maintained and updated when possible
}
---					TXWRITE is now readable - buffer it
pri UpdateTXWR				TXWRITE LW@ @txwr W! ;


\ TIMER contd
3 longs contd

---					ms 300 seconds = 5 MINS
pri KEEPALIVE				300,000 contd TIMEOUT ;


--- background timer cog can only request a disconnect
byte disreq
--- timeout sets disreq flag which is handled by main loop
pri DISCREQ				disreq C~~ ;

pub CONNECTED? ( -- flg )
---	Has CONNECT interrupt been set?
	sCONNECTED?
	DUP IF
---	Setup Tachyon to handle command/response mode
	   UpdateTXWR
	   1 <MSG ." CONNECT " MSG>
---	let console know what is happening
	  CONIO SKT@ .SOCKET
---	discard any console input as well
\ 	    BEGIN BEGIN KEY 0= UNTIL 3 ms KEY 0= UNTIL
---	flush out anything already sitting there
 	  LAN KEEPALIVE ON LANLED FlushSkt
	  ' DISCREQ contd ALARM
	THEN
	;
{ HELP DISCONNECT
Disconnect socket (which may progress through DISCON WAIT) and flip the shell back to the console
Report the socket status
}
pub DISCONNECT				sDISCON CONIO SKT@ .SOCKET LAN ;

pub DSCTD? ( -- flg )
	disreq C@ sESTAB? AND
---	process disconnect req if active
 	  IF DISCONNECT disreq C~ 0 contd ALARM THEN
---	or if it's closed OR closing or $1C? (gets stuck on CLOSE WAIT??)
 	sCLOSED? sCLOSING? OR sSTAT@ $1C = OR
---	disconnect interrupt? OR closed - ok
 	sDISCON? OR DUP
 	IF
	 1 <MSG ."   LISTENING " MSG>
	  sCLOSE sOPEN sLISTEN
	  OFF LANLED
 	  FlushSkt CONIO
 	  SKT@ .SOCKET
	THEN
	;
{
pri DISCONNECTED? ( -- flg )
	disreq C@ sESTAB? AND
 	  IF DISCONNECT disreq C~ 0 contd ALARM THEN 			--- process disconnect req if active

 	sCLOSED? sCLOSING? OR 						--- or if it's closed OR closing or $1C?
 	sSTAT@ $1C = OR						--- CLOSE WAIT - check this out - gets stuck on this
( #2  22:09:58 TCP 	80 39416 EE08.EE08.  83.  83.	. 00 1C closed wait	150.070XXXX )
 	sDISCON? OR DUP 							--- disconnect interrupt? OR closed - ok
 	IF
	 1 <MSG ."   LISTENING " MSG>
	  sCLOSE sOPEN sLISTEN
	  OFF LANLED
 	  FlushSkt CONIO
 	  SKT@ .SOCKET
	THEN
	;
}
pri CONNECT
	 1 <MSG ." CONNECTING "
	3000 contd TIMEOUT							--- allow up to 3 seconds to connect
	  BEGIN sESTAB? contd TIMEOUT? OR UNTIL 				--- Wait for it to be established (WIZNET regsiter quirks)
 	KEEPALIVE
	TXWRITE LW@ @txwr W! 						--- refresh txwrite (treat as new connection)
	( ." ---  CONNECTED " MSG> )
	;

byte constat 									--- relay connection status to application
pri STAT!		constat C! ;

{ TELNET IACs
pri /DO		253
pri IAC ( cmd -- ) 255 EMIT EMIT ;
pri /SB		250 IAC ;
pri /SE		240 IAC ;
pri /WILL		251 IAC ;
pri /WONT		252 IAC ;
pri /DONT		254 IAC ;

pri /NAWS		31 EMIT ;
pri /LINEMODE 	34 EMIT ;
pri /ECHO		1 EMIT ;
}


--- define a "bye" especially for telnet sessions.

: BYE	DISCONNECT ;
: QUIT	DISCONNECT ;

pri ?TELNET
---	check telnet socket new connection?
	TELNET SOCKET CONNECTED?
	IF
---	indicate connection status active as Telnet
 	  "T" STAT!
---	be interactive but not reset etc with certain controls
  	  1 flags 1+ SET
	  ledcnt C~
\ 	  CON CR LAN
---		let 1/128 timeout handle characters or blocks
	  LAN  autosend C~
---	execute IAC script to setup remote telnet client
	  " TELNET.INI" FOPEN$ IF FILEIN THEN
 	  WAITSEND 	  " WELCOME.TEL" FOPEN$
 	    IF (cat)
---	default Welcome banner
 	    ELSE ." WELCOME TO THE TACHYON WIZNET TELNET SESSION!" CRLF
 	    THEN
---	Reset rx buffer and receive --- redirect console to this LAN socket
	  FlushSkt LAN
	  KEEPALIVE
	THEN
---	Process disconnection
	DSCTD? IF
 	   0 <MSG ." SESSION ENDED " CR MSG>
 	  "t" STAT! CONIO
 	  1 flags 1+ CLR
 	THEN
	;


pub RESOLVE ( namestr -- ip )
 	HTTP SOCKET
 	;
{
HTTP/1.0 302 Found
Cache-Control: private
Content-Type: text/html; charset=UTF-8
Location: http://www.google.com.au/?gfe_rd=cr&ei=UH_EVO24O63u8wfd74GYAQ
Content-Length: 262
Date: Sun, 25 Jan 2015 05:29:52 GMT
Server: GFE/2.0
Alternate-Protocol: 80:quic,p=0.02

<HTML><HEAD><meta http-equiv="content-type" content="text/html;charset=utf-8">
<TITLE>302 Moved</TITLE></HEAD><BODY>
<H1>302 Moved</H1>
The document has moved
<A HREF="http://www.google.com.au/?gfe_rd=cr&amp;ei=UH_EVO24O63u8wfd74GYAQ">here</A>.
</BODY></HTML>
}
pub GETTIME
 	HTTP SOCKET
 	" google.com" RESOLVE HTTP SOCKET $0C L!			--- contact google.com and set dest IP
 	LAN ." GET /" CRLF						--- issue GET request

 	--- Date: Sun, 25 Jan 2015 05:29:52 GMT


 	;


\ Print the byte as a decimal number
pri .BYTEDEC ( byte -- )		>B .DEC ;

pri COMMA				"," EMIT  ;

pri .IPD ( long -- ) 	DUP 24 >> .BYTEDEC COMMA DUP 16>> .BYTEDEC COMMA DUP 8>> .BYTEDEC COMMA .BYTEDEC ;


16 bytes user$ " user" user$ $!

16 bytes pass$ " pass" pass$ $!

word dataport

20 dataport W!			\ Default FTP data port


pri GETFNAME
	INPUT$ DUP C@ "/" = IF 1+ THEN						--- adjust name if / is used
 	DUP LEN$ 1- OVER  + C@ "." = IF 0 OVER DUP LEN$ 1- + C! THEN 		--- remove final period
 	;


pri ECHOREQ
 	CONIO CRLF BEGIN LANKEY DUP EMIT 0= UNTIL					--- Just echo the request to the console for now
 	;

( FTP COMMANDS )
( FTP COMMANDS LINK )


{ HELP USER
FTP COMMAND
Syntax: USER username
Send this command to begin the login process. username should be a valid username on the system, or "anonymous" to initiate an anonymous login.
}
pre USER
	ON LANLED
	INPUT$ user$ $!
	." 331 User admin OK. Password required" CRLF
	;

pre PASS
	ON LANLED
	INPUT$ pass$ $!
	." 230 OK. Current restricted directory is /" CRLF
	;

long type

{ HELP TYPE
FTP COMMAND
Syntax: TYPE 	type-character [second-type-character]
Sets the type of file to be transferred. type-character can be any of:
A - ASCII text
E - EBCDIC text
I - image (binary data)
L - local format
For A and E, the second-type-character specifies how the text should be interpreted. It can be:
N - Non-print (not destined for printing). This is the default if 	second-type-character is omitted.
T - Telnet format control (<CR>, 	<FF>, etc.)
C - ASA Carriage Control
For L, the second-type-character specifies the number of bits per byte on the local system, and may not be omitted.
}
pre TYPE
	ON LANLED
	INPUT$ type 4 CMOVE
	LAN ." 200 TYPE is now " type C@ EMIT CRLF
	;

{ HELP PORT
FTP COMMAND
Syntax: PORT 	a1,a2,a3,a4,p1,p2
Specifies the host and port to which the server should connect for the next file transfer.
This is interpreted as IP address a1.a2.a3.a4, port p1*256+p2.
}
pre PORT 	\ accept port number
	ON LANLED
	INPUT$ NUMBER dataport W!
	LAN ." 200 Port is now " dataport W@ .DEC CRLF
	;

\ Define min and max for FTP passive ports
40,000 	:= #ftpmin
50,000 	:= #ftpmax

\ 227 Entering Passive Mode (192,168,16,106,248,252)
{ HELP PASV
FTP COMMAND
Syntax: PASV
Tells the server to enter "passive mode". In passive mode, the server will wait for the client to establish a connection with it rather than attempting to connect to a client-specified port. The server will respond with the address of the port it is listening on, with a message like:
227 Entering Passive Mode 	(a1,a2,a3,a4,p1,p2)
where a1.a2.a3.a4 is the IP address and p1*256+p2 is the port number.
}
pre PASV
	ON LANLED
	#ftpmax #ftpmin GETRND dataport W!						\ pick a random port in the specified range
	FTPDAT SOCKET sCLOSE 								\ Prep the data port socket
	TCP dataport W@ SetPORT sOPEN sLISTEN   					\ Set the port and open listen for connection
 	 1 <MSG ." FTPDAT CONNECT " MSG>
	\ respond that all is accepted
	FTP SOCKET LAN									\ switch back to FTP socket
	." 227 Entering Passive Mode with port " \ dataport W@ .DEC		\ Response with msg and port
	." (" @sip EE@ .IPD COMMA dataport 1+ C@ .BYTEDEC COMMA dataport C@ .BYTEDEC ." )" CRLF
	;

{ HELP SYST
FTP COMMAND
Syntax: SYST
Returns a word identifying the system, the word "Type:", and the default transfer type (as would be set by the TYPE command).
For example: UNIX Type: L8
}
pre SYST
	ON LANLED
	." 215 Unix Type: L8" CRLF
	;




pre FEAT
	ON LANLED
	." 211 no Features supported" CRLF
{	." 211-no Features supported" CRLF
 	."  yet to be implemented" CRLF
 	." 211 End" CRLF
}
	;

{ HELP MDTM
FTP COMMAND
  The server-PI will respond to the MDTM command with a 213 reply
   giving the last modification time of the file whose pathname was
   supplied, or a 550 reply if the file does not exist, the modification
   time is unavailable, or some other error has occurred.

      mdtm-response = "213" SP time-val CRLF /
                      error-response
Example response:
213 19980615100045.014
}
pre MDTM
 	ON LANLED
  	GETFNAME FOPEN$ DROP
 	autosend C~~
	." 550 Modification time not available" CRLF
	;


{ HELP CDUP
FTP COMMAND
Syntax: CDUP
Makes the parent of the current directory be the current directory.
}
pre CDUP
	  ON LANLED
	." 250 Directory successfully changed" CRLF
	;


16 bytes cwd$ " FILENAME.TXT " cwd$ $!

{ HELP CWD
Syntax: CWD remote-directory
Makes the given directory be the current directory on the remote host
}
pre CWD ( <name> )
	ON LANLED
	INPUT$ DUP cwd$ $! DUP " /" $= SWAP LEN$ 0= OR
 	IF
 	  ." 250 okay"
	ELSE
	  ." 550 Not a directory"
	THEN
 	CRLF
	;

{ HELP PWD
Syntax: PWD
Returns the name of the current directory on the remote host.
}
pre PWD
	ON LANLED
	." 257 " $22 EMIT "/" EMIT $22 EMIT ."  is your current location" CRLF
	;



pub ?DISCONNECT   	300 ms DISCONNECT ;

{ HELP LIST
FTP COMMAND
Syntax: LIST [remote-filespec]
If remote-filespec refers to a file, sends information about that file. If remote-filespec refers to a directory, sends information about each file in that directory. remote-filespec defaults to the current directory. This command must be preceded by a PORT or PASV command.
}
pre LIST
 	delim 1+ C@ $20 = IF INPUT$ DROP THEN                 --- ignore a remote-filespec
 	uemit W@ --- allow this to be dumped to the console in interactive mode
 	IF
	  KEEPALIVE
	  ON LANLED LANCON	." 150 Here comes the directory listing" CRLF LANSEND
	   1 <MSG ." LIST REQUEST " MSG>
	  FTPDAT SOCKET CONNECT
 	  autosend C~
	  LAN .LIST							--- Send off the directory listing in compatible format
	  LANSEND WAITSEND
 	  50 ms
	  FTPDAT SOCKET DISCONNECT
	  autosend C~~
	  FTP SOCKET LANCON ." 226 Directory send OK" CRLF LANSEND
	   1 <MSG ." LIST SENT " MSG>
	  ?DISCONNECT
 	ELSE
	  CRLF .LIST
	THEN
	;

{ This is how most UNIX, Novell, and MacOS ftp servers send their time
                                  Jul 06 12:57 or Jul  6  1999
-rwxrwxrwx	1 502  	500 	674 Sep  4  2014 HELP.TXT
-rwxrwxrwx	1 502  	500   65536 Sep  4  2014 FIRMWARE.ROM
}
{ Feature list from NAS FTP
211-Extensions supported:
 EPRT
 IDLE
 MDTM
 SIZE
 REST STREAM
 MLST type*;size*;sizd*;modify*;UNIX.mode*;UNIX.uid*;UNIX.gid*;unique*;
 MLSD
 TVFS
 ESTP
 PASV
 EPSV
 SPSV
 ESTA
 AUTH TLS
 PBSZ
 PROT
 UTF8
211 End.
}


long blkpoll
512 := BUFSIZ

--- BLKSEND will send a file sector by sector
--- send chunks of up to one complete sector at buffer address
pri BLKSEND ( xaddr cnt -- )
	?DUP 0= IF DROP EXIT THEN
	BEGIN
	  OVER SDADR OVER BUFSIZ MIN ( xaddr cnt bufadr bufcnt )		\ grab it a sector at a time
	  DUP >R LSEND									\ copy source buffer directly to socket tx buffer
\         blkpoll W@ ?DUP IF CALL THEN						\ callback hook used by applications
	  ( src cnt )
	 R> DUP >R - SWAP R> + SWAP ( xaddr cnt )					\ update source parameters block by block
	  DUP 0=									\ until the source buffer is exhausted (cnt=0)
 	  sCLOSED? OR									\ or if closed
	UNTIL
	2DROP
	;

--- Send the currently open file in block mode
pub SENDFILE ( offset -- )	FSIZE@ OVER - BLKSEND ;

{ HELP SIZE
FTP COMMAND
Syntax: SIZE remote-filename
Returns the size of the remote file as a decimal number.
}
pre SIZE
	ON LANLED
  	GETFNAME FOPEN$
 	 1 <MSG ." SIZE " FILE$ PRINT$ MSG>
 	LANCON
	IF
	  ." 213 "  FSIZE@ .DEC
	ELSE
 	  ." 550 Could not get file size."
 	THEN
 	CRLF LANSEND
	;
{

0000_C800:   55 53 45 52  20 61 6E 6F   6E 79 6D 6F  75 73 0D 0A   USER anonymous..
0000_C810:   50 41 53 53  20 63 68 72   6F 6D 65 40  65 78 61 6D   PASS chrome@exam
0000_C820:   70 6C 65 2E  63 6F 6D 0D   0A 53 59 53  54 0D 0A 50   ple.com..SYST..P
0000_C830:   57 44 0D 0A  54 59 50 45   20 49 0D 0A  50 41 53 56   WD..TYPE I..PASV
0000_C840:   0D 0A 53 49  5A 45 20 2F   0D 0A 50 41  53 56 0D 0A   ..SIZE /..PASV..
0000_C850:   43 57 44 20  2F 0D 0A 4C   49 53 54 20  2D 6C 0D 0A   CWD /..LIST -l..

550 Could not get the file size
}

--- send accepted or rejected message to FTP client
pri FTPMSG ( flg -- )
 	FTP SOCKET LANCON
	IF
	  ON LANLED
	  ." 150 Accepted data connection for " FILE$ PRINT$ CRLF LANSEND
	  FTPDAT SOCKET CONNECT LAN
 	ELSE
	  ." 550 File not available" CRLF LANSEND
	THEN
 	;

--- FTP rename file request ---

16 bytes RNFR$ " FILENAME.EXT" RNFR$ $!    \ place for source string for rename (PBJ: 0 STRING or #12 > req for null term.)

{ HELP RNFR
FTP COMMAND
Syntax: RNFR from-filename
Used when renaming a file. Use this command to specify the file to be renamed; follow it with an RNTO command to specify the new name for the file.
}
pre RNFR
 	GETFNAME RNFR$ $!
 	FTP SOCKET LANCON ." 350 Waiting for RNTO" CRLF LANSEND
 	;

{ HELP RNTO
FTP COMMAND
Syntax: RNTO to-filename
Used when renaming a file. After sending an RNFR command to specify the file to rename, send this command to specify the new name for the file.
}
pre RNTO
 	RNFR$ FOPEN$ DROP GETFNAME RENAME$
 	FTP SOCKET LANCON ." 250 Rename done" CRLF LANSEND
 	;


{
Command:	RETR PREVIOUS.ROM
Response:	150 Accepted data connection for PREVIOUS.ROM
Response:	226 File successfully transferred
Status:	File transfer successful, transferred 65,536 bytes in 1 second
}

--- FTP Retrieve a file i.e. RETR /LOG0001.TXT ---
{ HELP RETR
FTP COMMAND
Syntax: RETR remote-filename
Begins transmission of a file from the remote host. Must be preceded by either a PORT command or a PASV command to indicate where the server should send data.
}
pri (RETR) ( position flg/addr -- )
 	DUP FTPMSG
 	IF ( position )
	  FILE$ 3 RIGHT$ " LOG" $=
  	  IF										\ If it's a log file then just send up to EOF marker
 	    DROP 0 APPEND
 	      IF @FWRITE @ OVER - 16 MAX ELSE FSIZE@ THEN
 	    BLKSEND 									\ Just send all the text up to the EOF or at least 16
 	  ELSE 									\ else send the whole file
 	    SENDFILE
 	  THEN
	  100 ms
	  ?SEND
  	  DISCONNECT --- close the data connection
	  FTP SOCKET
 	  LANCON ." 226 File successfully transferred" CRLF LANSEND 	\ Announce successful transfer
 	ELSE
 	  DROP
	THEN
 	FTP SOCKET ?DISCONNECT
	;

pre RETR
	KEEPALIVE
	GETFNAME FOPEN$ 								\ get the file name and try to open it
 	0 SWAP (RETR)
	;


{ HELP STOR
FTP COMMAND
Syntax: STOR remote-filename
Begins transmission of a file to the remote site. Must be preceded by either a PORT command or a PASV command so the server knows where to accept data from.
Usage
Command:	STOR PREVIOUS.ROM
Response:	150 Accepted data connection for PREVIOUS.ROM
Response:	250 File rcvd PREVIOUS.ROM
Status:	File transfer successful, transferred 65,536 bytes in 5 seconds
}
pre STOR
	KEEPALIVE
	GETFNAME 							--- get file name to store
	FOPEN$ RW 							--- try to open it for overwrite
	DUP FTPMSG 							--- send appropriate FTP message if accepted or not, connect to FTPDAT if accepted
 	?SEND
 	IF
 	   1 <MSG ." STOR " FILE$ PRINT$ MSG>
	  FTPDAT SOCKET
	  BEGIN
	    @FWRITE @
	    LREADSKT ( dst --- )
 	    vwrite @ @FWRITE !							--- update file write index
 	    DSCTD?
 	  UNTIL
	  FTP SOCKET LANCON ." 250 File rcvd " FILE$ PRINT$ CRLF LANSEND
 	  FSTAMP
 	   1 <MSG ." FILE RCVD"  MSG>
	THEN
    	FTPDAT SOCKET ?DISCONNECT
 	FTP SOCKET ?DISCONNECT
	;




{ HELP REST
FTP COMMAND
Syntax: REST position
Sets the point at which a file transfer should start; useful for resuming interrupted transfers. For nonstructured files, this is simply a decimal number. This command must immediately precede a data transfer command (RETR or STOR only); i.e. it must come after any PORT or PASV command.
}
pre REST ( <position> )
	INPUT$ NUMBER 				--- read the offset specified
 	(RETR)						--- retrieve as usual from this offset
	;




{                   Tachyon FTP session
Status:	Connecting to 192.168.16.151:21...
Status:	Connection established, waiting for welcome message...
Response:	220 WELCOME TO THE TACHYON WIZNET FTP SESSION!
Command:	USER admin
Response:	331 User admin OK. Password required
Command:	PASS *****
Response:	230 OK. Current restricted directory is /
Status:	Server does not support non-ASCII characters.
Status:	Connected
Status:	Retrieving directory listing...
Command:	CWD /
Response:	250 Directory successfully changed
Command:	TYPE I
Response:	200 TYPE is now I
Command:	PASV
Response:	227 Entering Passive Mode with port (192,168,16,151,173,118)
Command:	LIST
Response:	150 Here comes the directory listing
Response:	226 Directory send OK
Status:	Directory listing successful

}



( *** FTP SERVER 	- relies on the Forth console to interpret FTP commands directly *** )

	byte ftp#
33 	bytes ftp$

pub !FTPCON	ftp# 34 ERASE ;

pub ?FTPCON
	LANKEY ?DUP 0EXIT
\	DUP MBXEMIT
	DUP $21 <
	IF
	  DROP ftp# C@ 0EXIT \  CONIO CRLF PRINT" FTP COMMAND: " ftp# $10 DUMP \ PRINT$ CRLF
	  LAN ftp$ SEARCH ?DUP IF CFA CALL ELSE ftp$ NUMBER 0= IF UNKNOWN THEN THEN
	  !FTPCON
	ELSE ftp# C@ $1F AND ftp$ + C! ftp# C++
	THEN
	;


pri ?FTP
	FTP SOCKET
	\ sESTAB? IF ?FTPCON THEN
	?FTPCON

	CONNECTED? 						--- examine interrupt register for a new connection etc
	IF
\	 !FTPCON
 	  "F" STAT!
	  LAN autosend C~~

	    LANCON ." 220 WELCOME TO THE TACHYON WIZNET FTP SESSION!" CRLF --- Welcome banner
	  KEEPALIVE 						--- Give FTP a maximum 5 min session
	  LAN 						--- makes sure the console uses this connection and socket
	THEN
	DSCTD? IF "f" STAT! CONIO THEN
	;



( HTTP COMMANDS )

--- some WIP here while I sort out my webpage files and content formatting etc


\ Sample content header - just for testing
pri CONTENT ( str -- )
	1 <MSG ." CONTENT = " DUP PRINT$  MSG>
	LANCON autosend C~
	." HTTP/1.1 200 OK" CRLF
	." Date: Tue, 03 Dec 2013 04:19:05 GMT" CRLF
	." Server: Tachyon Forth " CRLF
	." Last Modified: Tue, 01 Jan 2014 12:00:00 GMT" CRLF
	." Accept-Ranges: bytes" CRLF
	." Content-Length: " FSIZE@ .DEC CRLF
	." Connection: close" CRLF
	." Content-Type: " PRINT$ CRLF
	autosend C~~ CRLF
	;








\ 48 bytes _get$


48 	:= getsz	--- limited in size by GET$ = 39 or implement new GETPARS to place string directly into GET$

pri ?CONTENT     \  MJB maybe later move to a table based approach
	 \ GET$ 3 RIGHT$
	"." _get$ LOCATE$ 1+   \ MJB prepare for other extensions like "JS"

	DUP " JPG" COMPARE$ IF DROP " image/jpg" CONTENT EXIT THEN		\ Send header for JPG files
	DUP " ICO" COMPARE$ OVER " PNG" COMPARE$ OR
	  IF DROP " image/png" CONTENT EXIT THEN					\ Send header for ICO/PNG files
	DUP " HTM" COMPARE$ IF DROP " text/html" CONTENT EXIT THEN		\ Send header for TEXT/HTML files
	DROP
	;

IFNDEF >UPPER
pri >UPPER  ( str1 --  ) --- Convert lower-case letters to upper-case
	DUP LEN$ ADO I C@ "a" "z" WITHIN IF I C@ $20 XOR I C! THEN LOOP
	;
}

pri GETTXT
 	0 APPEND DROP @FWRITE @ OVER - 16 MAX BLKSEND			\ Just send all the text up to the EOF or at least 16
 	;
pri GETHTX --- temp def
	GETTXT
	;



--- Send the requested page to the web client ---
pri GETPAGE
 	_get$ W@ " /" W@ = 								\ null GET / (root dir)
	  IF " HOME.HTM" \ DUP _get$ $!						\ Default request - open HOME.HTM
	  ELSE _get$ 1+ DUP >UPPER DUP _get$ $!				\ otherwise convert requested file name to uppercase
	  THEN
 	FOPEN$ NOT IF " HTTP404.HTM" FOPEN$ DROP THEN 				\ on file not found - use default 404 file
	LAN										\ Direct all output to the selected socket
	?CONTENT									\ Handle content headers
	1 <MSG ."  --> " FILE$ PRINT$ MSG>				\ echo name of actual file served
	UpdateTXWR @txwr W@ TXREAD LW!

	FILE$ 3 RIGHT$
  	DUP " TXT" $= IF DROP GETTXT ?SEND EXIT THEN				\ plain text file  ( only uppercase ?? or is >upper used somewhere?)
 	" HTX" $= IF GETHTX ?SEND EXIT THEN 					\ we have a html template file HTX with embedded FORTH

	0 FSIZE@ BLKSEND								\ or just send the whole file
	?SEND
	;

{ HELP HEAD
HTTP COMMAND
The HEAD method is identical to GET except that the server MUST NOT return a message-body in the response. The metainformation contained in the HTTP headers in response to a HEAD request SHOULD be identical to the information sent in response to a GET request. This method can be used for obtaining metainformation about the entity implied by the request without transferring the entity-body itself. This method is often used for testing hypertext links for validity, accessibility, and recent modification.
The response to a HEAD request MAY be cacheable in the sense that the information contained in the response MAY be used to update a previously cached entity from that resource. If the new field values indicate that the cached entity differs from the current entity (as would be indicated by a change in Content-Length, Content-MD5, ETag or Last-Modified), then the cache MUST treat the cache entry as stale.
}
pre HEAD  --- just repond back with the same head
	ECHOREQ
	;



{ HELP GET
HTTP COMMAND
The GET method means retrieve whatever information (in the form of an entity) is identified by the Request-URI. If the Request-URI refers to a data-producing process, it is the produced data which shall be returned as the entity in the response and not the source text of the process, unless that text happens to be the output of the process.
The semantics of the GET method change to a "conditional GET" if the request message includes an If-Modified-Since, If-Unmodified-Since, If-Match, If-None-Match, or If-Range header field. A conditional GET method requests that the entity be transferred only under the circumstances described by the conditional header field(s). The conditional GET method is intended to reduce unnecessary network usage by allowing cached entities to be refreshed without requiring multiple requests or transferring data already held by the client.
The semantics of the GET method change to a "partial GET" if the request message includes a Range header field. A partial GET requests that only part of the entity be transferred, as described in section 14.35. The partial GET method is intended to reduce unnecessary network usage by allowing partially-retrieved entities to be completed without transferring data already held by the client.
The response to a GET request is cacheable if and only if it meets the requirements for HTTP caching described in section 13.
}
pre GET ( <name> -- \ Open up the file name and send it ) 		--- /index.htm HTTP/1.1
	KEEPALIVE
	LAN INPUT$ LEN$ getsz => IF DROP " GET parameter too long" EXIT THEN
\ 	_get$ $! 									--- get the name and store in GET$  \ GET$
	1 <MSG ." GET " _get$ PRINT$ MSG>					--- Let me know about a request
	ECHOREQ
	GETPAGE
	;

1	:= #hskts							--- select from 1 to 4 sockets for HTTP processing

{ HELP ?HTTP
Service the HTTP server socket
}

pri ?HTTP
	HTTP #hskts ADO
 	I SOCKET
	?FTPCON
	CONNECTED?
	  IF
 	    "H" STAT!
	    KEEPALIVE
	    LAN 							--- Let the same socket talk to the foreground Forth console when it switches back
	  THEN
 	  DSCTD? IF "h" STAT! CONIO THEN
 	LOOP
	;


\ ----------------------------------------------------------------------------------------------------------- \



pri ?LED
 	--- the LED should be blinking very briefly when it's idle but alive
	1 ledcnt C+! ledcnt C@ ledon C@ < LANLED LEDS
	--- reflect current connection status as a long or short blink
	constat C@ $61 < IF constat C@ ELSE 1 THEN ledon C!
 	;


( Main server loop - checks and services sockets - 1.3ms when idle )
pub ?EASYNET
\	?LED
\	?TELNET 								--- Poll the TELNET server
	?SENDPOLL
	?FTP 									--- Poll the FTP server
	?HTTP 									--- Poll the WEB server
\  	TRUE 8 0 DO I SOCKET sCLOSED? AND LOOP IF CONIO THEN			--- force console back to serial if not busy
  	DEPTH 8 > IF !SP THEN							--- clean up abnormal stack
	lanpolls ++
	;

pub RESTART		CONIO PLAIN ifconfig CRLF CRLF REBOOT ;

pub EASYNET
	58 4 ADO I FLOAT LOOP	--- release SPI I/O to SD
	1 RUN:
pub SERVER
	!SP
	$200 $300 $100 CMOVE $300 9 COG!
	lanpolls ~
	CONIO
	!SD DROP !SD DROP MOUNT
	CRLF ." *** TAQOZ EASYNET Network Servers and EASYFILE File Server *** " CRLF CRLF
	!WIZ 5000 @RTR LW! 16 @RCR LC!						--- setup retry counters
\	RND fboot !
	4 ledon C! 								--- just setup an LED blink time
	ON READYLED 								---  Now init the IP addresses (stored in high 64K EEPROM)
	TELNET SOCKET sCLOSE TCP 23 PORT!  sOPEN sLISTEN 			--- Setup TELNET but on port 10001
	FTP SOCKET sCLOSE TCP 21 PORT! sOPEN sLISTEN 				--- Setup FTP
	HTTP #hskts ADO I SOCKET sCLOSE TCP 80 PORT! sOPEN sLISTEN LOOP
	."  ... ready! " CRLF
	ifconfig 								--- report WIZnet status
  	0 STAT!
\	' ?EASYNET ' LANPOLL W!  \ +POLL 						--- Poll the server in the background
	CRLF ." * WEB, FTP, and TELNET servers running * "
	CRLF
	!FTPCON
	BEGIN ?EASYNET AGAIN
	;

\ pub SERVER.CONSOLE	CONIO BEGIN INPUT$ SEARCH ?DUP IF CFA CALL ELSE @WORD NUMBER 0= IF UNKNOWN THEN THEN AGAIN	;



: ??	lanpolls @ . ftp# QD ;

: GO 	ON MSGS EASYNET ;

\ AUTORUN EASYNET

\ : MYLED		IF $40 ELSE $100000 THEN LED! ;
\ ' MYLED ' LANLED W!

END
