IFDEF *TIA*	cc org FORGET *TIA* }

TAQOZ

pub *TIA*	PRINT" TAQOZ INTERACTIVE PASM2 CODE ASSEMBLER 200226-1800" ;

\ ALIAS \ //


public
{
COG REGISTER LAYOUT

The cog's 512 x 32 dual-port RAM, used for code and data, is mapped as follows:
}
( $000..$1EF    RAM            general-use code/data registers )
$1F0 :=     IJMP3       --- interrupt call   address for INT3
$1F1 :=     IRET3       --- interrupt return address for INT3
$1F2 :=     IJMP2       --- interrupt call   address for INT2
$1F3 :=     IRET2       --- interrupt return address for INT2
$1F4 :=     IJMP1       --- interrupt call   address for INT1
$1F5 :=     IRET1       --- interrupt return address for INT1
$1F6 :=     PA       	--- CALLD-imm return, CALLPA parameter, or LOC address
$1F7 :=     PB  	--- CALLD-imm return, CALLPB parameter, or LOC address

$1F8 :=     PTRA        --- pointer A to hub RAM
$1F9 :=     PTRB        --- pointer B to hub RAM
$1FA :=     DIRA        --- output enables for P31..P0
$1FB :=     DIRB        --- output enables for P63..P32
$1FC :=     OUTA        --- output states for P31..P0
$1FD :=     OUTB        --- output states for P63..P32
$1FE :=     INA         --- input states for P31..P0 also debug interrupt call address
$1FF :=     INB        --- input states for P63..P32 also debug interrupt return address


( fixed data registers )
' + COG@ 9 BITS		:= tos
tos			:= a
tos 1+			:= b
tos 2+			:= c
tos 3 +			:= d

( TAQOZ temporary registers )
' = 1+ COG@ 9 BITS	:= x
x 1+			:= y
x 2+			:= z
y			:= r0
z			:= r1
r1 1+			:= r2
r2 1+			:= r3
r3 1+			:= r4
x 1-			:= acc

( more registers )
23			:= _depth
24			:= _pin



byte warnings
pri WARN			warnings C++ ;



--- CZ CONDITIONALS ---

byte cc	--- condition code (normally %1111 = always)

pub ALWAYS		15
pri cc! 		cc C! ;

pub _RET_		0 cc! ;


pub IF_NZ_AND_NC
pub IF_A
pub IF_00
pub IF_NC_AND_NZ
pub {NC&NZ}		1 cc! ;


pub IF_Z_AND_NC
pub IF_01
pub IF_NC_AND_Z
pub {NC&Z}		2 cc! ;

pub IF_AE
pub IF_0X
pub IF_NC
pub {NC}		3 cc! ;

pub IF_NZ_AND_C
pub IF_10
pub IF_C_AND_NZ
pub {C&NZ}		4 cc! ;

pub IF_NE
pub IF_X0
pub IF_NZ
pub {NZ}		5 cc! ;

pub IF_Z_NE_C
pub IF_DIFF
pub IF_C_NE_Z
pub {C<>Z}		6 cc! ;

pub IF_NZ_OR_NC
pub IF_NOT_11
pub IF_NC_OR_NZ
pub {NC|NZ}		7 cc! ;

pub IF_11
pub IF_Z_AND_C
pub IF_C_AND_Z
pub {C&Z}		8 cc! ;

pub IF_SAME
pub IF_Z_EQ_C
pub IF_C_EQ_Z
pub {C=Z}		9 cc! ;

pub IF_E
pub IF_X1
pub IF_Z
pub {Z}			10 cc! ;

pub IF_Z_OR_NC
pub IF_NOT_10
pub IF_NC_OR_Z
pub {NC|Z}		11 cc! ;

pub IF_B
pub IF_1X
pub IF_C
pub {C}			12 cc! ;

pub IF_NOT_01
pub IF_NZ_OR_C
pub IF_C_OR_NZ
pub {C|NZ}		13 cc! ;

pub IF_NOT_00
pub IF_BE
pub IF_Z_OR_C
pub IF_C_OR_Z
pub {C|Z}		14 cc! ;



( CONDITION CODE EFFECTS  CZI )
byte eff
pri eff!		eff SET ;
pri eff@		eff C@ ;


pub WC			4 eff SET ;
pub WZ			2 eff SET ;
pub WCZ			6 eff SET ;
pub #s			1 eff SET ;
--- temporary def for #d to set L bit
pub #d			2 eff SET ;

pri ?EFF		eff@ AND IF PRINT"  !effects not allowed! " WARN THEN ;
pri -CZI		7 ?EFF ;
pri -CZ			6 ?EFF ;
pri -I			1 ?EFF ;


byte _abs
pub aa			_abs C~~ ;


word _defer
pub DEFER	R>  _defer W! ;


byte _cdepth
byte _adepth		--- depth of stack at start of line
pri ADEPTH ( -- depth )	DEPTH _adepth C@ - ;

long pc
pri PC@				pc @ ;
pri .ASM			CR PC@ DUP 16>> .H .WORD ." : " .LONG ;
pri ASM,	 		DUP .ASM PC@ ! 4 pc +! ALWAYS ;

pri +cc				cc C@ 10 << OR ;
pri +ops			+cc 18 << OR ;
pri +d				SWAP 9 << OR ;
pri DSOP			+ops +d ASM, ;

--- czi effects added into opcode (tos)
pri +E ( op -- op+eff )		eff@ AND OR ;

pri +C				4 +E ;
pri +Z				2 +E ;
pri +I				1 +E ;
pri +CZ				eff@ 6 = IF 6 +E THEN ;


--- dest source plus CZI routines
pri DSI ( d s op -- )		+I DSOP ;
pri DSZI			+Z DSI ;
pri DSCZI ( d s op -- )		+C DSZI ;
pri DSCZ ( d s op -- )		+C +Z DSOP ;
pri DSCI			+I
pri DSC				+C +ops +d ASM, ;

--- INSTRUCTIONS ---

--- LOGIC ---
--- ( d # s ) {WC/WZ/WCZ}
pub AND, 		%0101000_000 DSCZI ;
pub ANDN, 		%0101001_000 DSCZI ;
pub OR, 		%0101010_000 DSCZI ;
pub XOR, 		%0101011_000 DSCZI ;
pub MUXC, 		%0101100_000 DSCZI ;
pub MUXNC, 		%0101101_000 DSCZI ;
pub MUXZ, 		%0101110_000 DSCZI ;
pub MUXNZ, 		%0101111_000 DSCZI ;
pub MOV,  		%0110000_000 DSCZI ;
pub NOT,  		%0110001_000 DSCZI ;
pub ABS,  		%0110010_000 DSCZI ;
pub NEG,  		%0110011_000 DSCZI ;
pub NEGC,  		%0110100_000 DSCZI ;
pub NEGNC,  		%0110101_000 DSCZI ;
pub NEGZ,  		%0110110_000 DSCZI ;
pub NEGNZ,  		%0110111_000 DSCZI ;
pub TEST,  		%0111110_000 DSCZI ;
pub TESTN,  		%0111111_000 DSCZI ;
pub ZEROX,  		%0111010_000 DSCZI ;
pub SIGNX,  		%0111011_000 DSCZI ;
pub ENCOD,  		%0111100_000 DSCZI ;
pub ONES,  		%0111101_000 DSCZI ;

--- SHIFT ---
pub ROR, 		%0000000_000 DSCZI ;
pub ROL, 		%0000000_001 DSCZI ;
pub SHR, 		%0000010_000 DSCZI ;
pub SHL, 		%0000011_000 DSCZI ;
pub RCR, 		%0000100_000 DSCZI ;
pub RCL, 		%0000101_000 DSCZI ;
pub SAR, 		%0000110_000 DSCZI ;
pub SAL, 		%0000111_000 DSCZI ;
--- ARITHMETIC ---
pub ADD, 		%0001000_000 DSCZI ;
pub ADDX, 		%0001001_000 DSCZI ;
pub ADDS, 		%0001010_000 DSCZI ;
pub ADDX, 		%0001011_000 DSCZI ;
pub SUB, 		%0001100_000 DSCZI ;
pub SUBX, 		%0001101_000 DSCZI ;
pub SUBS, 		%0001110_000 DSCZI ;
pub SUBSX, 		%0001111_000 DSCZI ;
pub SUBR, 		%0010110_000 DSCZI ;
pub CMPSUB, 		%0010111_000 DSCZI ;

pub SUMC, 		%0011100_000 DSCZI ;
pub SUMNC, 		%0011101_000 DSCZI ;
pub SUMZ, 		%0011110_000 DSCZI ;
pub SUMNZ, 		%0011111_000 DSCZI ;
pub INCMOD, 		%0111000_000 DSCZI ;
pub DECMOD, 		%0111001_000 DSCZI ;

pub MUL, 		%1010000_000 DSZI ;
pub MULS, 		%1010000_100 DSZI ;
pub SCA, 		%1010001_000 DSZI ;
pub SCAS, 		%1010001_100 DSZI ;

--- COMPARE ---
pub CMP,  		%0010000_000 DSCZI ;
pub CMPX,  		%0010001_000 DSCZI ;
pub CMPS,  		%0010010_000 DSCZI ;
pub CMPSX,  		%0010011_000 DSCZI ;
pub CMPR,  		%0010100_000 DSCZI ;
pub CMPM,  		%0010101_000 DSCZI ;

--- MINMAX ---
pub FGE,  		%0011000_000 DSCZI ;
pub FLE,  		%0011001_000 DSCZI ;
pub FGES,  		%0011010_000 DSCZI ;
pub FLES,  		%0011011_000 DSCZI ;

--- BIT ---
--- these instructions write to C or Z - WC/WZ - ANDC/ANDZ - ORC/ORZ - XORC/XORZ
pub TESTB, ( d s -- ) 		%0100000_000 DSCZI ;
pub TESTBN, ( d s -- ) 		%0100001_000 DSCZI ;

--- modify TESTBx instruction
pub ANDC			%010_100 eff! ;
pub ANDZ			%010_010 eff! ;
pub ORC				%100_100 eff! ;
pub ORZ				%100_010 eff! ;
pub XORC			%110_100 eff! ;
pub XORZ			%110_010 eff! ;


--- specify no effects or WCZ only
pub BITL, ( d s -- ) 		%0100000_000 DSCZI ;
pub BITH, ( d s -- ) 		%0100001_000 DSCZI ;
pub BITC, ( d s -- ) 		%0100010_000 DSCZI ;
pub BITNC, ( d s -- ) 		%0100011_000 DSCZI ;
pub BITZ, ( d s -- ) 		%0100100_000 DSCZI ;
pub BITNZ, ( d s -- ) 		%0100101_000 DSCZI ;
pub BITRND, ( d s -- ) 		%0100110_000 DSCZI ;
pub BITNOT, ( d s -- ) 		%0100111_000 DSCZI ;

pri DSNIB ( d s #n op max -- )
	3RD < IF ."  range exceeded " THEN
	SWAP 2* OR +I DSOP
	;

--- NOTE - ALTSN version can override d and #n
pub SETNIB, ( d s #n --) 	%100000_000_0 7 DSNIB ;
pub GETNIB, ( d s #n --) 	%100001_000_0 7 DSNIB ;
pub ROLNIB, ( d s #n --) 	%100010_000_0 7 DSNIB ;
pub SETBYTE, ( d s #n --) 	%100011_000_0 3 DSNIB ;
pub GETBYTE, ( d s #n --) 	%100011_100_0 3 DSNIB ;
pub ROLBYTE, ( d s #n --) 	%100100_000_0 3 DSNIB ;
pub SETWORD, ( d s #n --) 	%100100_100_0 1 DSNIB ;
pub GETWORD, ( d s #n --) 	%100100_110_0 1 DSNIB ;
pub ROLWORD, ( d s #n --) 	%100101_000_0 1 DSNIB ;



pub SETR, ( d s -- )		%100110101_0 DSI ;
pub SETD, ( d s -- )		%100110110_0 DSI ;
pub SETS, ( d s -- )		%100110111_0 DSI ;
pub DECOD, ( d s -- )		%100111000_0 DSI ;
pub BMASK, ( d s -- )		%100111001_0 DSI ;
pub CRCBIT, ( d s -- )		%100111010_0 DSI ;
pub CRCNIB, ( d s -- )		%100111011_0 DSI ;
pub MUXNITS, ( d s -- )		%100111100_0 DSI ;
pub MUXNIBS, ( d s -- )		%100111101_0 DSI ;
pub MUXQ, ( d s -- )		%100111110_0 DSI ;
pub MOVBYTS, ( d s -- )		%100111111_0 DSI ;

pri DOP ( d -- )		%1101011_000 SWAP DSOP ;
pub SPLITB, ( d -- )		%001100000 DOP ;
pub MERGEB, ( d -- )		%001100001 DOP ;
pub SPLITW, ( d -- )		%001100010 DOP ;
pub MERGEW, ( d -- )		%001100011 DOP ;
pub SEUSSF, ( d -- )		%001100100 DOP ;
pub SEUSSR, ( d -- )		%001100101 DOP ;
pub XORO32, ( d -- )		%001101000 DOP ;
pub REV, ( d -- )		%001101001 DOP ;

pub WRC, ( d -- )		%001101100 DOP ;
pub WRNC, ( d -- )		%001101101 DOP ;
pub WRZ, ( d -- )		%001101110 DOP ;
pub WRNZ, ( d -- )		%001101111 DOP ;




--- {WC WZ WCZ}
pub RCZR, ( d -- )		%001101010 %1101011_000 DSCZ ;
pub RCZL, ( d -- )		%001101011 %1101011_000 DSCZ ;

{
pub MODCZ ( d -- )	%001101011 DCZ ;
pub MOVC
pub MODZ

}

	--- ALTER ---

pri DSI1                                ADEPTH 1 = 0 +I 0= AND IF 0 # THEN DSI ;
pub ALTSN, ( D # S )			%1001010100	DSI1 ;
pub ALTGN, ( D # S )			%1001010110	DSI1 ;
pub ALTSB, ( D # S )			%1001011000	DSI1 ;
pub ALTGB, ( D # S )			%1001011010	DSI1 ;
pub ALTSW, ( D # S )			%1001011100	DSI1 ;
pub ALTGW, ( D # S )			%1001011110	DSI1 ;
pub ALTR, ( D # S )			%1001100000	DSI1 ;
pub ALTD,  ( D # S )			%1001100010	DSI1 ;
pub ALTS,  ( D # S )			%1001100100	DSI1 ;
pub ALTB,  ( D # S )			%1001100110	DSI1 ;
pub ALTI,  ( D # S )			%1001101000	DSI1 ;

pub AUGS, ( N )	        		23 BITS %11110_00000 +ops ASM, ;
pub AUGD, ( N )	        		23 BITS %11111_00000 +ops ASM, ;

--- NOTE - needs to distinguish between D and S - also literal must precede ##
pub ##
	cc C@ >L
	DUP 9 BITS
	SWAP 9 >> AUGS,
	CRLF L> cc! #
	;

	--- HUB RAM ---
{
0c67af1f 	_ret_	wrlong	z,ptra[-1]
fb07ab5f 		rdlong	x,--ptra
fc679f61 		wrlong	v,ptra++
}

pub WMLONG, ( d s/p -- )				%101001111_0 DSI ;
pub RDBYTE, ( d s/p -- )				%1010010_000 DSCZI ;
pub RDWORD, ( d s/p -- )				%1010011_000 DSCZI ;
pub RDLONG, ( d s/p -- )				%1011000_000 DSCZI ;
pub POPA, ( d -- )					%101011111 # RDLONG, ;
pub POPB, ( d -- )					%111011111 # RDLONG, ;

--- allow #d as well as #s   ( d # s # WRBYTE )
pub DSLI						+Z +I DSOP ;

pub WRBYTE, ( d s/p -- )				%11000100_00 DSLI ;
pub WRWORD, ( d s/p -- )				%11000101_00 DSLI ;
pub WRLONG, ( d s/p -- )				%11000110_00 DSLI ;

	--- FAST HUB ---

pub RDFAST, ( # D # S )					%1100011_100 DSLI ;
pub WRFAST, ( # D # S )					%1100100_000 DSLI ;
pub FBLOCK, ( # D # S )					%1100100_100 DSLI ;
pub RFBYTE, ( D ) { WC/WZ/WCZ }		%000010000 	%1101011_000 DSCZ ;
pub RFWORD, ( D ) { WC/WZ/WCZ }		%000010001 	%1101011_000 DSCZ ;
pub RFLONG, ( D ) { WC/WZ/WCZ }		%000010010 	%1101011_000 DSCZ ;
pub RFVAR, ( D ) { WC/WZ/WCZ }		%000010011 	%1101011_000 DSCZ ;
pub RFVARS, ( D ) { WC/WZ/WCZ }		%000010100 	%1101011_000 DSCZ ;
pub WFBYTE, ( # D )  			%000010101 	%1101011_000 DSI ;
pub WFWORD, ( # D )  			%000010110 	%1101011_000 DSI ;
pub WFLONG, ( # D )  			%000010111 	%1101011_000 DSI ;
pub GETPTR, ( D )			%000110100 	%1101011_000 DSOP ;


	--- BRANCH ---

pub REP, ( ins times -- )	%11000111_00 DSLI ;
pri REL9 ( to -- rel )		0 +I IF PC@ 4+ - 4/ THEN 9 BITS ;
 --- If #S and cogex, PC += signed(S). If #S and hubex, PC += signed(S*4). If S, PC = register S.

pub DJZ, ( d # s )		REL9 %101101100_0 DSI ;
pub DJNZ, ( d # s )		REL9 %101101101_0 DSI ;
pub DJF, ( d # s )		REL9 %101101110_0 DSI ;
pub DJNF, ( d # s )		REL9 %101101111_0 DSI ;
pub IJZ, ( d # s )		REL9 %101110000_0 DSI ;
pub IJNZ, ( d # s )		REL9 %101110001_0 DSI ;
pub TJZ, ( d # s )		REL9 %101110010_0 DSI ;
pub TJNZ, ( d # s )		REL9 %101110011_0 DSI ;
pub TJF, ( d # s )		REL9 %101110100_0 DSI ;
pub TJNF, ( d # s )		REL9 %101110101_0 DSI ;
pub TJS, ( d # s )		REL9 %101110110_0 DSI ;
pub TJNS, ( d # s )		REL9 %101110111_0 DSI ;
pub TJV, ( d # s )		REL9 %101111000_0 DSI ;

pub CALLPA, ( #d s -- )		%10110100_00 DSLI ;
pub CALLPB, ( #d s -- )		%10110101_00 DSLI ;

pri REL20			PC@ 4+ - 20 BITS ;



( op\ is temporary method for selecting abs vs rel 20-bit addr )
pub JMPR, ( addr -- )		REL20 %1101100_1_00 +ops ASM, ;
pub JMP\, ( addr -- )		%1101100_0_00 +ops ASM, ;
pub CALLR, ( addr -- )		REL20 %1101101_1_00 +ops ASM, ;
pub CALL\, ( addr -- )		%1101101_0_00 +ops ASM, ;

pub CALLAR, ( addr -- )		REL20 %1101110_1_00 +ops ASM, ;
pub CALLA\, ( addr -- )		%1101110_0_00 +ops ASM, ;
pub CALLBR, ( addr -- )		REL20 %1101111_1_00 +ops ASM, ;
pub CALLB\, ( addr -- )		%1101111_0_00 +ops ASM, ;
--- calld	lr, #_PUTCW
pub CALLDS, ( d s )		%1011001_000 DSCZI ;

pri PR20			+ops ASM, ;
pub CALLDR, ( p addr )		SWAP PA - SWAP REL20 	%11100_00_1_00 PR20 ;
pub CALLD\, ( p addr )		SWAP PA - SWAP 		%11100_00_0_00 PR20 ;

pub LOCR, ( p addr )		SWAP PA - SWAP 		REL20 %11100_00_1_00 PR20 ;
pub LOC\, ( p addr )		SWAP PA - SWAP 		%11101_00_0_00 PR20 ;


\ pub RET,			0 %000101101 %1101011_001 +C +Z DSOP ;
pri DSI0			%110101100_0 DSI ;


pub JMP-D,     ( D )	{ WC/WZ/WCZ }		%000101100 %1101011_000	DSCZ ;
pub CALL-D,    ( D )	{ WC/WZ/WCZ }		%000101101 %1101011_000	DSCZ ;
pub RET,                { WC/WZ/WCZ }	0	%000101101 %1101011_001	DSCZ ;
pub CALLAD,   ( D )	{ WC/WZ/WCZ }		%000101110 %1101011_000	DSCZ ;
pub RETA,		{ WC/WZ/WCZ }	0	%000101110 %1101011_001	DSCZ ;
pub CALLBD,   ( D )	{ WC/WZ/WCZ }		%000101111 %1101011_000	DSCZ ;
pub RETB,		{ WC/WZ/WCZ }	0	%000101111 %1101011_001	DSCZ ;

pub JMPREL,	( # D )				%000110000 DSI0 ;
pub SKIP,	( # D )				%000110001 DSI0 ;
pub SKIPF,	( # D )				%000110010 DSI0 ;
pub EXECF,	( # D )				%000110011 DSI0 ;

--- INSTRUCTION MODE SELECTORS ---

pub JMP,	eff@ IF JMP-D, ELSE _abs C@ IF JMP\, ELSE JMPR, THEN THEN ;
pub CALL,	eff@ IF CALL-D, ELSE _abs C@ IF CALL\, ELSE CALLR, THEN THEN ;
pub CALLA,	eff@ IF CALLAD, ELSE _abs C@ IF CALLA\, ELSE CALLAR, THEN THEN ;
pub CALLB,	eff@ IF CALLBD, ELSE _abs C@ IF CALLB\, ELSE CALLBR, THEN THEN ;
pub CALLD,	_abs C@ IF CALLD\, ELSE CALLDR, THEN ;
pub LOC,	_abs C@ IF LOC\, ELSE LOCR, THEN ;
	--- EVENTS ---

pri ROP         			%1011001110 DSOP ;
pub RESI3,				%111110000	%111110001 ROP ;
pub RESI2,				%111110010	%111110011 ROP ;
pub RESI1,				%111110100	%111110101 ROP ;
pub RESI0,				%111111110	%111111111 ROP ;
pub RETI3,				%111111111	%111110001 ROP ;
pub RETI2,				%111111111	%111110011 ROP ;
pub RETI1,				%111111111	%111110101 ROP ;
pub RETI0,				%111111111	%111111111 ROP ;

pri JOP     				SWAP %101111001_0 DSI ;
pub JINT,  ( # S )			%000000000 JOP ;
pub JCT1,  ( # S )			%000000001 JOP ;
pub JCT2,  ( # S )			%000000010 JOP ;
pub JCT3,  ( # S )			%000000011 JOP ;
pub JSE1,  ( # S )			%000000100 JOP ;
pub JSE2,  ( # S )			%000000101 JOP ;
pub JSE3,  ( # S )			%000000110 JOP ;
pub JSE4,  ( # S )			%000000111 JOP ;
pub JPAT,  ( # S )			%000001000 JOP ;
pub JFBW,  ( # S )			%000001001 JOP ;
pub JXMT,  ( # S )			%000001010 JOP ;
pub JXFI,  ( # S )			%000001011 JOP ;
pub JXRO,  ( # S )			%000001100 JOP ;
pub JXRL,  ( # S )			%000001101 JOP ;
pub JATN,  ( # S )			%000001110 JOP ;
pub JQMT,  ( # S )			%000001111 JOP ;
pub JNINT, ( # S )			%000010000 JOP ;
pub JNCT1, ( # S )			%000010001 JOP ;
pub JNCT2, ( # S )			%000010010 JOP ;
pub JNCT3, ( # S )			%000010011 JOP ;
pub JNSE1, ( # S )			%000010100 JOP ;
pub JNSE2, ( # S )			%000010101 JOP ;
pub JNSE3, ( # S )			%000010110 JOP ;
pub JNSE4, ( # S )			%000010111 JOP ;
pub JNPAT, ( # S )			%000011000 JOP ;
pub JNFBW, ( # S )			%000011001 JOP ;
pub JNXMT, ( # S )			%000011010 JOP ;
pub JNXFI, ( # S )			%000011011 JOP ;
pub JNXRO, ( # S )			%000011100 JOP ;
pub JNXRL, ( # S )			%000011101 JOP ;
pub JNATN, ( # S )			%000011110 JOP ;
pub JNQMT, ( # S )			%000011111 JOP ;

pub SETPAT, ( # D # S )			%1011111100 DSLI ;
pub ADDCT1, ( D # S )			%1010011000 DSI ;
pub ADDCT2, ( D # S )			%1010011010 DSI ;
pub ADDCT3, ( D # S )			%1010011100 DSI ;
pub SETSE1, ( # D )			%000100000 %1101011000 DSI ;
pub SETSE2, ( # D )			%000100001 %1101011000 DSI ;
pub SETSE3, ( # D )			%000100010 %1101011000 DSI ;
pub SETSE4, ( # D )			%000100011 %1101011000 DSI ;

pri CZOP        %1101011_00_0 +C +Z DSOP ;

pub POLLINT,	{ WC/WZ/WCZ }		%000000000	%000100100 CZOP ;
pub POLLCT1,	{ WC/WZ/WCZ }		%000000001	%000100100 CZOP ;
pub POLLCT2,	{ WC/WZ/WCZ }		%000000010	%000100100 CZOP ;
pub POLLCT3,	{ WC/WZ/WCZ }		%000000011	%000100100 CZOP ;
pub POLLSE1,	{ WC/WZ/WCZ }		%000000100	%000100100 CZOP ;
pub POLLSE2,	{ WC/WZ/WCZ }		%000000101	%000100100 CZOP ;
pub POLLSE3,	{ WC/WZ/WCZ }		%000000110	%000100100 CZOP ;
pub POLLSE4,	{ WC/WZ/WCZ }		%000000111	%000100100 CZOP ;
pub POLLPAT,	{ WC/WZ/WCZ }		%000001000	%000100100 CZOP ;
pub POLLFBW,	{ WC/WZ/WCZ }		%000001001	%000100100 CZOP ;
pub POLLXMT,	{ WC/WZ/WCZ }		%000001010	%000100100 CZOP ;
pub POLLXFI,	{ WC/WZ/WCZ }		%000001011	%000100100 CZOP ;
pub POLLXRO,	{ WC/WZ/WCZ }		%000001100	%000100100 CZOP ;
pub POLLXRL,	{ WC/WZ/WCZ }		%000001101	%000100100 CZOP ;
pub POLLATN,	{ WC/WZ/WCZ }		%000001110	%000100100 CZOP ;
pub POLLQMT,	{ WC/WZ/WCZ }		%000001111	%000100100 CZOP ;
pub WAITINT,	{ WC/WZ/WCZ }		%000010000	%000100100 CZOP ;
pub WAITCT1,	{ WC/WZ/WCZ }		%000010001	%000100100 CZOP ;
pub WAITCT2,	{ WC/WZ/WCZ }		%000010010	%000100100 CZOP ;
pub WAITCT3,	{ WC/WZ/WCZ }		%000010011	%000100100 CZOP ;
pub WAITSE1,	{ WC/WZ/WCZ }		%000010100	%000100100 CZOP ;
pub WAITSE2,	{ WC/WZ/WCZ }		%000010101	%000100100 CZOP ;
pub WAITSE3,	{ WC/WZ/WCZ }		%000010110	%000100100 CZOP ;
pub WAITSE4,	{ WC/WZ/WCZ }		%000010111	%000100100 CZOP ;
pub WAITPAT,	{ WC/WZ/WCZ }		%000011000	%000100100 CZOP ;
pub WAITFBW,	{ WC/WZ/WCZ }		%000011001	%000100100 CZOP ;
pub WAITXMT,	{ WC/WZ/WCZ }		%000011010	%000100100 CZOP ;
pub WAITXFI,	{ WC/WZ/WCZ }		%000011011	%000100100 CZOP ;
pub WAITXRO,	{ WC/WZ/WCZ }		%000011100	%000100100 CZOP ;
pub WAITXRL,	{ WC/WZ/WCZ }		%000011101	%000100100 CZOP ;
pub WAITATN,	{ WC/WZ/WCZ }		%000011110	%000100100 CZOP ;

pub COGATN, ( # D )			%000111111 	DSI0 ;
pub HUBSET, ( # D )			%000000000 	DSI0 ;


	--- COG ---

pub COGINIT,	( # D # S ) { WC }	%1100111_000 +C DSLI ;
pub COGID,	( # D ) { WC }		%000000001 %1101011_000 DSCI ;
pub COGSTOP,	( # D )			%000000011 DSI0 ;
pub LOCKNEW,	( D ) { WC }		%000000100 %1101011_000 DSC ;
pub LOCKRET,	( # D )			%000000101 DSI0 ;
pub LOCKTRY,	( # D ) { WC }		%000000110 %1101011_000 DSCI ;
pub LOCKREL,	( # D ) { WC }		%000000111 %1101011_000 DSCI ;

	--- STREAMER ---

pub XINIT,	( # D # S )		%11001010_00 DSLI ;
pub XSTOP,	(  )			0 0 %1100101011 DSOP ;
pub XZERO,	( # D #	S )		%11001011_00 DSLI ;
pub XCONT,	( # D #	S )		%11001100_00 DSLI ;
pub SETXFRQ,	( # D )			%000011101 DSI0 ;
pub GETXACC,	( D )			%000011110 %1101011000 DSOP ;

	--- CORDIC ---

pub QMUL,	( # D #	S )		%11010000_00	DSLI ;
pub QDIV,	( # D # S )		%11010001_00	DSLI ;
pub QFRAC,	( # D #	S )		%11010010_00	DSLI ;
pub QSQRT,	( # D #	S )		%11010011_00	DSLI ;
pub QROTATE,	( # D #	S )		%11010100_00	DSLI ;
pub QVECTOR,	( # D #	S )		%11010101_00	DSLI ;
pub QLOG,	( # D )			%000001110 DSI0 ;
pub QEXP,	( # D )			%000001111 DSI0 ;
pub GETQX,	( D ) { WC/WZ/WCZ }	%000011000 %1101011_000 DSCZ ;
pub GETQY,	( D ) { WC/WZ/WCZ }	%000011001 %1101011_000 DSCZ ;


	--- INTERRUPTS ---

pub INTX				-CZI
pub INT,                                %1101011_000 DSCZI ;

pub ALLOWI,	 			%000100000	%000100100 INTX ;
pub STALLI,	 			%000100001	%000100100 INTX ;
pub TRGINT1,	 			%000100010	%000100100 INTX ;
pub TRGINT2,	 			%000100011	%000100100 INTX ;
pub TRGINT3,	 			%000100100	%000100100 INTX ;
pub NIXINT1,	 			%000100101	%000100100 INTX ;
pub NIXINT2,	 			%000100110	%000100100 INTX ;
pub NIXINT3,	 			%000100111	%000100100 INTX ;

pub SETINT1,	( # D )			%000100101 -CZ INT, ;
pub SETINT2,	( # D )			%000100110 -CZ INT, ;
pub SETINT3,	( # D )			%000100111 -CZ INT, ;
pub GETBRK,	( D )	( WC/WZ/WCZ )	%000110101 -I INT, ;
pub COGBRK,	( # D )			%000110101 -CZ INT, ;
pub BRK,	( # D )			%000110110 -CZ INT, ;


	--- INPUTS ---
--- TESTPx			blend in logicAL effects, clear,   opcode
pri TESTPx         		eff@ 3 >> OR $F8 eff CLR %1101011_000 DSCZI ;

--- WC/WZ ANDC/ANZ ORC/ORZ XORC/XORZ
pub TESTP,	( # D ) 	%001000000 TESTPx ;
pub TESTPN,	( # D ) 	%001000001 TESTPx ;

	--- OUTPUTS ---
--- NNNNDDDDD
pri DCZ				%1101011_000 +I +CZ DSOP ;

pub DIRL,	( # D ) { WCZ } %001000000 DCZ ;
pub DIRH,	( # D ) { WCZ } %001000001 DCZ ;
pub DIRC,	( # D ) { WCZ } %001000010 DCZ ;
pub DIRNC,	( # D ) { WCZ } %001000011 DCZ ;
pub DIRZ,	( # D ) { WCZ } %001000100 DCZ ;
pub DIRNZ,	( # D ) { WCZ } %001000101 DCZ ;
pub DIRRND,	( # D ) { WCZ } %001000110 DCZ ;
pub DIRNOT,	( # D ) { WCZ } %001000111 DCZ ;
pub OUTL,	( # D ) { WCZ } %001001000 DCZ ;
pub OUTH,	( # D ) { WCZ } %001001001 DCZ ;
pub OUTC,	( # D ) { WCZ } %001001010 DCZ ;
pub OUTNC,	( # D ) { WCZ } %001001011 DCZ ;
pub OUTZ,	( # D ) { WCZ } %001001100 DCZ ;
pub OUTNZ,	( # D ) { WCZ } %001001101 DCZ ;
pub OUTRND,	( # D ) { WCZ } %001001110 DCZ ;
pub OUTNOT,	( # D ) { WCZ } %001001111 DCZ ;
pub FLTL,	( # D ) { WCZ } %001010000 DCZ ;
pub FLTH,	( # D ) { WCZ } %001010001 DCZ ;
pub FLTC,	( # D ) { WCZ } %001010010 DCZ ;
pub FLTNC,	( # D ) { WCZ } %001010011 DCZ ;
pub FLTZ,	( # D ) { WCZ } %001010100 DCZ ;
pub FLTNZ,	( # D ) { WCZ } %001010101 DCZ ;
pub FLTRND,	( # D ) { WCZ } %001010110 DCZ ;
pub FLTNOT,	( # D ) { WCZ } %001010111 DCZ ;
pub DRVL,	( # D ) { WCZ } %001011000 DCZ ;
pub DRVH,	( # D ) { WCZ } %001011001 DCZ ;
pub DRVC,	( # D ) { WCZ } %001011010 DCZ ;
pub DRVNC,	( # D ) { WCZ } %001011011 DCZ ;
pub DRVZ,	( # D ) { WCZ } %001011100 DCZ ;
pub DRVNZ,	( # D ) { WCZ } %001011101 DCZ ;
pub DRVRND,	( # D ) { WCZ } %001011110 DCZ ;
pub DRVNOT,	( # D ) { WCZ } %001011111 DCZ ;

	--- SMARTPINS ---
pub RQPIN, ( d # s ) { WC }	%1010100_000 +C +I DSOP ;
pub RDPIN, ( d # s ) { WC }	%1010100_010 +C +I DSOP ;
pub AKPIN, ( # s )		%000000001 %110000001_0 DSI ;
pub WRPIN, ( # d # s )		%11000000_00 DSLI ;
pub WXPIN, ( # d # s )		%11000001_00 DSLI ;
pub WYPIN, ( # d # s )		%11000010_00 DSLI ;
pub SETDACS, ( # d )		%000011100 DSI0 ;
pub SETSCP, ( # d )		%001110000 DSI0 ;
pub GETSCP, ( d )		%001110001 %1101011000 DSOP ;

	--- LUT ---
pub WRLUT, ( # d # s/p )	%11000011_0_0 DSLI ;
pub RDLUT, ( d # s/p ) 		%1010101_000 DSCZI ;
pub SETLUTS, ( # d -- )		%000110111 DSI0 ;
	--- COLORSPACE ---
pub SETCY, ( # d -- )		%000111000 DSI0 ;
pub SETCI, ( # d -- )		%000111001 DSI0 ;
pub SETCQ, ( # d -- )		%000111010 DSI0 ;
pub SETCFRQ, ( # d -- )		%000111011 DSI0 ;
pub SETCMOD, ( # d -- )		%000111100 DSI0 ;
	--- PIXEL ---
pub SETPIV, ( # d -- )		%000111101 DSI0 ;
pub SETPIX, ( # d -- )		%000111110 DSI0 ;
pub ADDPIX, ( d s -- )		%101001000_0 DSI ;
pub MULPIX, ( d s -- )		%101001001_0 DSI ;
pub BLNPIX, ( d s -- )		%101001010_0 DSI ;
pub MIXPIX, ( d s -- )		%101001011_0 DSI ;
pub RGBSQZ, ( d -- )		%001100110 %1101011000 -CZI DSOP ;
pub RGBEXP, ( d -- )		%001100111 %1101011000 -CZI DSOP ;


	--- MISC ---
pub SETQ, ( #d -- )		%000101000 DSI0 ;
pub SETQ2, ( #d -- )		%000101001 DSI0 ;
pub PUSH,  ( #d -- )		%000101010 DSI0 ;
pub POP,  ( #d -- )		%000101011 %110101100_0	DSCZ ;
pub GETCT, ( d -- )		%000011010 %110101100_0 DSC ;
--- 2 forms, one with d and one with no dest but must use wc/wz/wcz
pub GETRND, ( d -- )		ADEPTH 0= IF 0 # THEN  %000011011 %1101011_00_0 DSCZI ;
pub WAITX, ( # d -- )		%000011111 %1101011_00_0 DSCZI ;
pub NOP,			0 0 +ops ASM, ;



--- Pseudo instructions
pub DEC,			# 1 SUB, ;
pub INC,			# 1 ADD, ;

--- Branch and loop structures and simple back labels

pub FOR, ( n reg -- addr )	2DUP <> IF SWAP mov, ELSE 2DROP THEN PC@ ;
pub NEXT, ( addr reg -- )	SWAP # DJNZ, ;
pub BEGIN, ( -- pc )		PC@ ;

8 longs labels
pub .l ( n -- )			4* labels + PC@ SWAP ! ;
pub #l	( -- addr )		4* labels + @ # ;
pub AGAIN, ( pc -- )		JMP\, ;
pub UNTIL, ( pc <cond> -- )	JMP\, ;	( {NZ} UNTIL, )




	--- TAQOZ KERNEL ---
pre DROP;		' WAIT 4+ @ [C] , ;
pub DROP,		' DROP CALL, ;
pub PUSHX,		' DUP 1+ CALL, ;
pub ROT,		' ROT CALL, ;
pub SWAP,		' SWAP CALL, ;
pub I,			' I CALL, ;
pub SPIRD,		' SPIRD CALL, ;
pub SPIWB,		' SPIWRB CALL ;
pub SPICE,		' SPICE CALL ;



--- testing line parser ---


80 bytes linebuf
byte keywr
pri PUTCH	linebuf keywr C@ + W! keywr C++ ;
pri PUT$	BEGIN DUP C@ WHILE DUP C@ PUTCH 1+ REPEAT DROP ;
pri BSCH	keywr C-- ;
pri DOKEY
	SWITCH
	^X CASE linebuf PRINT$ $0D SWITCH BREAK
	$0A CASE BREAK
	$0D CASE BREAK
	$08 CASE 8 EMIT SPACE 8 EMIT BSCH 0 PUTCH BSCH BREAK
	'#' CASE " #s " PUT$ '#' EMIT BREAK
	',' CASE $20 PUTCH ',' EMIT BREAK
	'\' CASE " aa " PUT$ '\' EMIT BREAK
	CASE@ DUP EMIT PUTCH
	;

pri GETLINE	keywr C~ BEGIN WKEY DOKEY CASE@ $0D = UNTIL linebuf ;



--- setup new code line
pri CODE:		CRLF 20 SPACES ALWAYS eff C~ DEPTH _adepth C! _abs C~ _defer W~ ;
pri ACP 		NOP  ;


pri ASSEMBLER
	BEGIN CODE: GETLINE EVALUATE _defer W@ ?DUP IF CALL THEN
	uprompt W@ 0=
	UNTIL
	;

--- create a CODE defining word that automatically compiles the ASM word to execute in-line code
pre CODE
	[C] CREATE$
pre ASM:
	warnings C~ DEPTH _cdepth C!
	PRINT" ( <condition> <dest> <#> <src> <effects>  instr, ) "
	' ASM [C] [W] [C] [
	' CODE: uprompt W! ' ACP uaccept W!
	6 flags SET
	ALWAYS
	HERE pc ! 256 ALLOT
	28 SPACES
	;

pub end,
pub ASM;
pub END-CODE
	$4D pc @ DUP @HERE ! DUP @CODES ! W!
	uprompt W~ uaccept W~ 6 flags CLR
	DEPTH _cdepth C@ <> IF PRINT"   Stack mismatch! " WARN THEN
	warnings C@ ?DUP IF . PRINT"  warnings " THEN
	;


pub add		DEFER ADD, ;
pub ret		RET, ;
pub end		END-CODE ;

END
