


	*** P2D2 EFM8UB3 SERIAL BACK CHANNEL COMMANDS ***
	--- ascii sequences for diagnostics ---
{
#$F5#$E5#$FA#$B4  echos i on serial
#$F5#$E5#$FA#$E1 Generates 10.23ms pulse on P1.0  = OK
#$F5#$E5#$FA#$D2 Generates Si5351 i2c preamble = OK


}
pub !!UB ( cmd -- )		20 ms $F5 EMIT $E5 EMIT $FA EMIT EMIT 20 ms ;
pub !!CG			$D2 !!UB ; 	--- trigger UB3 resend of CG table
pub !!PING			$B4 !!UB ; 	--- pings "i" on serial
pub !!ADC			$C3 !!UB ;	--- Reset UB3 ADC
pub !!SD			$E1 !!UB ;



	*** P2D2 EFM8UB3 I2C FUNCTIONS ***


{
CMD $30 ch           Read ADC ch - reads 13-bits
CMD $31 ADRL     Set address low for read, sets Addr Hi to 0xff unless $32 used first
CMD $32 ADRH     Set address Hi for read, send before $31 to read any page other than UUID
CMD $33 xx           Pulse SD reset - dummy byte required
CMD $34 xx            Emulate RTS toggle, triggers Si5351 reload
CMD $35 xx           Ping - echo inverted bytes and clear command vars to defaults  triggers Si5351 reload
}

pub !UB							400 I2C.KHZ ;

pub UB? ( -- flg ) 				!UB <I2C> $37 I2C.WR I2C.STOP 0= ;

--- Write cmd & data to ub3	start     write dev cmd  data stop
pub UBCMD ( data cmd -- )			!UB I2C.START $36 I2C!  I2C! I2C! I2C.STOP ;

--- Read res & data from ub3	start     read dev restart   ack cmd  nak data
pub UBDAT ( -- hhll )				!UB <I2C> $37 I2C! 0 I2C.RD >B 8 << 1 I2C.RD >B OR I2C.STOP ;

--- UB3 Reset SD power
pub UBSD					0 $C1 UBCMD ;
--- UB3 LOAD CLOCK GEN WITH TABLE n
pub UBCG ( n -- )			$C3 UBCMD ;
--- UB3 ECHO
pub UBEC ( ch -- )			$C5 UBCMD ;
--- WATCHDOG
pub WD ( time -- )			$C2 UBCMD ;
pub WD@ 					0 $C4 UBCMD UBDAT >B ;

	--- UB3 FLASH MEMORY FETCH OPERATORS ---

--- set address				split, init   select   dev      adrh adrl
pub UBADR ( addr -- ) 		W>B !UB I2C.START $36 I2C!   I2C! I2C! ;
pub UBW@ ( addr -- word )	UBADR I2C.START $37 I2C! I2C@ nakI2C@ 8<< OR I2C.STOP ;
pub UB@						DUP UBW@ SWAP 2+ UBW@ 16<< OR ;
pub UBC@ ( addr -- byte )	UBW@ >B ;
\ pub UBC@					UBADR I2C.START $37 I2C! I2C@ nakI2C@ DROP I2C.STOP ;

	--- DUMP UB3 DEVICE ---

pub UB						AT UBC@   AT UBW@   AT UB@ DUMP! ;

--- ROM COPY ROUTINES ---
pub UBREAD ( src dst cnt -- )	ROT UBADR I2C.START $37 I2C! ADO I2C@ I C! LOOP I2C.STOP ;
pub UBROM
	$40000 64 KB $FF FILL
	0 $40000 $9900 UBREAD
	$FA00 $4FA00 $1F0 UBREAD
	$FFC0 $4FFC0 $40 UBREAD
	;

{
028DC: 1A 03 53 00  69 00 6C 00  69 00 63 00  6F 00 6E 00     '..S.i.l.i.c.o.n.'
028EC: 20 00 4C 00  61 00 42 00  53 00 -- 4C 03  45 00 46 00     ' .L.a.B.S.L.E.F.'
028FC: 4D 00 38 00  55 00 42 00  33 00 20 00  50 00 32 00     'M.8.U.B.3. .P.2.'
0290C: 44 00 32 00  76 00 34 00  20 00 20 00  55 00 53 00     'D.2.v.4. . .U.S.'
0291C: 42 00 20 00  42 00 72 00  69 00 64 00  67 00 65 00     'B. .B.r.i.d.g.e.'
0292C: 20 00 55 00  42 00 33 00  5F 00 32 00  2E 00 35 00     ' .U.B.3._.2...5.'
0293C: 2E 00 36 00  20 00 -- 0A 03  30 00 30 00  30 00 35 00     '..6. ...0.0.0.5.'
}

( Silicon LaBS; EFM8UB3 P2D2v4  USB Bridge UB3_2.5.6 ;0005 )
pub .UB
	$2800 BEGIN
	    BEGIN DUP UB@ $690053 <> WHILE 1+ REPEAT
	  DUP 4+ UB@ $69006C =
	UNTIL
	2 - 
	BEGIN DUP 1+ UBC@ 3 = WHILE DUP 3 ms DUP 2+ SWAP UBC@ 2- ADO I UBC@ EMIT 2 +LOOP 
	  SPACE DUP UBC@ + 
	REPEAT DROP
	;


pub .UUID			$FFC0 16 ADO I UBC@ .BYTE LOOP ;

pub ADC@ ( ch -- result ) --- 100us at 1MHz
	$C0 UBCMD BEGIN UBDAT DUP $BFFF > WHILE DROP REPEAT 
	;
pub mv@ ( ch --- mV )	ADC@ 3300 * 13 >> ;

pub .AVOLTS ( adc -- )	3300 * 13 >> .AS" #.###V" ;

pub .ADC$ ( n -- )	4* " P0.0P0.1P0.2P0.3P0.4P0.5P0.6P0.7P1.0P1.1P1.2--------------------TEMPLDO VDD GND ----------------P2.1------------ D+  D- VIN4 NC " + 4 CTYPE ;

pub .ADCS
	!UB
	32 0 DO
	  CRLF I 2 U.R SPACE I .ADC$  TAB  I ADC@ DUP .W
	  SPACE .AVOLTS
	LOOP
	;

--- fetch the temperature 	read mV, and calculate  Tempc = ( Vtemp - offset ) / Slope
pub TEMP@ ( -- CC.cc )		16 mv@   757 - 10000 285 */ ;

pub .TEMP					TEMP@ .AS" *|.##'C" ;

