TAQOZ
{
'#######################################################################'
' 	vga-multi.p2a  for Rev B/C
'#######################################################################'

'******************************
'*  VGA 640 x 360 x 8bpp-lut  *
'
' PBJ: 181022 Adapted for TAQOZ
'
' 210125 - disable if vgacfg long is 0
' 190725 - 640x360 mode for 1080p
' 190726 - 640x360 mode for 720p'
' 190627 - MULTI MODE PROGRAMMBLE '
'
'******************************

' VGA HEADER
CON
}
\ intensity	= 80				'0..128

bmpint		= $0				' 256 byte header - mostly free but top half may have bmp header written'
hcnt		= $4				' hub variable word with current horz count (line)'
vcnt		= $6				' hub variable word with current vert count (frame)'


vlines		= 360

fclk		= float(CPUHZ)
fpixn		= 25_175_000
fpix		= float(fpixn)
fset		= (fpix / fclk * 2.0) * float($4000_0000)

DAT		org

vgainit		jmp		#vgainit2

' ----------------------------------VGA PARAMETER TABLE-------------------------------------------------
' NOTE: these locations are temporary and may be moved into a more logical sequence once completed'
' The hub locations may be updated and these locations become part of the cog registers when the cog is started '
' Reading the hub locations will not reveal the values that are updated by the vga cog itself.
'
'
' 01 '
_hpixels	long	640
_vlines		long 	480
' 03 			FP,SY,BP,DIV
v_bs		byte	16,96,48,1	'5,5,20,2
' 04 '
_fpix		long	fpixn			' pixel frequency'
_fset		long	round(fset)		' pixel nco value'
_palette	long 	bmporg+$100		' address of palette (normally $FC00)'
_screen		long	bmporg+$500		' address of screen (normally $10000)'
' 08  		 $7F01 = output X3, X2, X1, X0 on all four DAC channels'
m_bs		long	$7F010000+55		'before sync  <long> 32-bit immediate
m_sn		long	$7F010000+20		'sync
m_bv		long	$7F010000+110		'before visible
' 11 '
bpp		long	8						' bits/plane
'*1 note: The pixel parameter is calculated and added during init'
' 12			'%0111_0001_eppp_xxxx   <long>    32-bit immediate              $xxxxxxxx
m_vi		long	$7F01_0000		' *1
' 13 			%0111_1000_eppp_bbbb        -    8-bit RFLONG LUT              $xxxxxxxx
m_rf		long	$7F08_0000		' *1
' 14 '
_hbytes		long	640
dacmode_s	long    %0000_0000_000_1011000000000_01_00000_0+vgacog<<8         'hsync is 123-ohm, 3.3V
dacmode_c	long    %0000_0000_000_1011100000000_01_00000_0+vgacog<<8         'R/G/B are 75-ohm, 2.0V


'rdfast  ##w*h*bpp/32/16,##@video_buffer ' wraps ~253KB bitmap (longs/16)
' pub 1080p		1920 1080 1 VRES 148,500,000 VCLK 	88 44 148 HSYN 4 5 36 VSYN ;
'
' ------------------------------------------------------------------------------------------------------
{ P2B
0111 dddd eppp 001a   bbbb     RFLONG -> 32 x 1-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
0111 dddd eppp 010a   bbbb     RFLONG -> 16 x 2-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
0111 dddd eppp 011a   bbbb     RFLONG ->  8 x 4-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
0111 dddd eppp 1000   bbbb     RFLONG ->  4 x 8-bit LUT         32 out   %PONMLKJI_HGFEDCBA_ponmlkji_hgfedcba
}

vgainit2
		mov		vx,bpp				' encode bits per pixel as a shift value 0..3 '
		encod	vx
''		setbyte	m_rf,vx,#2		' set streamer mode based on bits per pixel (1,2,4,8)'
		xor		vx,#3				' flip shift value so that 8 bpp = 0  (3,2,1,0)
		mov		_hbytes,_hpixels	' and calculate bytes per horizontal line '
		shr		_hbytes,vx			' 1920 mono -> 240 etc '

		mov		_hblks,_hbytes		' setup rdfast blocks for default vertical scaling off'
		shr		_hblks,#6			' per line basis
		add		_hblks,#1
		getbyte	vx,v_bs,#3		' rdfast the whole frame if there is no vertical scaling involved'
		cmp		vx,#1 wz			' otherwise if scaling <> 1 '
 if_ne	jmp		#.l0
		mov		_hblks,_hpixels		' then setup rdfast blocks on a frame basis'
		mul		_hblks,_vlines
		shr		_hblks,vy
		shr		_hblks,#6

.l0		setword	m_vi,#0,#0		' setup visible pixels streamer word'
		add		m_vi,_hpixels

		setword	m_rf,#0,#0		' setup display pixels streamer word
		add		m_rf,_hpixels		' add in pixels'

		call	#loadpal
		'  cmod   65_4_321_0'		' VGA
		setcmod	#%01_0_000_0		'enable vga colorspace conversion
		rdbyte	vx,#@_VGACFG		' read hsync
		wrpin	dacmode_s,vx		'enable dac modes in selected pins
		dirh	vx
		rdbyte	vx,#@_VGACFG+1		' blue PIN
		wrpin	dacmode_c,vx
		dirh	vx
		rdbyte	vx,#@_VGACFG+2		' green PIN
		wrpin	dacmode_c,vx
		dirh	vx
		rdbyte	vx,#@_VGACFG+3		' red PIN
		wrpin	dacmode_c,vx
		dirh	vx
		rdbyte	vsync,#@_VGACFG+4	' vsynch PIN
		drvl	vsync
'
' XCONT D31..16 = INSTRUCTION, D15..0 = NCO ROLLERS, S=SUB-MODE
' Field loop
'
field
		rdfast	_hblks,_screen		' default rdfast for whole screen '
		getbyte	vx,v_bs,#2		'top blanks
		call	#blank
		mov     vx,_vlines		'set visible lines
		mov		scrptr,_screen
line	getbyte	vy,v_bs,#3		' vert scale (duplicate lines)'
		cmp		vy,#1 wz
linerep
 if_ne	rdfast	_hblks,scrptr		' only rdfast for a line if vertical scaling '
		call	#hsync			'do horizontal sync
		xcont	m_rf,#0			'visible line
		djnz	vy,#linerep

		add		_hcnt,#1		' increment horizontal line count '
		wrword	_hcnt,##bmporg+hcnt	' and update hub'
		add		scrptr,_hbytes		' advance scaling screen ptr to next line'
		djnz    vx,#line           	' another line?

		getbyte	vx,v_bs,#0		' bottom blanks
		call	#blank
		drvnot	vsync			' vertical sync on
		add		_vcnt,#1		' increment frame count'
		wrword	_vcnt,##bmporg+vcnt	' update hub'
		mov		_hcnt,#0		' reset horizontal line count every vsynch '
		getbyte	vx,v_bs,#1		' sync blanks
		call	#blank
		drvnot	vsync			' sync off
		call	#loadpal		' continually update palette in case it has changed'
    	jmp     #field			'loop
'
' Subroutines
'
blank	call	#hsync			'blank lines
		xcont	m_vi,#0
 _ret_	djnz	vx,#blank

hsync	xcont	m_bs,#0			'horizontal sync
		xcont	m_sn,#1
 _ret_	xcont	m_bv,#0


' Load palette from hub into lut '
loadpal
		mov		vx,_fset
		setxfrq vx			'set transfer frequency

		mov		vx,#0
		rdfast	#0,_palette 		'load .bmp palette into lut
		rep		@.end,#$100		' 256 colors
		rflong	vy
		shl		vy,#8
		wrlut	vy,vx
		add		vx,#1
.end
		rdbyte	vx,##bmporg+bmpint	' update intensity'
		shl		vx,#8
		setcq	vx
		shl		vx,#8
		setci	vx
		shl		vx,#8
		setcy	vx
		ret

{ iterative parameter update
		mov	vy,vcnt
		cmp	vy,#10 wcz
	if_lt	add	vy,#1
		alts	(d),vy
		rdlong	vx,at_hpixels


 mode dacs pins base   S/#       description                   dac output
 ---- ---- ---- ----   ------    ---------------------------   --------------------
%0000_dddd_xppp_pppx   config    DDS/Goertzel LUT              $xxxxxxxx

%0001_dddd_eppp_pppx   %00r00    1-bit RFBYTE, r=reorder       $000000xx, %aaaaaaaa
%0001_dddd_eppp_ppxx   %00r01    2-bit RFBYTE, r=reorder       $000000xx, %babababa
%0001_dddd_eppp_pxxx   %00r10    4-bit RFBYTE, r=reorder       $000000xx, %dcbadcba
%0001_dddd_eppp_xxxx   %00011    8-bit RFBYTE                  $000000xx
%0001_dddd_eppp_xxxx   %01rgb    8-bit RFBYTE LUMA8            $RRGGBB00
%0001_dddd_eppp_xxxx   %10xxx    8-bit RFBYTE RGBI8            $RRGGBB00
%0001_dddd_eppp_xxxx   %11xxx    8-bit RFBYTE RGB8 (3:3:2)     $RRGGBB00

%0010_dddd_eppp_xxxx       %0    16-bit RFWORD                 $0000xxxx
%0010_dddd_eppp_xxxx       %1    16-bit RFWORD RGB16 (5:6:5)   $RRGGBB00

%0011_dddd_eppp_xxxx       %0    32-bit RFLONG                 $xxxxxxxx
%0011_dddd_eppp_xxxx       %1    32-bit RFLONG RGB24 (8:8:8)   $RRGGBB00

%0100_dddd_eppp_bbbb     %rxx    1-bit RFLONG LUT, r=reorder   $xxxxxxxx
%0101_dddd_eppp_bbbb     %rxx    2-bit RFLONG LUT, r=reorder   $xxxxxxxx
%0110_dddd_eppp_bbbb     %rxx    4-bit RFLONG LUT, r=reorder   $xxxxxxxx
%0111_dddd_eppp_bbbb        -    8-bit RFLONG LUT              $xxxxxxxx

%1000_dddd_eppp_bbbb   <long>    1-bit immediate LUT           $xxxxxxxx
%1001_dddd_eppp_bbbb   <long>    2-bit immediate LUT           $xxxxxxxx
%1010_dddd_eppp_bbbb   <long>    4-bit immediate LUT           $xxxxxxxx
%1011_dddd_eppp_bbbb   <long>    8-bit immediate LUT           $xxxxxxxx

%1100_dddd_eppp_xxxx   <long>    32-bit immediate              $xxxxxxxx

%1101_xxxx_xppp_pppx     %r00    1-pin -> WFBYTE, r=reorder    <none>
%1101_xxxx_xppp_ppxx     %r01    2-pin -> WFBYTE, r=reorder    <none>
%1101_xxxx_xppp_pxxx     %r10    4-pin -> WFBYTE, r=reorder    <none>
%1101_xxxx_xppp_xxxx      %11    8-pin -> WFBYTE               <none>

%1110_xxxx_xppp_xxxx        -    16-pin -> WFWORD              <none>

%1111_xxxx_xppp_xxxx        -    32-pin -> WFLONG              <none>



}
vsync		res	1
vx			res	1
vy			res	1
_hblks		res	1
_vcnt		res	1
_hcnt		res	1
scrptr		res	1
