$60000 FL TAQOZ ( Primary kernel extensions )
0000 NFA' END 8 + $0C0 CMOVE --- make a backup of TAQOZ configuration at the end of the dictionary

	--- EXTEND MODE HEADER ---

pub *EXTEND*		PRINT" Primary kernel extensions 200525-1000" ;

0 @ := VEC0	--- lock in reset vector constant since loc 0 gets trashed at times

{
TAQOZ V1.1 EXTENSIONS
V1.2 integrates kernel components
V2 has new kernel
}


{
--- set new cfa to point back to DOES: code (skipped by DOES: itself)
pub DOES>	R> 0 REG W@ W! ;
--- create new dev with dummy cfa (save ptr to it)
pub CREATE	HERE [C] CREATE: [C] GRAB HERE 0 REG W! 0_0 [W] ;

pre Q  CREATE [W] DOES> W@ . ;


PTR CH 0

0 $1.0000 CRLF BEGIN C@++ ?DUP KEY 0= AND WHILE DUP EMIT ROT OVER = IF DUP $0D = IF $0A EMIT THEN THEN SWAP REPEAT 2DROP

}

pub CPA! ( n nfa -- )	DUP $20 AND IF CPA M! ELSE CPA W! THEN ;

\ ALIAS <for> <as>
pre ALIAS	[C] NFA' [G] DUP CFA [C] CREATE$ @WORDS CPA!   C@ $E0 AND @WORDS C+! ;


--- alternative comment for titles

ALIAS \ ***
ALIAS AND &
ALIAS ANDN !&
ALIAS XOR ^
ALIAS = ==
ALIAS ' AT


\ Simple word spacer, does and compiles nothing, just helps with readability
pre ... ;

\ dummy prompt to allow console output to be copy and pasted back in
pub TAQOZ# ;

( P2 CONTROL )
public
{
COG REGISTER LAYOUT

The cog's 512 x 32 dual-port RAM, used for code and data, is mapped as follows:
}
( $000..$1EF    RAM            general-use code/data registers )
$1F0 :=     IJMP3       --- interrupt call   address for INT3
$1F1 :=     IRET3       --- interrupt return address for INT3
$1F2 :=     IJMP2       --- interrupt call   address for INT2
$1F3 :=     IRET2       --- interrupt return address for INT2
$1F4 :=     IJMP1       --- interrupt call   address for INT1
$1F5 :=     IRET1       --- interrupt return address for INT1
$1F6 :=     PA       	--- CALLD-imm return, CALLPA parameter, or LOC address
$1F7 :=     PB  	--- CALLD-imm return, CALLPB parameter, or LOC address

$1F8 :=     PTRA        --- pointer A to hub RAM
$1F9 :=     PTRB        --- pointer B to hub RAM
$1FA :=     DIRA        --- output enables for P31..P0
$1FB :=     DIRB        --- output enables for P63..P32
$1FC :=     OUTA        --- output states for P31..P0
$1FD :=     OUTB        --- output states for P63..P32
$1FE :=     INA         --- input states for P31..P0 also debug interrupt call address
$1FF :=     INB        --- input states for P63..P32 also debug interrupt return address

27	:= CLKREG			--- store clock mask here for CLOCK  '
28	:= CLKDLY			--- delay register ( 0=none)'
6	:= KBCLK
7	:= KBDAT


private

$10	:= _xin
$14	:= _cpuhz
$18	:= _clkcfg
$1C	:= _baud
$20	:= _vgacfg
$24	:= _vspin
\ $28	:= @vgainit
\ $2C	:= kbpins
\ $30
\ $34

--- some common constants
public

64 KB		:= 64KB
1,000,000	:= 1M

--- run a TAQOZ task in another cog
pub RUN ( task cog -- )		DUP NEWCOG 5000 WAITX TASK W! ;

--- Run the code that follows this word as a cog task
pub RUN: ( cog -- )		R> SWAP RUN ;

( to use: ' <mytask> 1 RUN )

--- Set the lower address to trace from and enable tracing
pub TRACE! ( floor -- )		TRACE $1EF COG! ;




--- create names for some kernel variables
public

--- print n as 5 hex digits
pub .M ( n --- )	DUP 16>> .H .WORD ;

--- Set the prompt or use 0 to reset to default
pub PROMPT! ( cfa -- )	uprompt W! ;

--- Print code pointer prompt
pri .HERE		." TAQOZ[" HERE 16>> ?DUP IF .BYTE THEN HERE .WORD ." ]# " ;

--- Change prompt to include current code pointer
pub PAGER		' .HERE uprompt W! ;

--- Plain non-interactive responses for remote operation - Remove prompt and accept strings
pub REMOTE		flags C~ AT NOP PROMPT! AT NOP uaccept W! $CE REG W++ ;

--- Reset prompt to local interactive
pub LOCAL		1 flags SET uprompt W~ uaccept W~ ( linenum W~ ) CON ;



	*** ANSI TERMINAL SUPPORT ***

{
NOTE: ANSI controls are prefixed with % to distinguish them from other similar commands
}
pub *ANSI*			PRINT" ANSI TERMINAL SUPPORT 200410-0000" ;
pub ESC ( ch -- )		$1B CONEMIT CONEMIT ;

pub %HOME			'H'
 pri ESCB ( ch -- )		'[' ESC CONEMIT ;

pub %PEN ( col -- )		7 AND '3'
 pri COL ( col fg/bg -- )	ESCB '0' + CONEMIT 'm' CONEMIT ;
pub %PAPER ( col -- )		'4' COL ;


 pri CUR ( cmd n -- )		'[' ESC SWAP
 pri .PAR			SWAP . CONEMIT ;
pub %XY ( x y -- )		';' SWAP CUR 'H' .PAR ;


pub %CLS 			$0C CONEMIT ;
--- Erase the screen from the current location
pub %ERSCN			'2' ESCB 'J' CONEMIT ;
--- Erase the current line
pub %ERLINE			'2' ESCB 'K' CONEMIT ;


pub %CURSOR ( on/off -- )	'?' ESCB 25 .
 pri asw				IF 'h' ELSE 'l' THEN CONEMIT ;

pub %PLAIN			'0'
 pri ATR ( ch -- )		ESCB 'm' CONEMIT ;
pub %REVERSE			'7' ATR ;
pub %BOLD			'1' ATR ;

pub %WRAP ( on/off -- )		'?' ESCB '7' CONEMIT asw ;

\ pub %MARGINS ( top bottom -- )	'[' ESC SWAP ':' .PAR 'r' .PAR ;


public
--- ANSI COLORS
0	:= %black
1	:= %red
2	:= %green
3	:= %yellow
4	:= %blue
5	:= %magenta
6	:= %cyan
7	:= %white





	*** DEFERENCE ***

--- simple single level defer (needs to be tied in with accept )
pub <-		NOP  AT NOP AT <- W! ;
pub ->		R>  ( AT DEFERRED DUP 2+ 6 <CMOVE ) AT <- W! ;

pub CALL$ ( string -- )
	DUP C@
	IF DUP SEARCH ( str nfa )
	  ?DUP IF NIP CFA CALL
	  ELSE ( str ) unum W@ ?DUP IF CALL ELSE DROP THEN
	  THEN
	ELSE DROP
	THEN ;

long nx'	--- eval string ptr

 pri EVALKEY	nx' @ C@ DUP IF nx' ++ ELSE ukey W~ THEN ;

pub EVALUATE
	$20 OVER DUP LEN$ + W!
	nx' ! ' EVALKEY ukey W!
	BEGIN GET$ DUP LEN$ WHILE NUMBER 0= IF @WORD CALL$ THEN  REPEAT
	DROP
	;


 	*** DICTIONARY MODULE HIDE/REVEAL  ***
{
Uses new absolute dictionary link word to skip words in dictionary.
All that is required is a dummy "pub _ ;" word which is overwritten
with a link code to hide all entries up to the link
To reveal the original NFA of this dummy _ word which is then restored
}
{
pub HIDE$				SEARCH
--- NFA' *TIA* HIDE
pub HIDE ( to-nfa -- )			" _" SEARCH ?DUP IF SWAP OVER - 16<< $8000 + SWAP  !  ELSE DROP THEN   ;

pub REVEAL$ 				SEARCH NFA+
--- NFA' _ REVEAL
pub REVEAL ( from-nfa -- )		$5F01 SWAP W! ;
}



4  := #vocabs
#vocabs longs vocabs
--- only default FORTH vocab
pub FORTH	vocabs #vocabs 4* ERASE ;



pub @VOCAB ( index -- addr )	4* vocabs + ;

--- push this vocab to the top of the search list
pub +VOCAB ( nfa --- )
	vocabs vocabs 4+ #vocabs 1- 4* <CMOVE
	vocabs !
	;

pub SEARCH-VOCABS ( str -- nfa )
	0 #vocabs
	ADO
	  I @VOCAB @ ?DUP IF OVER SWAP ( str str list ) FIND$ ( str nfa ) ?DUP ?LEAVE ELSE 0 LEAVE THEN
	LOOP
	( str nfa )
	?DUP IF NIP ELSE @WORDS FIND$ THEN
	;

FORTH

--- Called from vocab control word and links in
pri (VOCAB)
	R> @ NFA+ +VOCAB
	' SEARCH-VOCABS ufind W!
	;

pre VOCAB ( <name> <including> -- )
---	First create a dummy link word with no skip (04)	1
	-4 uwords +! $04_8000 @WORDS !   @WORDS
---	Then create a definition that calls the vocab linking code
	[C] CREATE: AT (VOCAB) HERE 2- W! DUP  HERE ! 4 ALLOT
---	Then calculate the link displacement and update it
	[C] NFA' [G] OVER - SWAP 2+ W!
	;

( USAGE: VOCAB ASSEMBLER *TIA* )


(	********************** INSERT TIA HERE ?? ************************ )





{	Background Polling
low priority background functions are checked when console input is idle
Up to 8 vectors are polled as part of POLLS
}
pub POLLS		NOP NOP NOP NOP NOP NOP NOP NOP ;

--- Init and clear all polling vectors
pub !POLLS		AT POLLS 16 ADO AT NOP I W! 2 +LOOP ;

pub POLL:
	R>
pub +POLL
	AT POLLS 16 ADO
	  I W@ AT NOP = IF DUP I W! LEAVE THEN
	  DUP I W@ = ?LEAVE
	2 +LOOP
	DROP AT POLLS keypoll W!
	;


	*** SOFT TIMERS ***

--- define simple timers which uses one word for milliseconds and a long for CNT origin
pub TIMEOUT ( ms dvar -- )
	CNT@ OVER 4+ ! W!
	;
pub TIMEOUT? ( var -- flg )
	DUP 4+ @ CNT@ - ABS 1000 CLKHZ U*/ ( var mslap )
	SWAP W@ U>
	;
pub ?UNTIL ( var -- )	BEGIN DUP TIMEOUT? UNTIL DROP ;





--- redefine | literal byte compile to compile pairs of bytes automatically
pri ~b	0 ;
' ~b W@ := w

pre |	[G] >B ~b IF 8<< ~b >B + [C] || w ELSE w $100 + OR THEN AT ~b W! ;

--- negate long at adr
pub +-! ( adr -- )		DUP @ NEGATE SWAP ! ;

--- Revector any calls to target to jump to new by rewriting first wordcode
pre REVECTOR ( <target> <new> -- ) [C] AT [C] AT [G] 1+ SWAP W! ;

private
long _el
byte _sp
pri SPINNER
---	check if enough time has elapsed -  then update
	CNT@ _el @ - ABS CLKHZ 10 / > 0EXIT CNT@ _el !
---	output next char and backspace
	_sp C@ 3 AND " |/-\" + C@ EMIT 8 EMIT _sp C++
	;

pub .BITS ( n bits -- ) 	FOR DUP 1& . 2/ NEXT DROP ;

pub .BYTES ( adr bytes -- )	ADO IC@ .BYTE SPACE LOOP ;

pub #c		',' ;

--- process all digits for printing from right to left while inserting commas every third digit
pri #S, ( val -- 0 )
	0 SWAP
	BEGIN
---	while double not zero and not first digit
	  DUP 12 REG @ OR 3RD 0= OR
	WHILE
---	  after 1st check group if comma
	  OVER IF OVER 3 // 0= #c 0<> AND IF #c HOLD THEN THEN
---	  prepend a digit and increment digit count
	  # b++
	REPEAT
	NIP
	;
--- print a double number right justified
pub D.DECS ( dval. digits -- )	SWAP <D>
pub .DECS ( val digits -- )	>R <# #S, #> R> OVER LEN$ - 0 MAXS SPACES PRINT$ ;

pub >STR ( number -- string ) 	DUP ABS <# #S SWAP 0< IF '-' HOLD THEN #> ;

pub .DP ( num left-digits -- )
	SWAP >STR 2DUP SWAP CTYPE '.' EMIT ( left str )
	DUP LEN$ ( left str len )
	3RD - SWAP ROT + SWAP CTYPE
	;
--- print a double number
pub D.				0
pub D.R ( dval. digits -- )	SWAP <D>
pub U.R				SWAP <# #S #> DUP LEN$ ROT SWAP - 0 MAXS SPACES PRINT$ ;

--- print bytes as bytes or kilobytes
\ pri .KB				DUP 10 >> IF 10 >> .AS" *|kB" ELSE .AS" *| B" THEN ;

--- Print memory capacity
pub .MEM
	DUP >STR LEN$ SWITCH
	1 3 <CASE> .DEC PRINT" B" BREAK
	1000 U/
	4 6 <CASE> .DEC PRINT" KB" BREAK
	1000 U/
	7 9 <CASE> .DEC PRINT" MB" BREAK
	1000 U/ .DEC PRINT" GB"
	;

--- to Upper Case
pub a>A ( ch -- ch )		DUP 'a' 'z' WITHIN IF $20 - THEN ;

pub $= ( str1 str2 -- flg )
	OVER LEN$ OVER LEN$ =
	IF
	  DUP LEN$
pub C$= ( adr1 adr2 len -- flg )
	  ADO C@++ IC@ <> IF 0= LEAVE THEN LOOP
	  0<>
	BREAK
	2DROP FALSE
	;

32 bytes X$
pub $+ ( str1 str2 -- strx )	SWAP X$ $! X$ DUP LEN$ + OVER LEN$ 1+ CMOVE X$ ;

\ S2 X$ LEN2+1


--- replace the inline 10-bit literal with a new value
pub >!				$3FF AND w + R> W! ;

{ pre REPLACE ( <old> <new> -- )
	NFA' DUP C@ $1F AND GETWORD DUP LEN$ ROT =
	  IF ( nfa word ) SWAP C@++ $1F AND CMOVE
	  ELSE 2DROP ."  Mismatched "
	  THEN
	;
}




' 0EXIT 9 - := PAGE0

\ pub .HADR	CRLF DUP 16>> .H $FFFF AND .WORD ." : " ;

pub .NFA ( nfa -- )	C@++ $1F AND CTYPE ;

pub CFA>NFA ( cfa -- nfa )
	@WORDS
	BEGIN DUP W@
	WHILE 2DUP CFA = IF NIP EXIT THEN NFA+
	REPEAT 2DROP 0
	;

pub LWORDS
	@WORDS
	BEGIN ( cnt width words )
	  DUP .ADDR
	  DUP W@
	WHILE ( cnt width words )
	  DUP CFA .M
	  DUPC@ 5 >> DUP 3 + SPACES 3 * " pub-1-pri-3-pre-5--6--7-" + 3 CTYPE
	  SPACE
	  DUP .NFA
	  NFA+
	REPEAT
	DROP
	;


--- Test header to see if it is a *MODULE* name
---		Starts with *	  Ends with *                           and len is > 3
pri MOD?	DUP 1+ C@ '*' =	  OVER DUP C@ $1F AND + C@ '*' =    AND SWAP C@ $1F AND 3 > AND ;

pub MWORDS ( width -- )
	0 @WORDS DUP .ADDR
	BEGIN ( cnt width words )
	  OVER 4TH > OVER MOD? OR IF ( DUP .ADDR ) CRLF NIP 0 SWAP THEN
	  DUP W@
	WHILE ( cnt width words )
	  DUP C@ $1F AND 1+ ROT + SWAP
	  DUP C@++ $1F AND CTYPE SPACE
	  DUP MOD? IF CRLF CRLF THEN
	  NFA+
	REPEAT
	3DROP
	;

--- Rename kernel WORDS to wORDS before creating new WORDS
'w' NFA' WORDS ?DUP IF 1+ C! THEN

pre WORDS
	delim 1+ C@ $20 =
	IF
	  GET$ DUP UPPER$ DUP " -L" $= IF DROP LWORDS EXIT; THEN
	  DUP " -M" $= IF DROP 100 MWORDS EXIT; THEN
	THEN
	[C] wORDS
	;

--- Print TAQOZ control key assignments ---
pub .CTRLS
	32 FOR I 2* AT GET$ $40 - + W@ ?DUP IF CRLF I .B ."  ^"  I '@' + EMIT SPACE DUP CFA>NFA ?DUP IF .NFA DROP ELSE .M THEN THEN NEXT
	;
{
pub .VARS ---
         @WORDS ---
         BEGIN ---
           DUP W@  ---
         WHILE ---
           DUP CFA W@ $140 $141 WITHIN  ---
             IF CRLF DUP CFA 2+ @ .L  ---
             DUP CFA W@ $141 = IF ."  = " ELSE ."  @ " THEN  ---
             DUP .NFA THEN ---
           NFA+ ---
         REPEAT ---
         DROP ---
         ; ---
}


pri .CV
         @WORDS
         BEGIN
           DUP W@
         WHILE
           DUP CFA W@ 4TH 4TH WITHIN
             IF CRLF DUP CFA 2+ @ .L
             DUP CFA W@ $141 = IF ."  = " ELSE ."  @ " THEN
             DUP .NFA
             THEN
           NFA+
         REPEAT
         3DROP
          ;


pub .CONVARS 	' _sp W@ ' 1M W@ 1+ .CV ;
pub .VARS   	' _sp W@ DUP .CV ;
pub .CONS 	' 1M W@ DUP 1+  .CV ;


6 bytes dz
--- DUMP MEMORY AS BYTES BUT SKIP ANY 128 BYTE PAGE THAT IS ALL 0'S OR FF'S
pub DUMPZ ( src cnt -- )
	$AA REG dz 6 CMOVE
	ADO
	  0 I 128 ADO I dz W@ ?DUP IF CALL ELSE C@ THEN + LOOP
	  ?DUP IF $FFFF.FFC0 <> IF dz $AA REG 6 CMOVE  I 128 DUMP THEN ELSE CRLF I .M ." : " THEN
	128 +LOOP
	;


private
long _pinmode
IFDEF PIN
'p' NFA' PIN 1+ C! --- rename PIN to pIN to make way for new def
}

pub PIN		pIN _pinmode ~ ;

--- Create a pin code range for Rev B pins instructions
pub PINS ( from for -- pins )	1- 6 << + ;


pub .DEC2 	.AS" ##" ;

pub .io
	64 FOR
	  I $1F AND 0= IF CRLF  THEN
	  I 7 AND 4 = IF ." -" THEN
	  I 7 AND 0= IF I .AS"   ##:"  THEN
	  I PIN@ 1& I |< DIRA I 5 >> + COG@ AND IF 2+ THEN
	  " lhLH" + C@ EMIT
	NEXT
;

--- type out printable characters or substitute with a dot
\ pub CTYPE ( adr cnt -- )	ADO I C@ .EMIT LOOP ;

pri .OK		IF ."  OK!" THEN ;

pri .SUCCESS
	SPACE IF ." SUCCESS!" BREAK ." ERROR!"
	;
pub TAB				9 EMIT ;
pub TABS			CR FOR TAB NEXT ;

--- redirect (using uemit/ukey) all character I/O to the code that follows
pub EMIT:			R> EMIT! ; \ uemit W! ;
pub KEY:			R> ukey W! ;
--- null output device - discard data
pub NULL			EMIT: DROP ;

long bufptr
long bufwr
long bufsz

--- direct output to a new buffer in memory or add to that buffer
pub =BUF ( address size -- )	bufsz ! bufptr ! bufwr ~
pub +BUF			EMIT: bufptr @ bufwr @ + C! bufwr @ 1+ bufsz @ // bufwr ! ;

pub CONOUT
	EMIT:
pub MBXEMIT
	BEGIN outbox C@ 0= UNTIL outbox C!
	;


--- create a table of preallocated bytes
pre TABLE ( bytes -- ) ( -- addr )
	HERE 2+ [G]
---	create name and allow bytes
	[C] CREATE: DUP ALLOT
---	erase any allocated bytes
	?DUP IF ERASE ELSE DROP THEN
	;

pub HERE: R> ;

--- compiles the current data ptr before creating a new word
pre module			org@ [C] , [C] CREATE$ [C] ] ;

		*** BENCHMARKS ***

pub fibo ( n -- f )  		0 1 ROT FOR BOUNDS NEXT DROP ;


pub fibos  1 46 ADO CRLF I .AS" fibo(*|#) = " LAP I fibo  LAP .LAP ."  result = " .DECL 5 +LOOP ;

{

: fib ( x -- y )
	DUP 2 > IF DUP  1- fib
		   SWAP 2- fib +  EXIT
	     THEN
	DROP 1 ;
pub fibos  1 46 ADO CRLF I .AS" fibo(*|#) = " LAP I fibo  LAP .LAP ."  result = " .DECL 5 +LOOP ;
40 fibo . --- 102334155 ok 375 secs
iterative version
TAQOZ# lap 40 fibo lap .lap --- 2,961 cycles= 11,844ns @250MHz ok

200325
TAQOZ# 40 LAP fibo LAP .LAP --- 2,904 cycles= 14,520ns @200MHz ok
fibo(46) = 3,336 cycles= 16,680ns @200MHz result = 1,836,311,903 ok

fibo(1) = 441 cycles= 2,205ns @200MHz result = 1
fibo(6) = 761 cycles= 3,805ns @200MHz result = 8
fibo(11) = 1,081 cycles= 5,405ns @200MHz result = 89
fibo(16) = 1,401 cycles= 7,005ns @200MHz result = 987
fibo(21) = 1,721 cycles= 8,605ns @200MHz result = 10,946
fibo(26) = 2,041 cycles= 10,205ns @200MHz result = 121,393
fibo(31) = 2,361 cycles= 11,805ns @200MHz result = 1,346,269
fibo(36) = 2,681 cycles= 13,405ns @200MHz result = 14,930,352
fibo(41) = 3,001 cycles= 15,005ns @200MHz result = 165,580,141
fibo(46) = 3,321 cycles= 16,605ns @200MHz result = 1,836,311,903 ok

}

{
'**************** configuration block **************** '
$00004

		byte	"P2-ES   "		' 8 character ID'
_OPTIONS	byte	%0000_0011		' options    SD,FLASH
		byte	0,0,0

'	*** CLOCK ***	'
''$10
_XIN		long	XIN			' input freqency'
_CPUHZ		long	CPUHZ			' final clock '
_CLKCFG		long	CLKCFG	''$014CB3FC 'CLKCFG

'	*** SERIAL/VGA/KEYBOARD *** '
_BAUD		long	baud_rate
_VGACFG		long	vgapins			' VGA CONFIG '
		long	vspin
_VGAINIT	long	@vgainit		' VGA code '
_KBCFG		long	kbpins
		long	0

'	*** RESET VECTORS *** '
_RESET		long	@RESET
_IDLE		long	@IDLE
_TERMINAL	long	@TERMINAL		' COG0 TASK'
_COG1		long	0			' COG1 TASK ( 0=none )
_COG2		long	0
_COG3		long	0
_COG4		long	0
_COG5		long	0
_COG6		long	0
_COG7		long	0



$10	:= _xin
$14	:= _cpuhz
$18	:= _clkcfg
$1C	:= _baud
$20	:= _vgacfg
$24	:= _vspin
\ $28	:= @vgainit
\ $2C	:= kbpins
\ $30
\ $34
}


 	*** SERIAL MODES ***
{
115200 RXD		--- 115200 baud (default 8-bit) receive
9 -bit 1 M TXD		--- 9-bit 1 megabaud transmit

}

pri dl				7 ; --- bit length of asynch serial smartpin interface
pub -bit ( n -- )		1- ' dl C! ;
pri BAUD ( baud mode -- )	WRPIN CLKHZ SWAP U/ 16<< ( dl 0= IF 8 BIT THEN ) dl + WXPIN H 8 -bit ;
pub TXD ( baud -- )		$7C BAUD 0 WYPIN ;
pub RXD ( baud -- )		$3E BAUD ;

byte _com
pub COMPORT ( pin -- )		_com C! EMIT: _com C@
pub SEROUT ( data pin -- )	pIN WAITPIN WYPIN ;


---				config save	set rxd mode   & tx mode
pub CONBAUD ( baud -- )		DUP _baud !  	63 PIN DUP RXD 62 PIN TXD ;





		*** P2 CLOCK CONTROL ***

pub *P2CLOCK*		PRINT" P2 CLOCK CONTROL 190800-0000" ;

{
CLOCK MODES
---	 1098_7654_321098_7654321098_7654_32_10
---	 0000_000E_DDDDDD_MMMMMMMMMM_PPPP_CC_SS

SS		Clock source
CC
PPPP		PLL divider 1,2,4,6...30
MMMMMMMMMM
DDDDDD		DIVIDE XIN TO PHASE COMP REFERENCE
E		PLL ENABLE
}
public
long _clk  \  _clk ~
private
long _fin
--- set the
pub CLKSET			_clk @ DUP _clkcfg ! HUBSET ;
( PLL should run between 100 to 200MHz )

--- CC: Usage: 30 pf or 15 pf or 0 pf or -15 pf to disable
pri +CC
pri pf ( pf -- )		15 / 1+   3 AND 2 << $0C
pri CLK! ( data mask -- )	_clk @ SWAP ANDN OR _clk ! ;

--- E: - enable PLL
pub PLLEN			24 |< _clk SET ;
pub PLLOFF			24 |< _clk CLR ;

--- DDDDDD:
pub XIDIV ( 1..64 -- )		1- $3F AND 18 << $00FC0000 CLK! ;
( ends up as multiply)
pub VCOMUL ( 1..1024 -- )	1- $3FF AND 8 << $3FF00 CLK! ;

--- PPPP: Divide the PLL by 2 4 6 ... 30 for the system clock when SS = %11 --- 1 = 31 = no divide
pub +PPPP
pub PLLDIV ( 2..30 -- ) 	2/ 1- >N 4 << $0F0 CLK! ;

--- SS: clock source
pub +SS
pub CLKSRC			CLKSET DUP 1 > IF 200,000 WAITX THEN 3 AND 3 CLK! CLKSET ;

pub USEPLL			3 CLKSRC ;
pub USEXTAL			2 CLKSRC ;

public
CLKHZ 1,000,000 U/ := CLKMHZ

ALIAS CLKHZ clkfreq	--- alias for common "clkfreq" name

pri HZ!
	DUP _cpuhz ! 1,000,000 U/
	DUP AT CLKMHZ :=!
---	CPUHZ/4_000_000
	4/ AT us @ $1FF ANDN OR AT us !
	;


--- Set P2 CLOCK to selected MHZ ( simple PLL settings only )

pub CLKHZ! ( HZ --- )
---	automatically make <500 into MHz
	DUP 500 < IF M THEN
---	align to multiples of XIN
	$10 @ U/ $10 @ *
pri CLKHZ1! ( hz -- )
	_clk ~ HZ! 0 HUBSET
---	defaults of 15pF and an XI divide of 1
	  15 pf PLLEN 1 XIDIV
---	then multiply up the base input frequency
	  CLKHZ _xin @ U/ VCOMUL
---	default PLL divider of 1 and enable
	  1 PLLDIV USEPLL
pub !CLKHZ
	NOP NOP NOP NOP
---	reload to calculate baud rate setting
	_baud @ CONBAUD
	;

ALIAS CLKHZ! clkfreq!
ALIAS CLKHZ clkfreq
ALIAS .CLK .clkfreq

--- RCSLOW is fairly stable at 20kHz but mmake no other timing adjustments
pub RCSLOW		20,000 HZ! 1 HUBSET _clk ~ ;

---			nominal rcfast freq ( Use <new value> AT RCFAST 2+ ! )
pub RCFAST		25,100,000	( CLKHZ1! ) 0 HUBSET _clk ~ HZ! !CLKHZ ;

--- quick clock set to MHZ - but delay for transmit characters during interactive
\ pub CLKMHZ!		5 ms M CLKHZ! ;

\ pub COAST		125 CPUMZ ;
pub CRUISE		200 clkfreq! ;
\ pub TURBO		250 CPUMHZ ;
\ pub RACE		300 CPUMHZ ;



		*** HUB ***

\ %0100_xxxx_xxxx_xxxx_xxxx_xxxR_RLLT_TTTT     Set filter R to length L and tap T

pub FILTER! ( tap0..31 len0..3 filter0..3 -- )	3 AND 7 << SWAP 3 AND 5 << OR SWAP $1F AND OR HUBSET ;


			*** SMART PINS ***

pub *SMARTPINS*		PRINT" SMARTPIN FUNCTIONS and drive modes 190800-0000" ;



{
                     PIN CONTROL
       1098_7654_321_0987654321098_76_54321_0
D/# = %AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0

PIN MODE 13 BITS
CIO HHH LLL

 PIN DRIVE MODES

1K5 SOURCE NO SINK
OPEN SOURCE FAST SINK
1K5 SOURCE FAST SINK
OPEN DRAIN



--- Normal I/O pin with 1k5 pullup
56 PIN 1K5 SOURCE FAST SINK SETPIN
56 PIN SETPIN
To configure non-smartpin modes - select PIN prior to modes
Default is fast push/pull (normal CMOS drive)
32 PIN					--- Selects P32 and clears config setup
32 8 PINS				--- Selects P32..P39 and clears config setup


OPEN-DRAIN SETPIN			--- open-drain
OPEN SOURCE 15K PULLDOWN !IN SETPIN	--- 15k pulldown inverted input:
1K5 PULLUP FAST PULLDOWN SETPIN		--- 1k5 pullup open-drain
1K5 PU CMOS SINK
1ma SOURCE FAST SINK			--- 1ma pullup open-drain


}

	*** PIN DRIVE MODES ***

--- pin driver settings - use in descriptive combination
--- use: 4 PIN 1K5 SOURCE FAST SINK


pri 14P				14
pri PINM ( val field -- )	<< _pinmode SET ;

pub CLOCKED			$100 14P ;
pub !IN				$80 14P ; --- inverted input
pub !OUT			$40 14P ;

--- drive mode operand for source/sink
pub CMOS			0 ;
pub 1K5				1 ;
pub 15K				2 ;
pub 150K			3 ;
pub 1ma				4 ;
pub 100ua			5 ;
pub 10ua			6 ;
pub OPEN			7 ; ( float )
pub SOURCE ( val -- )		11 PINM ;
pub SINK ( val -- )		8 PINM ;

public
ALIAS SOURCE PULLUP
ALIAS SINK PULLDOWN
ALIAS PULLUP PU
ALIAS PULLDOWN PD

pub OPEN-DRAIN			OPEN SOURCE CMOS SINK ;

pub SETPIN			0
--- WRPIN in combo with modes - float, shift, combine, wrpin, low (DIR=1)enables smartpin
pub WRFNC ( MMMMM -- )		F 2* _pinmode @ OR WRPIN L ;


--- mute smartpin functions on current pins(pins)
pub MUTE			F 0 WRPIN ;

	*** FREQUENCY MEASUREMENTS ***
---	%AAAA_BBBB_FFF_PPPP_PPPPPPPPP_TT_MMMMM_0
---	               1k5  L0.45Vdac----
---	%0000_0000_000_1100_000100000_00_10101_0

--- Set up the pin in frequency counting mode
pub FREQCNT ( clocks mode0..2 -- )
---	Lookup and write selected mode
\	F 2* %00_10101_0 + WRPIN
	F 2* %1100_000100000_00_10101_0 + WRPIN
	CLKMHZ * WXPIN   %00 WYPIN   H
	;

--- Return with raw frequency measurements from current pin
pub RAWFREQ? ( us -- clocks states periods )
	3 FOR DUP I FREQCNT AKPIN WAITPIN RQPIN SWAP NEXT DROP
	;


--- demo to print the frequency and duty cycle
pub .FREQ ( us -- )
	RAWFREQ? ( clocks states periods )
---	duty = states * 1_000 / clocks
	SWAP 1,000 4TH */  ( clocks periods duty ) -ROT  \ ." Duty = " 2 .DP ." %"   ( clocks periods )
---	'frequency = periods * sysfreq / clocks
	CLKHZ ROT */ ( GETQY SWAP ) .DECL .AS" Hz @ ##.#%"
	;

{
	qmul	states,##1_000			'duty = states * 1_000 / clocks
	getqx	x
	getqy	y
	setq	y
	qdiv	x,clocks
	getqx	duty

	qmul	periods,##round(sysfreq)	'frequency = periods * sysfreq / clocks
	getqx	x
	getqy	y
	setq	y
	qdiv	x,clocks
	getqx	frequency

	getqy	y				'frequency sub = remainder / clocks * 1_000_000
	qfrac	y,clocks
	getqx	x
	qmul	x,##1_000_000
	getqy	frequency_sub
}

	*** SMARTPIN NCO ***

--- convert frequency to count value depending upon system clock
pub NCOCNT ( hz -- cntval )	CLKHZ 4 << SWAP U/ 0 $10 ROT UM/ ;
--- convert nanoseconds to counter value based on CLKHZ
pub NSCNT ( ns -- cntval )	1000 * 1,000,000,000,000. CLKHZ UM/ U/ ;



	*** SMARTPIN FREQUENCY GENERATION ***

pub MHZ ( MHz -- )		1000 *
pub KHZ	( kHz -- )		1000 *
--- setup smartpin to output a square wave frequency
pub HZ ( Hz -- )		NCOCNT
--- select NCO frequency mode
pub NCO ( count -- )		%1_00110
pub SETNCO ( count mode --)	WRFNC 1 WXPIN WYPIN ;

--- Duty mode smartpin (frequency varies with duty)
pub DUTY ( val -- )		%01_00111 SETNCO ;

pub BLINK ( pin -- )		PIN 2 HZ ;


	*** SMARTPIN PWM ***

--- pulse-width modulation output : use: 25 100 1 PWM!
pub PWM ( duty frame div -- )	%1_01001
pri PWM!			WRFNC SWAP 16<< OR WXPIN WYPIN ;
pub TRI ( duty frame div -- )	%01_01000 PWM! ;
--- switch-mode PWM
pub SMPS ( duty fram div -- )	%01_01010 PWM! ;

	*** SMARTPIN PULSES ***

{ Usage:
 48 PIN ... 12000 6000 HILO ... 50 LOW ... 16 PULSES ... WAITPIN ... 3 PULSES ... 50 HIGH
}

pub PW ( width -- )		%01_00101 WRFNC WXPIN ;

pub PULSE			1
pub PULSES ( cnt -- )		WYPIN ;
pub HILO ( high low -- )	%01_00100 WRFNC SWAP OVER+ SWAP 16<< OR WXPIN ;


	*** SMARTPIN ANALOG ***

--- SMART PINS - %AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0

( 12-bit analog to digital to analog, 19.5k samples/second )

---				16-bit dither DAC
pub DAC ( bits -- )		%101_00_0_0000000_01_00011 WRFNC |< WXPIN ;

--- Output a scaled voltage onto the DAC pin (5mv
pub mV ( millivolts --- )	5 - 0 MAXS 16<< 3300 U/ WYPIN ;

{ Ahle2 - https://forums.parallax.com/discussion/comment/1497176/#Comment_1497176
CON
  L_PIN = 0
  R_PIN = 1
  SYSTEM_CLOCK = 250000000
  SAMPLE_RATE = 250000

  'DAC_MODE             = %00001_0 ' DAC 8-bit noise
  'DAC_MODE             = %00010_0 ' DAC 16-bit dither, noise
  DAC_MODE             = %00011_0 ' DAC 16-bit dither, PWM
  DIR_MODE             = %01      ' Output enabled, overrides DIR
  INIT_8BIT_DAC_VALUE  = 128
  'ANALOG_OUT_MODE      = %10100 ' 990 ohm, 3.3V DAC mode
  'ANALOG_OUT_MODE      = %10101 ' 600 ohm, 2.0V DAC mode
  'ANALOG_OUT_MODE      = %10110 ' 123 ohm, 3.3V DAC mode
  ANALOG_OUT_MODE      = %10111 '  75 ohm, 2.0V DAC mode
  SMARTPIN_DAC_MODE    = (ANALOG_OUT_MODE << 16) | (INIT_8BIT_DAC_VALUE << 8) | (DIR_MODE << 6) | DAC_MODE
  SAMPLE_PERIOD        = SYSTEM_CLOCK  / SAMPLE_RATE  'CPU cycles between sample updates

DAT
    org

    wrpin   ##SMARTPIN_DAC_MODE, #L_PIN   ' Config smartpin DAC mode on left pin
    wrpin   ##SMARTPIN_DAC_MODE, #R_PIN   ' Config smartpin DAC mode on right pin
    wxpin   ##SAMPLE_PERIOD, #L_PIN       ' Set sample period for left audio channel
    wxpin   ##SAMPLE_PERIOD, #R_PIN       ' Set sample period for right audio channel
    dirh    #L_PIN                        ' Enable smartpin DAC mode on left pin
    dirh    #R_PIN                        ' Enable smartpin DAC mode on right pin
    setse1  #%001_000000 | L_PIN          ' Event triggered every new sample period (when "left in pin rises")

loop
    wypin    sawWave, #L_PIN              ' Output sample on left channel
    wypin    sawWave, #R_PIN              ' Output sample on right channel
    waitse1                               ' Wait for smart pin NCO wrap, new period
    add      sawWave, #1
    jmp      #loop

sawWave	 res      1
}

( RevA A/D --- TODO: needs to be updated )

pub ADC ( cycles -- )		%100_011_0000000_00_01111 WRFNC WXPIN 0 WYPIN ;

private
64 words amin	64 words aref
pri AREF			@PIN 2* aref + ;
pri AMIN			@PIN 2* amin + ;
pub SETADC ( min ref -- )	AREF W! AMIN W! ;
pub VOLTS@ ( -- volts*1000 )	RDPIN AMIN W@ - 1000 AREF W@ U*/ ;

( usage: 40 PIN 40,000 ADC 7191 7675 SETADC )


	*** SMARTPIN SERIAL ***

{ TRANSMITTING ASYNCH
TAQOZ# 34 PIN 8 BIT 115200 TXD  ok
TAQOZ# $55 WYPIN  ok
TAQOZ# $41 WYPIN  ok
TAQOZ# @NAMES 4 TXDAT  ok
'        1098 7654 321 0987654321098 76 54321 0
'           0 0001 000 0000000000000 01 11100 0
' D/# = %AAAA_BBBB_FFF_PPPPPPPPPPPPP_TT_MMMMM_0
' 11100*  = sync serial transmit         (A-data, B-clock)
}
\ pub SYNTX ( bits --- )		L $100.0078 WRPIN 1- $20 OR WXPIN ;


\ pub SERIAL ( pin -- )           PIN EMIT: WYPIN ;




( EASYFILE )





	*** I2C SUPPORT ***
{
P56 is SCL
P57 is SDA
COG 6 is SCL pin register - default 56
COG 7 is SDA pin register - default 57
COG 8 is SCL delay count - default 80 for 400kHz @200MHz


}

ALIAS I2C.STOP I2C>
ALIAS I2C.RESTART <I2C>

byte acks
pub I2C.START			acks C~ I2C.RESTART ;

pub I2CPINS ( scl sda -- )	7 COG! 6 COG! ;

pub i2cdev			$A4 ;
pub I2CRD? ( adr -- ack )	1 OR I2C.START I2C.WR 0= ;
pub I2CRD ( adr -- )		I2CRD? DROP ;
pub I2CWR ( adr -- ) 		1 ANDN I2C.START I2C.WR DROP ;
pub I2C! ( data -- )		I2C.WR 0= 1& acks C+! ;
pub I2C@ 			0 I2C.RD >B ;
pub nakI2C@			TRUE I2C.RD >B ;

pub I2CRDREG ( dev reg -- )	OVER I2CWR I2C! I2CRD ;

	--- I2C DUMP SUPPORT ---

pub I2CC@			i2cdev I2CWR I2C!    i2cdev I2CRD ;
pub I2C				AT i2cdev C! AT I2CC@ DUP DUP DUMP! ;

--- Set the I2C BUS FREQUENCY in kHz
pub I2C.KHZ ( khz -- )		1000 W* CLKHZ SWAP / 72 - 2 SAR 0 MAXS 8 COG! ;





	*** RV-3028 RTC ***

pub *RTC*			PRINT" RV-3028 RTC DATE and TIME 190800-0000" ;


pub RTC? ( -- flg )		$A4 I2CRD? I2C.STOP ;

--- RTC BCD STORE - store byte as BCD in RTC register
pub RTCB! ( byte reg -- )	SWAP 10 U// 4 << OR SWAP
pub RTC! ( byte reg -- )	$A4
pub I2CREG! ( dat reg dev -- )	I2CWR I2C! I2C! I2C.STOP ;

pub RTC@ ( reg -- byte )	$A4
--- fetch reg from 8-bit reg addr   ADDR   REG      ADDR  DATA
pub I2CREG@ ( reg dev -- dat )	DUP I2CWR SWAP I2C! I2CRD nakI2C@ I2C.STOP ;

--- rtc buffer
byte @sec
byte @min
byte @hour
byte @day
byte @date
byte @month
byte @year

--- RV-3028 can latch 7 bytes for I2C read
pub RDRTC			400 I2C.KHZ I2C.STOP 20 us  $A4 I2C! 0 I2C! <I2C> $A5 I2C! @sec 7 ADO I2C@ I C! LOOP nakI2C@ DROP I2C> ;

pub !RTC			( $BC ) $B4 $37 RTC! ;

pub RTC				AT RTC@ DUP DUP DUMP! ;


pub UTIME@ ( -- secs )		0 27 4 ADO I RTC@ OR 8 ROR LOOP ; \ 27 RTC@ 28 RTC@ 8<< + 29 RTC@ 16<< + 30 RTC@ 24 << + ;
pub UTIME! ( secs -- )		27 4 ADO DUP I RTC! 8>> LOOP DROP ;

pub TIME! ( hhmmss -- )		!RTC 100 U// SWAP 0 RTCB! 100 U// SWAP 1 RTCB! 2 RTCB! ;
pub DAY!			7 AND 3 RTC! ;
pub DATE! ( yymmdd -- )		!RTC 100 U// SWAP 4 RTCB! 100 U// SWAP 5 RTCB! 6 RTCB! ;

pub BCDDEC			DUP >N SWAP 4 >> 10 * + ;

pub BCD@			0 3 FOR 100 * OVER C@ BCDDEC + SWAP 1- SWAP NEXT NIP ;

pub TIME@			RDRTC @hour BCD@ ;
pub DATE@			@year BCD@ ;

pub DAY@			@day C@ 1 MAX 7 MIN ;

pub .6				.AS" ######" ;
pub .DT				DATE@ .6 '-' EMIT TIME@ .6 ;

pub .DATE			DATE@ 20000000 + .AS" ####/##/## "  ;
pub .DAY			DAY@ 1- 3 * " MONTUEWEDTHUFRISATSUN" + 3 CTYPE SPACE ;
pub .TIME			TIME@ .AS" ##:##:##" ;
pub .FDT			.DATE .DAY .TIME ;




	*** P2D2 EFM8UB3 SERIAL BACK CHANNEL COMMANDS ***
	--- ascii sequences for diagnostics ---
{
#$F5#$E5#$FA#$B4  echos i on serial
#$F5#$E5#$FA#$E1 Generates 10.23ms pulse on P1.0  = OK
#$F5#$E5#$FA#$D2 Generates Si5351 i2c preamble = OK


}
pub !!UB3 ( cmd -- )		20 ms $F5 EMIT $E5 EMIT $FA EMIT EMIT 20 ms ;
pub !!CG			$D2 !!UB3 ; 	--- trigger UB3 resend of CG table
pub !!PING			$B4 !!UB3 ; 	--- pings "i" on serial
pub !!ADC			$C3 !!UB3 ;	--- Reset UB3 ADC
pub !!SD			$E1 !!UB3 ;



	*** P2D2 EFM8UB3 I2C FUNCTIONS ***


{
CMD $30 ch           Read ADC ch - reads 13-bits
CMD $31 ADRL     Set address low for read, sets Addr Hi to 0xff unless $32 used first
CMD $32 ADRH     Set address Hi for read, send before $31 to read any page other than UUID
CMD $33 xx           Pulse SD reset - dummy byte required
CMD $34 xx            Emulate RTS toggle, triggers Si5351 reload
CMD $35 xx           Ping - echo inverted bytes and clear command vars to defaults  triggers Si5351 reload


pub ADC@ ( ch -- result ) 	$30 UB3! ( 100 us UB3@ DROP ) 30 us UB3@ ;
: CHECK
	61 FLOAT 58 FLOAT
	130 I2C.KHZ 0 BEGIN 1+ DUP $1F AND ADC@ DROP acks C@ 4 <> KEY $1B = OR 3 ms UNTIL
	 DUP . SPACE $1F AND .
	 ;

}

pub UB3KHZ	400 I2C.KHZ ;

pub UB3? ( -- flg ) 		UB3KHZ <I2C> $37 I2C.WR I2C.STOP 0= ;
\ pub UB3CMD ( byte cmd -- )	I2C.START $36 I2C! I2C! I2C! I2C.STOP ;

--- Write cmd & data to ub3	start     write dev cmd  data stop
\ pub UB3! ( data cmd -- )	I2C.START $36 I2C!  I2C! I2C! I2C.STOP ;
pub UB3! ( data cmd -- )	UB3KHZ I2C.START $36 I2C!  I2C! I2C! I2C.STOP ;

--- Read res & data from ub3	start     read dev restart   ack cmd  nak data
pub UB3@ ( -- hhll )		UB3KHZ <I2C> $37 I2C! 0 I2C.RD >B 8 << 1 I2C.RD >B OR I2C.STOP ;

pub !SDPWR			0 $33 UB3! ;
pub RTS				0 $34 UB3! ;
pub PING ( ch -- )		$35 UB3! ;


pub UB3ADR ( addr -- )		W>B $32 UB3! $31 UB3! ;

pub UB3W@ ( addr -- word )	UB3ADR I2C.START $37 I2C! I2C@ nakI2C@ 8<< OR I2C.STOP ;
pub UB3L@			DUP UB3W@ SWAP 2+ UB3W@ 16<< OR ;
pub UB3C@			UB3ADR I2C.START $37 I2C! I2C@ nakI2C@ DROP I2C.STOP ;
pub UB3				UB3KHZ AT UB3C@ AT UB3W@ AT UB3L@ DUMP! ;

pub UB3>RAM ( src dst cnt -- )	ROT UB3ADR I2C.START $37 I2C! ADO I2C@ I C! 50 us LOOP I2C.STOP ;
\ pub UB3>RAM ( src dst cnt -- )	ADO DUP UB3W@ I W! 2+ 2 +LOOP DROP ;
pub UB3ROM
	$40000 64 KB $FF FILL
	0 $40000 $9DF0 UB3>RAM
	$FA00 $4FA00 $1F0 UB3>RAM
	$FFC0 $4FFC0 $40 UB3>RAM
	;
{
02870: 10 E5 CE 13  22 1A 03 53  00 69 00 6C  00 69 00 63     '...."..S.i.l.i.c'
02880: 00 6F 00 6E  00 20 00 4C  00 61 00 42  00 53 00 4C     '.o.n. .L.a.B.S.L'
02890: 03 45 00 46  00 CD 00 38  00 55 00 42  00 33 00 20     '.E.F.M.8.U.B.3. '
028A0: 00 50 00 32  00 44 00 32  00 76 00 34  00 20 00 20     '.P.2.D.2.v.4. . '
028B0: 00 55 00 53  00 42 00 20  00 42 00 72  00 69 00 64     '.U.S.B. .B.r.i.d'
028C0: 00 67 00 65  00 20 00 55  80 42 00 33  00 5F 00 32     '.g.e. .U.B.3._.2'
028D0: 00 2E 00 35  00 2E 00 34  00 20 00 0A  03 30 00 30     '...5...4. ...0.0'
028E0: 00 30 00 35  00 FF FF FF  FF FF FF FF  FF FF FF FF     '.0.5............'

010028DBH   PUBLIC    CONST    ---       USB_SerialStr
0100288FH   PUBLIC    CONST    ---       USB_ProductStr
01002875H   PUBLIC    CONST    ---       USB_MfrStr
}
pri .UB3$	DUP 2+ SWAP UB3C@ 2- ADO I UB3C@ EMIT 2 +LOOP ;
pub .UB3
	$2800 BEGIN
	    BEGIN DUP UB3L@ $690053 <> WHILE 1+ REPEAT
	  DUP 4+ UB3L@ $69006C =
	UNTIL
	2 - DUP .UB3$ ." ; "
	DUP UB3C@ + DUP .UB3$ ." ;"
	DUP UB3C@ + .UB3$
	;


{ 17 bytes UUID$
pub GET.UUID			$FFC0 16 ADO I UB3C@ UUID$ I+ C! LOOP ;
pub .UUID			UUID$ PRINT$ ;
}
pub .UUID			$FFC0 16 ADO I UB3C@ .BYTE LOOP ;

pub ADC@ ( ch -- result )
	$30 UB3! ( 100 us UB3@ DROP ) 100 us UB3@
	;
pub mv@ ( ch --- mV )
	ADC@ 3300 * 13 >>
	;
pub .AVOLTS ( adc -- )	3300 * 13 >> .AS" #.###V" ;

pub .ADC$ ( n -- )	4* " P0.0P0.1P0.2P0.3P0.4P0.5P0.6P0.7P1.0P1.1P1.2--------------------TEMPLDO VDD GND ----------------P2.1------------ D+  D- VIN4 NC " + 4 CTYPE ;
pub .ADCS
	UB3KHZ
	32 0 DO
	  CRLF I 2 U.R SPACE I .ADC$  TAB  I ADC@ DUP .W
	  SPACE .AVOLTS
	LOOP
	;

--- fetch the temperature 	read, convert to mV, subtract
pub TEMP@ ( -- CC.cc )		16 mv@ 757 - 10000 285 */ ;
pub .TEMP			TEMP@ .AS" *|.##'C" ;

{
--- Tempc = ( Vtemp - offset ) / Slope
pub TEMP@ ( -- cc.cc )
---	temp cmd   wait
	$10 $30 UB3! 100 us UB3@ DROP
	UB3@ DUP $FFFF <>
---	     scale result  -offset /2.85mV scaled  /4096
	  IF 1000 *   757 -   1000 285 */      12 >>
	  ELSE DROP 0
	  THEN
	;
}


{
SLOPE = 2.85mV/'C
OFFSET = 757mV

Vtemp = (Slope * Tempc ) + offset
Tempc = ( Vtemp - offset ) / Slope

Tempc = 2156
Tempc = 6.14460 / 2.85
$FFC0
0195F: 82 C4 CF 08  27 DE E8 11  8C 53 42 B1  A5 1F 80 DA     '....'....SB.....'
0196F: FF FF FF FF  FF FF FF FF  FF FF FF FF  FF FF FF FF     '................'
0197F: 55 AA 19 58  10 FF FF FF  FF FF FF FF  FF FF FF FF     'U..X............'
0198F: FF FF FF FF  FF FF FF FF  FF FF FF FF  FF FF FF XX     '................' ok
}


{
<I2C> $36 I2C! $F5 I2C! $E5 I2C! $FA I2C! $C3 I2C! I2C>

 x8 accum readings are  0x815/4096 = 0.505126953125
; ((0.757+2.85m*25)/1.65) = 0.50196 seems plausible ?
; tho drawing has default gain 0.5 and temp is shown before that ? - maybe Temp selects Gain = 1 ?

you could see if it seems to follow that   0.757+2.85mV/'C prediction ?

}



	*** DECOMPILER ***

pub *DECOMPILER*	PRINT" A decompiler for TAQOZ 190825-0000" ;

pri dflg	HERE: 0 [

private
20 bytes ifs
byte ex		--- exit flag
byte ind
word wcode		--- current wordcode

long wnfa		--- NFA of current decomps
long wptr
long wsrc


pri dflg?	 1 dflg SET? ;
pri eflg?	 2 dflg SET? ;

pri @SEE++	2
pri @SEE+	wptr +! ;
pri @SEE	wptr @ ;
2 longs xcfa
pri SEE@	@SEE W@ xcfa @ + ;

--- create a temporary dummy def so that we can find the CFAs for unnamed words
: T BEGIN $1234 $12345678 UNTIL uemit $0FF " STRING" ;
AT T 16 + W@		--- address and read " string literals
AT T 14 + W@		--- 10-bit literal
AT T 12 + W@		--- register offset
AT T 10 + W@		--- address and read UNTIL
AT T 4 + W@		--- address and read a LONG literal
AT T W@			--- address and read a WORD literal
FORGET T		--- discard temp def and now use parameters for constants
:= (W)			--- 16-bit WORD
:= (L)			--- 32-bit LONG
8>> := (IF)		--- IF or UNTIL branch
8>> := (R)		--- 8-bit register offset
10 >> := (S)		--- 10-bit literal
:= (")

--- find .AS" runtime cfa
: T .AS" ##" ;
( AT T 2+ W@ ) AT T W@
FORGET T
\ := (EXIT)
:= (AS)

--- find ." runtime cfa using temp def
: T ." HELLO WORLD! " ;
AT T W@
FORGET T
:= (.")

--- find cfa for a long constant
AT SDBUF W@ := (LC)
(LC) 1-	:= (DS)

pri 'EMIT	''' EMIT ;
pri $		'$' EMIT ;
pri .D		SPACE '(' EMIT DUP . ')' EMIT
\ pri .ASC	SPACE DUP $20 $7E WITHIN IF 'EMIT EMIT 'EMIT ELSE DROP THEN ;
pri .ASC	SPACE $20 MAX $7F MIN EMIT ;
pri .M:		CRLF .M ." : " ;

pri .STR	'"' EMIT SPACE @SEE++ @SEE PRINT$ '"' EMIT @SEE LEN$ 1+ 2 ALIGN @SEE+ ;
pri INDENT	ind C@ 0 MAX SPACES ;
pri +ind	2 ind C+! ;
pri -ind	ind C@ IF -2 ind C+! THEN ;

--- print value of 10-bit encoded literal
pri .W10	SEE@ $3FF AND
pri .LIT	dflg? IF DUP 11 > IF DUP . 3 SPACES DUP DUP 16 >> IF .L ELSE .W THEN .ASC  ELSE .  THEN ELSE . THEN ;

--- add an IF branch to address so that indentation and a THEN can be added
--- and the address to the ifs array
pri +if ( addr -- )
	2 dflg SET? IF DUP ."  (+" .W ." ) " THEN
	ifs ifs 2+ 18 <CMOVE ifs W!
\	4 dflg SET? IF ifs 10 DUMPW THEN
	;

pri -if ( addr -- )
	2 dflg SET? IF DUP ."  (-" .W ." ) " THEN
	ifs 20 ADO DUP I W@ = IF 0 I W! LEAVE THEN 2 +LOOP DROP
\	4 dflg SET? IF ifs 10 DUMPW THEN
	;

pri if? ( addr -- flg )
---	find matching address and clear with flag else loop and exit false
	ifs 20 ADO DUP I W@ = IF ( 0 I W! ) UNLOOP EXIT THEN 2 +LOOP DROP 0
	;


--- forward address referenced?
pri fad? ( addr -- flg )
	0 ifs 20 ADO OVER I W@ <= OR 2 +LOOP NIP
	;

pri ?CRLF	dflg? 0= IF CRLF INDENT THEN ;

pri .LCON	PRINT" := " @SEE 2+ @ .LIT 6 @SEE+ ;

pri ?GOTO
	8 dflg CLR
---	jump bit set? (only valid for a threaded call adddress, not asm or encoded)
	SEE@ 1& SEE@ AT SPACE => AND
	IF
---	check if this might be jump because it is an ELSE
	  @SEE 2+ if? ( ptr cfa flg ) @SEE SEE@ U< AND
	  IF @SEE 2+ -if PRINT" ELSE " SEE@ 1 ANDN +if
	  ELSE

	  ( ptr cfa ) SEE@ @SEE > @SEE SEE@ > AND
	    IF PRINT" REPEAT " ELSE ( PRINT" GOTO" ) 8 dflg SET THEN
	  THEN
	  dflg? IF SEE@ 1 ANDN DUP CFA>NFA 0= IF .W SPACE ELSE DROP THEN  ( ptr cfa ) THEN
---	set ex termination flag if not a forward reference AND not nested
	  @SEE fad? NOT ind C@ 6 < AND IF ex C++ THEN
	THEN
	;

pri CASE?			CASE@ = OR ;

pri ?DOS
	0  AT FOR CASE?  AT DO CASE?   AT ADO CASE?   IF +ind THEN
	;
pri ?LOOPS
	0   AT NEXT CASE?   AT ?NEXT CASE?   AT LOOP CASE?   AT +LOOP CASE?   IF -ind THEN
	;

pri .SEE ( cfa -- )
\	xcfa @ + xcfa ~
	SWITCH
	?LOOPS
	dflg? IF CASE@ .WORD SPACE INDENT ELSE SPACE THEN
	?GOTO ?DOS
---	Check for paging call
	PAGE0 DUP 7 - SWAP <CASE> PAGE0 CASE@ - DUP 16<< xcfa 4+ ! PRINT" PAGE" . @SEE++  BREAK

	(.") CASE	PRINT" PRINT" .STR BREAK
	(") CASE	.STR BREAK
	(AS) CASE	PRINT" AS" .STR BREAK
	(W) CASE	@SEE++ CASE@ .LIT @SEE++ BREAK
	(L) CASE	.LCON BREAK
	(DS) CASE	.LCON ex C++ BREAK
	(LC) CASE	.LCON ex C++ BREAK
---	10-bit coded literal?
	CASE@ 10 >> (S) = IF .W10 @SEE++ BREAK

	AT CASE 6 - CASE	." CASE=" @SEE++ BREAK

	AT EXIT CASE	DUP fad? NOT IF PRINT" ;" ex C++ ELSE PRINT" EXIT" THEN @SEE++ BREAK

---	Decoded wordcodes $F800->$FFFF
        CASE@ 8>> SWITCH
	$FD CASE	PRINT" ELSE" SEE@ $80 AND IF ." -" ELSE ." +" THEN SEE@ $7F AND .  @SEE++ BREAK
	(R) CASE	PRINT" REG " SEE@ .B @SEE++ BREAK
---	conditional?     forward IF or back UNTIL ?
	(IF) CASE	?CRLF SEE@ $80 AND 0=
	    IF
	      PRINT" IF" +ind
---	      next   find branch address and remember
	      @SEE 2+ SEE@ >B 2* + DUP +if
	    ELSE
	      PRINT" UNTIL"
	      @SEE 2+ SEE@ $7F AND 2* -
	    THEN
	 ( branch )
	  dflg? IF SPACE .W ELSE DROP THEN @SEE++
	  BREAK

---	default for anything other threaded code
	SEE@ DUP $7FF > IF 1 ANDN THEN CFA>NFA ?DUP IF .NFA THEN
	8 dflg SET? IF ."  ; " THEN
	@SEE++
;


pri ?THENS
---	  display  non-code THEN(s) for matching IF(s) using the ifs table
	BEGIN @SEE if?
	WHILE dflg?
	  IF CRLF 10 SPACES -ind INDENT ELSE -ind THEN
	  PRINT"  THEN" ?CRLF
	  @SEE -if
	REPEAT
	;

pri .NAME ( nfa -- )
	CRLF DUP .M:
	DUP C@ $40 AND IF PRINT" pri " THEN
	DUP C@ $80 AND IF PRINT" pre " THEN
	DUP C@ 5 >> 0= IF PRINT" pub " THEN
	.NFA ?CRLF
	;
pri ?NAME --- check if this address matches a dictionary entry
	@SEE CFA>NFA ?DUP IF .NAME THEN
	;


pub SEECFA ( cfaptr --  )
	xcfa ~
	DUP wsrc ! wptr !			--- save ptr - use @SEE to read pointer
	ifs 24 ERASE		--- clear all variables
	4 ind C!
	@SEE AT SPACE U< IF ."  *CODE* " DROP BREAK
	BEGIN
	  @SEE 1 ANDN wptr !
--- report name of any IPs that match
	  ?NAME
	  ex C~
	  ?THENS
---	  Print address
	  dflg? IF @SEE .M: THEN
	  SEE@ .SEE xcfa 4+ @ xcfa ! xcfa 4+ ~
---	  terminate if flagged or a key pressed
	  ex C@ KEY OR
---	  but not if it still has a forward reference to resolve
	  @SEE fad? NOT AND
---	  but always if we are now reading nulls
	  SEE@ 0= OR
---	 terminate if that was an EXIT and no further nesting
	  @SEE 2- W@ AT EXIT = ind C@ 5 < AND OR
	UNTIL
	CRLF 6 SPACES @SEE wsrc @ - . ."  bytes "
	;


pre SEE
	[C] NFA' [G]  1 dflg SET
pub SEENFA ( nfa -- )
	?DUP
	IF
	  DUP wnfa !
\	  DUP .NAME ?CRLF
	  CFA SEECFA
	  CRLF
	ELSE PRINT"  not found "
	THEN
	;

pre DECOMP
	[C] NFA' [G] 1 dflg CLR SEENFA
	;

\ : SEEALL  @WORDS BEGIN DUP C@ WHILE DUP SEES CPA 2+ REPEAT DROP ;






pub STRIPIT ( nameptr -- nameptr+ )
	SPACE DUP C@++ $1F AND CTYPE			--- Ok, strip it out
	DUP DUP C@ $1F AND 3 + ( 1 ANDN ) ( nameptr cnt )
	DUP >L @WORDS +
	@WORDS ROT SWAP - ( newnames len )
	@WORDS ROT ROT <CMOVE
	L> DUP names W+! +   	 			--- add to names pointer and to current pointer for next word
 	;

--- Strip a single header from the dictionary
pre STRIP ( <name> -- )			[C] NFA' [G] STRIPIT DROP ;

--- RECLAIM memory by striping private headers from the dictionary
--- RECLAIM <opt>
pre RECLAIM ( <to> -- )
	delim 1+ C@ $20 = IF [C] NFA' [G] ELSE $10.0000 THEN ( to )
	4 REG W~
	CRLF CRLF '{' EMIT
	@WORDS DUP >L
	BEGIN
	( to words )
	  2DUP >
	  OVER W@ AND
	WHILE

	  --- Test to see if ATR is private
  	  DUPC@ $40 AND
  	     --- strip header or proceed to next
  	    IF 4 REG W@ 10 // 0= IF CRLF THEN STRIPIT 4 REG W++ ELSE NFA+ THEN
	REPEAT
	--- Report results
	DROP CRLF ." Reclaimed " @WORDS L> DUP >L  - DUP .DECL PRINT"  bytes"
	--- Clear the reclaimed area (not needed really )
	L> SWAP ?DUP IF ERASE ELSE DROP THEN
\	CRLF [C] WORDS
	CRLF '}' EMIT DROP
	;





	*** SERIAL RAM ***

pub *SPIRAM*		PRINT" LY68L6400 8MB SPI RAM ACCESS 191020-0000" ;
{
LY68L6400 8MB SPI RAM

$03	READ
$0B	FAST READ
$02	WRITE
$66	RESET ENABLE
$99	RESET
$C0	SET BURST LENGTH
$9F	READ ID

}


ALIAS SFC@ SRC@
ALIAS SFW@ SRW@
ALIAS SF@ SR@
ALIAS SF SR

pub SRRD				3 SFCMD SPIWM ;
pub !SR					$66 SFCMD SPICE $99 SFCMD SPICE ;
pub SRWRP ( src dst -- )		2 SFCMD SPIWM 512 SPITX SPICE ;
pub SRWRS ( hub srdst bytes -- )	ROT SWAP ADO I OVER SRWRP 512 + 512 +LOOP DROP ;
pub SRC!				2 SFCMD SPIWM SPIWB SPICE ;
pub SRW!				2 SFCMD SPIWM DUP SPIWB 8>> SPIWB SPICE ;
pub SR!					2 SFCMD SPIWM 4 FOR DUP SPIWB 8>> NEXT DROP SPICE ;
pub SRID				$9F SFCMD 0 SPIWM 0 SPIRL 0 SPIRL ;
pub .SR					SRID SWAP .L SPACE .L ;


0	:= srinc
pub SRRDS ( srsrc hubdst bytes -- )
	BEGIN
	  3RD SRRD 	\ $0B SFCMD SPIWM 0 SPIRD DROP
	  DUP 1024 MIN AT srinc 2+ !
	  OVER srinc SPIRX SPICE
	  ROT srinc + ROT srinc + ROT srinc -
	  DUP 0=
	UNTIL 3DROP
	;


{
--- routine to cache 8MB of a file into SPI RAM
pub FCACHE				@FILE 0 $80.0000 9 >> FOR OVER SECTOR OVER SRWRP b++ 512 + NEXT 2DROP ;
}

{
SFJID	$EF40_1400	EF WINBOND 40 TYPE  14 W25Q80
#EF
SRID	$0D5D_46A0 $2A46_5C34		0D LYONTEK 5D KGD=PASS




}



{
1,000,000 := cntmax
pri pnext	 3 >> DUP cntmax < IF . ELSE ."  X " DROP THEN ;
pri LAPCNT	CNT@ - ABS ;
pri CNT?	DUP LAPCNT cntmax > ;
{ MEASURE PIN CAPACITANCE AS A FLOAT TO HIGH TIME }
: ?PIN ( pin --  )
	CRLF ." P" DUP . 9 EMIT
	PIN
	0 8 FOR L 100 us F CNT@ BEGIN CNT? R OR UNTIL LAPCNT + NEXT pnext
	9 EMIT
	0 8 FOR H 100 us F CNT@ BEGIN CNT? R 0= OR UNTIL LAPCNT + NEXT pnext
	;
: ?PINS ( from for -- ) ADO I ?PIN LOOP ;

}

pri pnext	 3 >> DUP 100,000,000 < IF 10 U.R ELSE 9 SPACES ." X" THEN ;
pri CNT?	DUP CNT@ - ABS 100,000,000 > ;
{ MEASURE PIN CAPACITANCE AS A FLOAT TO HIGH TIME }
: ?PIN ( pin --  )
	CRLF ." P" DUP . 9 EMIT
	PIN
	0 8 FOR L 100 us F CNT@ BEGIN CNT? R OR UNTIL CNT@ - ABS + NEXT pnext

	0 8 FOR H 100 us F CNT@ BEGIN CNT? R 0= OR UNTIL CNT@ - ABS + NEXT pnext
	;
: ?PINS ( from for -- ) ADO I ?PIN LOOP ;


pri CRLF+		CRLF 2 SPACES ;


pub .MODULES
	HERE @WORDS
	BEGIN
	  DUP W@
	WHILE
	  DUP MOD?
	  IF CRLF+
	    SWAP OVER CFA - 5 U.R DUP CFA SWAP SPACE
	    DUP .NFA
	    CR TAB TAB TAB DUP CFA EXECUTE
	  THEN
	  NFA+
	REPEAT
	2DROP
	;


pub .ASBYTES		.DECL ."  bytes" ;


\ pub lsi2c	128 FOR I 2* I2CRD? IF I 2* .B SPACE THEN NEXT I2C> ;
pri .I2C ( dev -- )
	AT i2cdev C!
	i2cdev I2CRD? 0EXIT
	CRLF i2cdev 2 SPACES .B
	i2cdev SWITCH 2 TABS
	$A4 CASE PRINT" RV-3028 RTC" BREAK
	$A0 CASE PRINT" EEPROM" BREAK
	$36 CASE PRINT" P2D2 UB3 USB+SUPPORT  UUID:" .UUID BREAK
	CASE@ $C0 $DE WITHIN IF PRINT" Si5351A CLOCK GEN" BREAK
	CASE@ $30 $3E WITHIN IF PRINT" MCP9808 TEMPERATURE SENSOR" BREAK

\	$C4 CASE PRINT" Si5351A-B0448 CLOCK GEN" BREAK
	CASE@ $40 $4E WITHIN IF PRINT" I/O EXPLANDER" BREAK
	PRINT" UNKNOWN DEVICE"
	;
pub lsi2c	PRINT" I2C DEVICES"	400 I2C.KHZ $80 FOR I 2* .I2C NEXT ;

pub SFBYTES	SFJID 8>> >B |< ;
pri .UBYTES	SWAP .ADRX 2 SPACES .ASBYTES ;
pub .USAGE
	CRLF PRINT" MEMORY MAP"
	CRLF+ PRINT" CODE:" 		2 TABS HERE HERE .UBYTES
	CRLF+ PRINT" WORDS:" 		2 TABS @WORDS " END" SEARCH 6 +  @WORDS - .UBYTES
	CRLF+ PRINT" DATA:" 		2 TABS org@   org@ AT orglen 6 - CALL @ - .UBYTES
	HERE 16>> 0=
	IF
	  CRLF+ PRINT" ROOM:" 		2 TABS @WORDS HERE - 7 SPACES .ASBYTES
	THEN
	;
pub ?DEVICES	NOP NOP NOP NOP NOP NOP NOP NOP ;
pub +DEVICE
	' ?DEVICES BEGIN
	  2DUP W@ = IF 2DROP EXIT THEN
 	  DUP W@ ' NOP = IF W! EXIT THEN
	  2+
	  AGAIN
	  ;

pub .DEVICES
	CRLF PRINT" DEVICES"
	?DEVICES
---	SPI FLASH
	SFJID 16 >> $FFFF <> IF CRLF+ PRINT" SPI FLASH" 	2 TABS SFBYTES .MEM SPACE
	SFJID 24 >> $EF = IF PRINT" WINBOND" ELSE ." UNKNOWN" THEN  SPACE SFJID .L SPACE SFSID '#' EMIT D. THEN
---	SPI RAM
	SRID DROP 24 >> $0D = IF CRLF+ PRINT" SPI RAM"		2 TABS SRID SWAP .L SPACE .L THEN

---	UB3 USB
	UB3? IF CRLF+ PRINT" USB " 2 TABS .UB3 THEN
---	I2C
	5 ms CRLF lsi2c
	;
pub SYSINFO
	CRLF PRINT" KERNEL" 		2 TABS .VER
	PRINT" MODULES:" 		2 TABS .MODULES
	.USAGE
	CRLF PRINT" HARDWARE"
	CRLF+ PRINT" PCB"		2 TABS 4 8 CTYPE $A4 I2CRD? IF PRINT" (P2D2)" THEN
	CRLF+ PRINT" CLOCK IN"		2 TABS _xin @ 2 .DP PRINT" MHZ"
	.DEVICES
	CRLF
	RTC? IF  TAB TAB <I2C> .FDT THEN
	UB3? IF  3 SPACES .TEMP 3 SPACES ." Vdd=" 10 ADC@ .AVOLTS THEN
	CRLF
	;

ALIAS SYSINFO ??

	*** SHORTCUTS ***

pri ~Y		[C] wORDS CRLF PROMPT ; 	AT ~Y ^Y CTRL!
pri ~?		.USAGE CRLF PROMPT ;	AT ~? ^? CTRL!
pri ~W		W CRLF PROMPT ; 	AT ~W ^W CTRL!
pri ~D		DEBUG CRLF PROMPT ;	AT ~D ^D CTRL!

--- capture rx buffers into $70000 stacked, then erase buffers
pri ~E		$70000 $70300 $0C00 <CMOVE $7F500 $70000 $300 CMOVE $7F500 $300 ERASE ."  SAVED " ; AT ~E ^E CTRL!



--- perform SYSINFO one second after powerup (allows for USB connection etc)
pub MAIN	FORTH 1000 ms KEY 1 <> 0EXIT DISCARD   SYSINFO ;

AUTO MAIN
\ RECLAIM

END
