CON
_clkfreq    = 200_000_000
_xinfreq    = 20_000_000
XIN			= _xinfreq
xmode		= 3			' 2 for xtal, 3 for osc'
CPUHZ		= _clkfreq   '200_000_000		' desired CPU clock frequency'
baud_rate   = 921600		' console baud rate - timing value calculated at startup'
morestops	= 2			' extra stop bits for USB or terminal esp. at higher baud rates
bootms      = 1000

include(`P2.inc')
include(`memmap.inc')

{ I/O PINS
P63	RXD
P62	TXD
P61	SFCS SDCK
P60	SFCK SDCS
P59	SFDI SDDI
P58	SFDO SDDO
P57	SDA
P56	SCL
-
P55
P54	PS2CLK
P53	PS2DAT
P52	VS
P51	RED
P50	GRN
P49	BLU
P48	HS
-
P47
P46
P45
P44
P43
P42
P41
P40
-
P39
P38
P37
P36
P35
P34
P33
P32

_VGACFG		long	$03020100	''$33323130		' VGA RGBH pins on P48..P52
		long	$04	''$34			' VSYNCH'
_VGAINIT	long	@vgainit		' VGA code '
_VGASET		long	round(fset)
_KBCFG		long	$3635			' PS/2 CLK,DAT' 54,53



}

'************* VGA & KEYBOARD ************* '

vgacog		= 7				' vga runs in this cog '

DAT	' STAGE 1 - BOOT TIME INITIALIZATION '

		orgh	0
		org
		jmp	#initsys

include(`configs.inc')
include(`init.inc')
include(`trace.p2a')
include(`taqoz.inc')		' defs for TAQOZ '
include(`version.p2a')		' version header '
include(`variables.p2a')	' defs for TAQOZ variables '
include(`kernel.p2a')		' TAQOZ COG CODE'
include(`vga-multi.p2a')	' VGA COG CODE'

include(`hubexec.p2a')		'HUBEXEC CODE AFTER WORDCODE '
include(`i2c.p2a')
include(`serial.p2a')

include(`threads.twc')
include(`flash.twc')
	' sdcard
codeorg

include(`dictionary.twc')
include(`license.txt')
